#!/usr/bin/python
from cal import *

def test_hijri_with_idate(self):
  jd_today = int(gregorian_to_jd(*time.localtime()[:3]))
  for jd in xrange(jd_today-400, jd_today+10):
    greg   = jd_to_gregorian(jd)
    hijri  = jd_to_hijri(jd)
    hijri2 = jd_to_hijri_idate(jd)
    if hijri != hijri2:
      print greg, hijri, hijri2

def test_jalali_with_farsiweb(self):
  from utility_disable import jalali_to_milady
  jd_start = int(to_jd(1305, 1, 1, DATE_JALALI))
  jd_end   = int(to_jd(1500,12,29, DATE_JALALI))
  for j in xrange(jd_start, jd_end+1):
    jd = j + 0.5
    try:
      jdate1 = jd_to_jalali(jd)
      gdate  = jd_to_gregorian(jd) ### int+0.5
      jd2 = jalali_to_jd(*jdate1)
      if jd!=jd2:		### OK
        print jd, jd2
        sys.exit(1)
      jdate2 = convert(gdate[0], gdate[1], gdate[2], DATE_GREG, DATE_JALALI)
      if jdate1 != jdate2:	### OK
        print 'jdate1 =', jdate1, '\tjdate2 =', jdate2
        sys.exit(1)
      gdate2   = convert(jdate2[0], jdate2[1], jdate2[2], DATE_JALALI, DATE_GREG)
      if gdate != gdate2:	### OK
        print 'gdate =', gdate, '\tgdate2 =', gdate2
        sys.exit(1)
      #### Testing with farsiweb algorithm
      out = os.popen("/data/Data-New/Programming/Calendar-work/StarCalendar/jalali %s %s %s"%gdate).read().split('/')
      jdate3 = (int(out[0]), int(out[1]), int(out[2]))
      if jdate1 != jdate3:### Breaks in 2025/3/20:	jdate1 = (1404, 1, 1) 	jdate3 = (1403, 12, 30)
        print 'gdate =', gdate, '\tjdate1 =', jdate1, '\tjdate3 =', jdate3
        sys.exit(1)
    except KeyboardInterrupt:
      print 'Stoped!'
      try:
        raw_input()
      except KeyboardInterrupt:
        sys.exit(0)



if __name__=='__main__':
  import sys, os
  c = Calverter()
  arg = sys.argv
  """
  #c.test_hijri_with_idate()
  c.test_jalali_with_farsiweb()
  print 'Test was succesfull'
  #sp = arg[1].split('/')
  #print c.gregorian_to_jd(int(sp[0]), int(sp[1]), int(sp[2]))
  sys.exit(0)
  
  print hijriDbInitDates
  print
  for i in (0,1,2):
    (y,m,d) = hijriDbInitDates[i]
    jd = c.to_jd(y, m, d, i)
    print jd, c.jd_to_hijri(jd)
  print
  for i in (0, 1, 2):
    print c.jd_to(hijriDbInitJD, i)
  
  jdi = hijriDbInitJD
  for jd in xrange(jdi, jdi+1000):
    date1 = c.jd_to_hijri(jd)
    date2 = c.jd_to_hijri(jd)
    if date1!=date2:
      print date1, date2
  """
  if len(arg)<3:
    sys.exit(0)
  if arg[1]=='-j':
    mode=DATE_JALALI
  elif arg[1]=='-g':
    mode=DATE_GREG
  elif arg[1] in ('-h', '-i'):
    mode=DATE_HIJRI
  elif arg[1]=='-jd':
    mode=DATE_JD
  else:
    sys.exit(1)
  if mode==DATE_JD:
    jd = int(arg[2])
  else:
    sp = arg[2].split('/')
    y = int(sp[0])
    m = int(sp[1])
    d = int(sp[2])
    jd = c.to_jd(y, m, d, mode)
  print 'Julian Day: %s'%jd
  print 'Gregorian:  '+('%2d/%2d/%2d'%c.jd_to(jd, DATE_GREG)).replace(' ', '0')
  print 'Jalali:     '+('%2d/%2d/%2d'%c.jd_to(jd, DATE_JALALI)).replace(' ', '0')
  print 'Hijri:      '+('%2d/%2d/%2d'%c.jd_to(jd, DATE_HIJRI)).replace(' ', '0')
      
  
