#!/usr/bin/python
#J0000 = 1721424.5                # Julian date of Gregorian epoch: 0000-01-01
#J1970 = 2440587.5                # Julian date at Unix epoch: 1970-01-01
#JMJD  = 2400000.5                # Epoch of Modified Julian Date system
#J1900 = 2415020.5                # Epoch (day 1) of Excel 1900 date system (PC)
#J1904 = 2416480.5                # Epoch (day 0) of Excel 1904 date system (Mac)

## weekday_before: Return Julian date of given weekday (0 = Sunday) in the seven days ending on jd
weekday_before = lambda weekday, jd: jd - jwday(jd - weekday)



#search_weekday: Determine the Julian date for: 
#                       weekday      Day of week desired, 0 = Sunday
#                       jd           Julian date to begin search
#                       direction    1 = next weekday, -1 = last weekday
#                       offset       Offset from jd to begin search"""
search_weekday = lambda weekday, jd, direction, offset: weekday_before(weekday, jd + (direction * offset))


##  Utility weekday functions, just wrappers for search_weekday
#nearest_weekday = lambda weekday, jd: search_weekday(weekday, jd, 1, 3)
#next_weekday = lambda weekday, jd: search_weekday(weekday, jd, 1, 7)
#next_or_current_weekday = lambda weekday, jd: search_weekday(weekday, jd, 1, 6)
#previous_weekday = lambda weekday, jd: search_weekday(weekday, jd, -1, 1)
#previous_or_current_weekday = lambda weekday, jd: search_weekday(weekday, jd, 1, 0)



def n_weeks(weekday, jd, nthweek):
  if nthweek > 0 :
    return 7 * nthweek + search_weekday(weekday, jd, -1, 1)
  else:
    return 7 * nthweek + search_weekday(weekday, jd, 1, 7)

def pad(st, howlong, padwith) :
  "PAD: Pad a string to a given length with a given fill character. "
  s = str(st)
  while s.length < howlong :
      s = padwith + s
  return s

