#!/usr/bin/env python
##
##   Copyright (C) 2007 Mehdi Bayazee <Bayazee@Gmail.com>
##   Copyright (C) 2009-2010 Saeed Rasooli <saeed.gnu@gmail.com> (ilius)
##
##
##   This program is free software; you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation; either version 3 of the License,  or
##   (at your option) any later version.
##
##   This program is distributed in the hope that it will be useful, 
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License along
##   with this program. If not, see <http://www.gnu.org/licenses/gpl.txt>.

name = 'gregorian'
desc = 'Gregorian'

monthName = ('January','February','March','April','May','June','July','August','September','October','November','December')

getMonthName = lambda m, y: monthName.__getitem__(m-1)
getMonthsInYear = lambda y: 12

from math import floor
ifloor = lambda x: int(floor(x))

epoch = 1721426
minMonthLen = 29
maxMonthLen = 31

options = ()

def save():
  pass

is_leap = lambda year: ((year % 4) == 0) and (not(((year % 100) == 0) and ((year % 400) != 0)))

def to_jd(year, month, day):
  # Python <= 2.5
  if month <= 2 :
    tm = 0
  elif is_leap(year):
    tm = -1
  else:
    tm = -2
  # Python 2.5
  #tm = 0 if month <= 2 else (-1 if is_leap(year) else -2)
  return ifloor( epoch - 1 + 365*(year-1) + floor((year-1)/4) - floor((year-1)/100) + \
    floor((year-1)/400) + floor((367*month-362)/12 + tm + day))


def jd_to(jd) :
  assert type(jd)==int
  ##wjd = floor(jd - 0.5) + 0.5
  (quadricent, dqc) = divmod(jd - epoch, 146097)
  (cent, dcent) = divmod(dqc, 36524)
  (quad, dquad) = divmod(dcent, 1461)
  yindex = divmod(dquad, 365)[0]
  year = ifloor((quadricent * 400) + (cent * 100) + (quad * 4) + yindex) + (cent!=4 and yindex!=4)
  yearday = jd - to_jd(year, 1, 1)
  # Python <= 2.5 :
  if jd < to_jd(year, 3, 1):
    leapadj = 0
  elif is_leap(year):
    leapadj = 1
  else:
    leapadj = 2
  # Python 2.5
  #leapadj = 0 if jd < to_jd(year, 3, 1) else (1 if is_leap(year) else 2)
  month = int(floor((((yearday + leapadj) * 12) + 373) / 367))
  day = int(jd - to_jd(year, month, 1)) + 1
  return (year, month, day)

def getMonthLen(y, m):
  if m==12:
    return to_jd(y+1, 1, 1) - to_jd(y, 12, 1)
  else:
    return to_jd(y, m+1, 1) - to_jd(y, m, 1)

