#!/usr/bin/python
## ISO_TO_JULIAN: Return Julian day of given ISO year, week, and day
iso_to_julian = lambda year, week, day: day + n_weeks(0, gregorian_to_jd(year-1, 12, 28), week)

## JD_TO_ISO: Return array of ISO (year, week, day) for Julian day
def jd_to_iso(jd):
  year = jd_to_gregorian(jd - 3)[0] + (jd >= iso_to_julian(year + 1, 1, 1))
  week = int(floor((jd - iso_to_julian(year, 1, 1)) / 7)) + 1
  day = jwday(jd)
  if day == 0 :
    day = 7
  return (year, week, day)

## ISO_DAY_TO_JULIAN: Return Julian day of given ISO year, and day of year
iso_day_to_julian = lambda year, day: (day - 1) + gregorian_to_jd(year, 1, 1)

## JD_TO_ISO_DAY: Return array of ISO (year, day_of_year) for Julian day
def jd_to_iso_day(jd):
  year = jd_to_gregorian(jd)[0]
  day = int(floor(jd - gregorian_to_jd(year, 1, 1))) + 1
  return (year, day)
