#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#    Copyright (C) 2009 Saeed Rasooli <saeed.gnu@gmail.com> (ilius)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program. If not, see <http://www.gnu.org/licenses/gpl.txt>.
#    Or on Debian systems, from /usr/share/common-licenses/GPL


import sys
#sys.path.append('/usr/lib/gdesklets/utils/')
#import GlassWindow

import os, os.path, time, pango, cairo

import gobject
from gobject import timeout_add

import cal
from cal import getMonthLen, convert
primaryMode=0

from paths import *

comDesk='%s/.config/autostart/starcal.desktop'%homeDir
#kdeDesk='%s/.kde/Autostart/starcal.desktop'%homeDir


pyVersion = sys.version_info[:2]
if pyVersion==(2, 6):
  sys.path.append('%s/lib/python2.6'%rootDir)
elif pyVersion==(2, 5):
  sys.path.append('%s/lib/python2.5'%rootDir)
elif pyVersion==(2, 4):
  sys.path.append('%s/lib/python2.4'%rootDir)

def myRaise(File=None):
  i = sys.exc_info()
  if File==None:
    sys.stderr.write('line %s: %s: %s\n'%(i[2].tb_lineno, i[0].__name__, i[1]))
  else:
    sys.stderr.write('File "%s", line %s: %s: %s\n'%(File, i[2].tb_lineno, i[0].__name__, i[1]))


#dateOrigLang = {DATE_GREG:1, DATE_JALALI:2, DATE_HIJRI:3}
lang = 0

#dateOrigLang={DATE_GREG:'en', DATE_JALALI:'fa', DATE_HIJRI:'ar'}
#lang = ''
#exec('%s/lang'%srcDir)
#langItem = default
#del default

prefPath = os.path.join(confDir, 'pref')
if os.path.exists(confDir):
  if os.path.isfile(confDir): ## For Compatibility with old versions
    os.rename(confDir, confDir+'-old')
    os.mkdir(confDir)
    os.rename(confDir+'-old', prefPath)
else:
  os.mkdir(confDir)
if os.path.isfile(prefPath):
  try:
    prefText = file(prefPath).read()
  except:
    myRaise(__file__)
    prefText=''
else:
  print 'Warning: configuration file "%s" not exists'%prefPath
  prefText=''

for line in prefText.split('\n'):
  if line.startswith('lang'):
    exec(line)
    break

sysRtl = (os.popen('locale cal_direction').read()=='3\n')

langList=(
('System Setting',None,None,'computer.png',sysRtl)##query that is RTL or no????????????????
,('English','en_US.UTF-8','en','flag-us.png',False)
,('فارسی','fa_IR.UTF-8' ,'fa','flag-ir.png',True)
#,('العربية','ar_IQ.UTF-8','ar','flag-iq.png',True)
,('العربية','ar_IQ.UTF-8','ar','ar.png',True)
#,('العربية','ar_LB.UTF-8','ar','flag-lb.png',True)
)
##/usr/share/locale/l10n/us/flag.png
##/usr/share/locale/l10n/ir/flag.png
##/usr/share/locale/l10n/iq/flag.png



if lang>0:
  os.environ['LANG']=langList[lang][1]#'fa_IR.UTF-8'
import pygtk
pygtk.require('2.0')
import gtk#, mywidgets
from gtk import gdk
print 'PyGTK %s.%s.%s'%gtk.pygtk_version

gtk.init_check()




rootWindow = gdk.get_default_root_window()
##import atexit
##atexit.register(rootWindow.set_cursor, gdk.Cursor(gdk.LEFT_PTR)) ## ?????????????????????
#rootWindow.set_cursor(cursor=gdk.Cursor(gdk.WATCH)) ## ???????????????????
while gtk.events_pending():
  gtk.main_iteration_do(False)


import gettext
if lang==2:
    try:
      translator = gettext.GNUTranslations(
        open('%s%s%s%s%s'%(rootDir,os.sep,'locale',os.sep,'fa.mo'), 'rb')).gettext
    except:
      try:
        translator = gettext.GNUTranslations(
          open('/usr/share/locale/fa/LC_MESSAGES/starcal.mo', 'rb')).gettext
      except:
        myRaise(__file__)
        translator = gettext.gettext
elif lang==3:
    try:
      translator = gettext.GNUTranslations(
        open('%s%s%s%s%s'%(rootDir,os.sep,'locale',os.sep,'ar.mo'), 'rb')).gettext
    except:
      try:
        translator = gettext.GNUTranslations(
          open('/usr/share/locale/ar/LC_MESSAGES/starcal.mo', 'rb')).gettext
      except:
        myRaise(__file__)
        translator = gettext.gettext
else:
  translator = gettext.gettext
_ = translator


autoLocal=False


def validDate(y, m, d, mode=None):## move to cal-modules
  if mode==None:
    mode=primaryMode
  if y<0:
    return False
  if m<1 or m>12:
    return False
  if d > cal.getMonthLen(y, m, mode):
    return False
  return True

def show_event(widget, event):
  print type(widget), event.type.value_name, event.get_time()#, event.send_event

gdkColorToStr = lambda color: 'gdk.Color(%d, %d, %d)'%(color.red, color.green, color.blue)

rgbToHtml = lambda r, g, b: '#%.2x%.2x%.2x'%(r/256, g/256, b/256)

gdkColorToHtml = lambda color: '#%.2x%.2x%.2x'%(color.red/256, color.green/256, color.blue/256)

"""def gdkColorInvert(color):
  r = color.red
  g = color.green
  b = color.blue
  m = max(r, g, b)
  if m==0:
    return gdk.Color(-1, -1, -1)
  e = (65535.0-m)/m
  return gdk.Color(int(e*r), int(e*g), int(e*b))"""

def parseDroppedDate(text):
    part = text.split('/')
    if len(part)==3:
      try:
        part[0] = int(part[0])
        part[1] = int(part[1])
        part[2] = int(part[2])
      except:
        myRaise(__file__)
        return None
      minmax = ((0, 9999), (1, 12), (1, 31))
      formats=(
      [0, 1, 2],
      [1, 2, 0],
      [2, 1, 0],
      )
      for format in formats:
        for i in range(3):
          valid = True
          f = format[i]
          if not (minmax[f][0] <= part[i] <= minmax[f][1]):
            valid = False
            #print 'format %s was not valid, part[%s]=%s'%(format, i, part[i])
            break
        if valid:
          year = part[format.index(0)] ## "format" must be list because of method "index"
          month = part[format.index(1)]
          day = part[format.index(2)]
          break
      if not valid:
        return None
    else:
      return None
    ##??????????? when drag from a persian GtkCalendar with format %y/%m/%d
    #if year < 100:
    #  year += 2000
    return (year, month, day)

def urlToPath(url):
  if len(url)<7:
    return url
  if url[:7]!='file://':
    return url
  path=url[7:]
  if path[-2:]=='\r\n':
    path=path[:-2]
  elif path[-1]=='\r':
    path=path[:-1]
  ## here convert html unicode symbols to utf8 string
  if not '%' in path:
    return path
  path2=''
  n=len(path)
  i=0
  while i<n:
    if path[i]=='%' and i<n-2:
      path2 += chr(eval('0x%s'%path[i+1:i+3]))
      i += 3
    else:
      path2 += path[i]
      i += 1
  return path2








#htmlColorToGdk=lambda hc: gdk.Color(int(hc[1:3], 16)*256, int(hc[3:5], 16)*256, int(hc[5:7], 16)*256)
#htmlColorToGdk = lambda hc: gdk.color_parse(hc)


themeDir = os.path.join(rootDir, 'themes')
theme = None 

rtl = langList[lang][4]
if rtl:
  gtk.widget_set_default_direction(gtk.TEXT_DIR_RTL)
def rtlSgn():
  if rtl:
    return 1
  else:
    return -1


fa_dig = (u'۰', u'۱', u'۲', u'۳', u'۴', u'۵', u'۶', u'۷', u'۸', u'۹')
ar_dig = (u'٠', u'١', u'٢', u'٣', u'٤', u'٥', u'٦', u'٧', u'٨', u'٩')

def numLocal(num, mode=lang, fillSpace=0, fillZero=0):
  ## import locale ; locale.str(num)
  if mode==0:
    import locale
    return locale.str(num)
  if not mode in (2, 3):
    return str(num)
  if num<0:
    s = str(-num)
    neg = True
  else:
    s = str(num)
    neg = False
  if mode==2:
    dig = fa_dig
  elif mode==3:
    dig = ar_dig
  res = u''
  for i in s:
    try:
      res += dig[int(i)]
    except:
      myRaise(__file__)
      res = s
      break
  if neg:
    res = '-'+res
  if fillSpace>0:
    if len(res)<fillSpace:
      res = (fillSpace-len(res))*u' '+res
  elif fillZero>0:
    if len(res)<fillZero:
      res = (fillZero-len(res))*dig[0]+res
  return res


def my_url_show(link):
  try:
    os.popen2("xdg-open '%s'"%link)
    #import subprocess
    #subprocess.Popen(['xdg-open', link])
  except:
    try:
      import webbrowser
      webbrowser.open(url)
    except:
      try:
        import gnomevfs
        gnomevfs.url_show(url)
      except:
        for path in ('/usr/bin/gnome-www-browser','/usr/bin/firefox',
        '/usr/bin/iceweasel','/usr/bin/konqueror'):
          if os.path.isfile(path):
            os.popen2('%s \'%s\''%(path, link))
            return

click_website = lambda widget, link: my_url_show(link)
try:
  gtk.link_button_set_uri_hook(click_website)
except:
  myRaise(__file__)
  print 'may be an old version of PyGTK (older than 2.10)'
try:
  gtk.about_dialog_set_url_hook(click_website)
except:
  myRaise(__file__)
  #print 'may be an old version of PyGTK (older than 2.10)'

settings = gtk.settings_get_default()
fontUseDefault	= True
fontDefault	= settings.get_property('gtk-font-name')
fontCustom	= fontDefault
####################
shownDates=(
{'enable':True, 'mode':1, 'x':0,  'y':-2, 'font':'Sans 14', 'color':gdk.Color(0, 0, 0)}, 
{'enable':True, 'mode':0, 'x':18, 'y':5,  'font':'Sans 8',  'color':gdk.Color(0, 40000, 0)}, 
{'enable':True, 'mode':2, 'x':-18,'y':4,  'font':'Sans 9',  'color':gdk.Color(0, 0, 50000)})
shownDates[0]['font'] = fontDefault
parts = fontDefault.split(' ')
n = len(parts)
if n in (2, 3):
  try:
    if n==2:
      fontname = parts[0]
      size = int(parts[1])
    elif n==3:
      fontname = parts[0] + ' ' + parts[1]
      size = int(parts[2])
  except:
    myRaise(__file__)
  else:
    for item in shownDates[1:]:
      item['font'] = '%s %d'%(fontname, size*0.6)
    del fontname, size
del n, parts
shownDatesOrig = shownDates
################################# Options
keyDelay 	= 0 #0.07 ## delay between listening of key press in calendar
##calHeight	= 220 #???????? removed with new sizing method
winHeight	= 300 #????????????????????
winWidth	= 480
winX      = 0
winY      = 0
winTaskbar	= False
showDigClockTb	= True ## On Toolbar
showDigClockTr	= True ## On Tray
clockFormat	= '%X' ## '%T' or '%X' (local) or '<b>%T</b>' (bold) or '%m:%d' (no seconds)
showToolbar	= True
bgColor		= gdk.Color(65535, 65535, 65535)## or None
bgColorAlpha 	= 40000
bgUseDesk 	= True
borderColor	= gdk.Color(0, 37000, 0)
borderColorAlpha= 30000
borderTextColor	= gdk.Color(65535, 65535, 65535) ## text of weekDays and weekNumbers
#menuBgColor	= borderColor ##???????????????
menuTextColor	= None##borderTextColor##???????????????
holidayColor	= gdk.Color(60000, 10535, 10000)
inactiveColor	= gdk.Color(0, 0, 0)
inactiveColorAlpha= 15000
cursorFixed = False
cursorOutColor	= gdk.Color(42565, 0, 42235)
cursorBgColor	= gdk.Color(65535, 65535, 65535)
cursorBgAlpha	= 49000
cursorD 	= 3.0
cursorR		= 7.0 ## Rounded Rectangle
cursorW 	= 57
cursorH		= 24
calGrid 	= True
gridColor 	= gdk.Color(0, 0, 0)
gridAlpha 	= 9000
calLeftMargin 	= 30
calTopMargin 	= 30
boldYmLabel		= True	##??????????????? Apply in Pref
showYmArrows	= True	##??????????????? Apply in Pref
labelMenuDelay = 0.1 ## delay for shift up/down items of menu for right click on YearLabel
trayImage	= os.path.join(pixDir, 'tray-green.png')
trayImageHoli	= os.path.join(pixDir, 'tray-red.png')
trayBgColor	= gdk.Color(-1, -1, -1, 0) ## how to get bg color of gnome panel ????????????
trayTextColor	= gdk.Color(0, 0, 0)
traySize	= 22
trayFont	= None
trayY0		= None
trayEggPopupImageOnly = False	##??????????????? Apply in Pref

dragGetMode	= cal.DATE_GREG			##??????????????? Apply in Pref
#dragGetDateFormat = '%Y/%m/%d'
dragRecMode	= cal.DATE_GREG			##??????????????? Apply in Pref
dragIconCell	= False
####################
calHeightReq = -1
lowerDocked = False
lowerExpanded = True ## affect only if lowerDocked==True
####################
monthRMenuNum = True
#monthRMenu
prefPagesOrder = (0, 1, 2, 3)
showWinController = True
adjustTimeCmd = ''
for cmd in ('gksudo', 'kdesudo', 'gksu', 'gnomesu', 'kdesu'):
  if os.path.isfile('/usr/bin/%s'%cmd):
    adjustTimeCmd = '%s \'%s/adjust_dtime.py\''%(cmd, srcDir)
###############################################



def shownDatesStr():
  n = len(shownDates)
  st='('
  for i in range(n):
    d = shownDates[i].copy()
    st+='\n{'
    for k in d.keys():
      v = d[k]
      if type(v)==gdk.Color:
        vs = gdkColorToStr(v)
      else:
        vs = repr(v)
      st += '%s:%s, '%(repr(k),vs)
    if i==n-1:
      st=st[:-2]+'})'
    else:
      st=st[:-2]+'},'
  return st


extradayEnable = True
extradayTray = False


class BaseTextPlug(gobject.GObject):
  def __init__(self, path, mode=0, desc='No Description', enable=True, show_date=False
    , about=None, authors=[], has_config=False, has_image=False):
    gobject.GObject.__init__(self)
    self.external = False
    self.path = path
    self.mode = mode
    self.desc = desc
    self.enable = enable
    self.show_date = show_date
    self.about = about
    self.authors = authors
    self.has_config = has_config
    self.has_image = has_image
    #########
    self.text = ''
    self.holiday = False
    self.load()
  def clear(self):
    pass
  def load(self):
    pass
  def get_text(self, year, month, day):### Remove ????????????
    return ''
  def update_cell(self, c):
    if extradayEnable and c.gray==0:
          (y, m, d) = c.dates[self.mode]
          text = ''
          t = self.get_text(y, m, d)
          if t!='':
            text += t
          if d>=cal.modules[self.mode].minMonthLen:
          ## and d<=cal.modules[self.mode].maxMonthLen:
            (ny, nm, nd) = cal.jd_to(c.jd+1, self.mode)
            if nm>m or ny>y:
              nt = self.get_text(y, m, d+1)
              if nt!='':
                text += nt
          if text!='':
            if c.extraday!='':
              c.extraday += '\n'
            c.extraday += text
          
  #def open_configure(self):## for external plugins
  #  pass
  #def open_about(self):## for external plugins
  #  pass

gobject.type_register(BaseTextPlug)
gobject.signal_new('date-change', BaseTextPlug, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [int, int, int])
gobject.signal_new('date-change-after', BaseTextPlug, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [int, int, int])


class HolidayPlug(BaseTextPlug):
  def __init__(self, path, enable=None, show_date=None):
    default_enable = True
    default_show_date = False
    exec(file(path).read())
    if enable==None:
      enable = default_enable
    if show_date==None:
      show_date = default_show_date
    BaseTextPlug.__init__(self, path, None, desc, enable, show_date,
      about, authors, has_config, False)
    self.holidays = holidays
  def update_cell(self, c):
    if c.gray==0 and not c.holiday:
            for mode in self.holidays.keys():## .keys() in not neccesery
              (y, m, d) = c.dates[mode]
              for (hm, hd) in self.holidays[mode]:
                if m==hm:
                  if d==hd:
                    c.holiday = True
                    break
                  elif d==hd-1 and hd>=cal.modules[mode].minMonthLen:
                    (ny, nm, nd) = cal.jd_to(c.jd+1, mode)
                    if nm>m or ny>y:
                      c.holiday = True
                      break



class BuiltinTextPlug(BaseTextPlug):
  def __init__(self, path, enable=None, show_date=None):
    default_enable = True
    default_show_date = False
    exec(file(path).read())
    if enable==None:
      enable = default_enable
    if show_date==None:
      show_date = default_show_date
    self.db_path = os.path.dirname(path)+'/'+db_name
    BaseTextPlug.__init__(self, path, mode, desc, enable, show_date,
      about, authors, has_config, has_image)
  def clear(self):
    self.data = []
  def load(self):
    db = []
    for j in xrange(12):
        monthDb=[]
        for k in xrange(cal.modules[self.mode].maxMonthLen):
          monthDb.append('')
        db.append(monthDb)
    db.append({}) ## last item is a dict of dates (y, m, d) and the description of day
    ext = os.path.splitext(self.db_path)[-1]
    if ext=='.xml':
        tmp = parse(self.db_path).documentElement ### if db not exist?
        db_xml=tmp.getElementsByTagName('day')
        for record in db_xml:
          for element in record.childNodes:
            if element.nodeType != element.TEXT_NODE:
              if element.nodeType != element.TEXT_NODE:
                name, data = _get_text(element)
                if name=='num':
                  sp=data.split('/')
                  find = True
                if name=='desc' and find:
                  if len(sp)==2:
                    try:
                      m = int(sp[0])
                      d = int(sp[1])
                      db[m-1][d-1] = data
                    except:
                      myRaise(__file__)
                      print(m,d)
                  elif len(sp)==3:
                    try:
                      y = int(sp[0])
                      m = int(sp[1])
                      d = int(sp[2])
                      db[12][(y,m,d)] = data
                    except:
                      myRaise(__file__)
                      print(y,m,d)
                  find = False
    elif ext=='.titled':## Titled text db (used for Owghat)
        sep = '\t'
        try:
          lines = file(self.db_path).read().split('\n')
        except:
          myRaise(__file__)
        year = 0
        month = 1
        day = 1
        heads = lines[0].split('\t')
        n = len(heads)
        for line in lines[1:]:
          if line=='':
            continue
          if line[0]=='#':
            continue
          parts = line.split('\t')
          assert len(parts)==n
          date = parts[0].split('/')
          if len(date)==3:
            year = int(date[0])
            month = int(date[1])
            day = int(date[2])
          elif len(date)==2:
            month = int(date[0])
            day = int(date[1])
          elif len(date)==1:
            day = int(date[0])
          else:
            raise IOError, 'Bad line in database %s:\n%s'%(db_file, line)
          tp = []
          for j in xrange(1, n):#????????????????????
            tp.append('%s: %s'%(heads[j], parts[j]))
          db[12][(year, month, day)] = sep.join(tp)
    elif ext in ('.txt', '.db'):
        sep = '\t'
        try:
          lines = file(self.db_path).read().split('\n')
        except:
          myRaise(__file__)
        for line in lines[1:]:
          if line=='':
            continue
          if line[0]=='#':
            continue
          parts = line.split('\t')
          if len(parts)<2:
            continue
          date = parts[0].split('/')
          text = '\t'.join(parts[1:])
          if len(date)==3:
            y = int(date[0])
            m = int(date[1])
            d = int(date[2])
            db[12][(y, m, d)] = text
          elif len(date)==2:
            m = int(date[0])
            d = int(date[1])
            db[m-1][d-1] = text
          else:
            raise IOError, 'Bad line in database %s:\n%s'%(self.db_path, line)
    self.data = db
  def get_text(self, year, month, day):
    db = self.data
    if db==None:
      return ''
    mode = self.mode
    text = ''
    #if mode!=primaryMode:
    #  (year, month, day) = cal.convert(year, month, day, primaryMode, mode)
    try:
      text = db[month-1][day-1]
    except IndexError:
      pass
    else:
      if self.show_date and text!='':
        text = '%s %s: %s'%(numLocal(day), cal.modules[mode].monthName[month-1], text)
    try:
      text2 = db[12][(year, month, day)]
    except:
      pass
    else:
      if text!='':
        text += '\n'
      if self.show_date:
        text2 = '%s %s %s: %s'%(numLocal(day), cal.modules[mode].monthName[month-1], numLocal(year), text2)
      text += text2
    return text
  #def pref_str(self):
    ## (self, path, mode, desc, show_date=False):
    #return '%s("%s", %s, "%s", enable=%s, show_date=%s)'%(self.__class__.__name__, self.db_path.replace('"', '\\"'),
    #  self.mode, self.desc.replace('"', '\\"'), self.enable, self.show_date)


def ymdRange((y1, m1, d1), (y2, m2, d2), mode=cal.DATE_GREG):
  if y1==y2 and m1==m2:
    return [(y1, m1, d) for d in range(d1, d2)]
  j1 = int(cal.to_jd(y1, m1, d1, mode))
  j2 = int(cal.to_jd(y2, m2, d2, mode))
  l = []
  for j in range(j1, j2):
    l.append(cal.jd_to(j, mode))
  return l


class IcsTextPlug(BaseTextPlug):
  def __init__(self, path, enable=True, show_date=False, all_years=False):
    desc = os.path.split(path)[-1][0:-4]
    self.ymd = None
    self.md = None
    self.all_years = all_years
    BaseTextPlug.__init__(self, path, cal.DATE_GREG, desc, enable, show_date)
    #self.load()
  def clear(self):
    self.ymd = None
    self.md = None
  def load(self):
    try:
      lines = file(self.path).read().replace('\r', '').split('\n')
    except:
      myRaise(__file__)
    n = len(lines)
    i = 0
    while True:
      try:
        if lines[i]=='BEGIN:VEVENT':
          break
      except IndexError:
        print 'bad ics file "%s"'%self.path
        return
      i += 1
    SUMMARY		= ''
    DESCRIPTION	= ''
    DTSTART		= None
    DTEND		= None
    if self.all_years:
      md = {}
      while True:
        i += 1
        try:
          line = lines[i]
        except IndexError:
          break
        if line=='END:VEVENT':
          if SUMMARY!='' and DTSTART!=None and DTEND!=None:
            text = SUMMARY
            if DESCRIPTION!='':
              text += '\n%s'%DESCRIPTION
            #print DTSTART, DTEND, text
            for (y, m, d) in ymdRange(DTSTART, DTEND):
              md[(m, d)] = text
          else:
            print 'unsupported ics event, SUMMARY=%s, DTSTART=%s, DTEND=%s'%(SUMMARY,DTSTART,DTEND)
          SUMMARY		= ''
          DESCRIPTION	= ''
          DTSTART		= None
          DTEND			= None
        elif line.startswith('SUMMARY:'):
          SUMMARY = line[8:].replace('\\,', ',').replace('\\n', '\n')
        elif line.startswith('DESCRIPTION:'):
          DESCRIPTION = line[12:].replace('\\,', ',').replace('\\n', '\n')
        elif line.startswith('DTSTART;'):
          #if not line.startswith('DTSTART;VALUE=DATE;'):
          #  print 'unsupported ics line: %s'%line
          #  continue
          date = line.split(':')[-1]
          #if len(date)!=8:
          #  print 'unsupported ics line: %s'%line
          #  continue
          try:
            DTSTART = (int(date[:4]), int(date[4:6]), int(date[6:8]))
          except:
            print 'unsupported ics line: %s'%line
            myRaise(__file__)
            continue
        elif line.startswith('DTEND;'):
          #if not line.startswith('DTEND;VALUE=DATE;'):
          #  print 'unsupported ics line: %s'%line
          #  continue
          date = line.split(':')[-1]
          #if len(date)!=8:
          #  print 'unsupported ics line: %s'%line
          #  continue
          try:
            DTEND = (int(date[:4]), int(date[4:6]), int(date[6:8]))
          except:
            print 'unsupported ics line: %s'%line
            myRaise(__file__)
            continue
      self.ymd = None
      self.md = md
    else:## not self.all_years
      ymd = {}
      while True:
        i += 1
        try:
          line = lines[i]
        except IndexError:
          break
        if line=='END:VEVENT':
          if SUMMARY!='' and DTSTART!=None and DTEND!=None:
            text = SUMMARY
            if DESCRIPTION!='':
              text += '\n%s'%DESCRIPTION
            for (y, m, d) in ymdRange(DTSTART, DTEND):
              ymd[(y, m, d)] = text
          SUMMARY		= ''
          DESCRIPTION	= ''
          DTSTART		= None
          DTEND			= None
        elif line.startswith('SUMMARY:'):
          SUMMARY = line[8:].replace('\\,', ',').replace('\\n', '\n')
        elif line.startswith('DESCRIPTION:'):
          DESCRIPTION = line[12:].replace('\\,', ',').replace('\\n', '\n')
        elif line.startswith('DTSTART;'):
          #if not line.startswith('DTSTART;VALUE=DATE;'):
          #  print 'unsupported ics line: %s'%line
          #  continue
          date = line.split(':')[-1]
          #if len(date)!=8:
          #  print 'unsupported ics line: %s'%line
          #  continue
          try:
            DTSTART = (int(date[:4]), int(date[4:6]), int(date[6:8]))
          except:
            print 'unsupported ics line: %s'%line
            myRaise(__file__)
            continue
        elif line.startswith('DTEND;'):
          #if not line.startswith('DTEND;VALUE=DATE;'):
          #  print 'unsupported ics line: %s'%line
          #  continue
          date = line.split(':')[-1]
          #if len(date)!=8:
          #  print 'unsupported ics line: %s'%line
          #  continue
          try:
            DTEND = (int(date[:4]), int(date[4:6]), int(date[6:8]))
          except:
            print 'unsupported ics line: %s'%line
            myRaise(__file__)
            continue
      self.ymd = ymd
      self.md = None
  def get_text(self, y, m, d):
    if self.ymd!=None:
      if (y, m, d) in self.ymd:
        if self.show_date:
          return '%s %s %s: %s'%(numLocal(d), cal.modules[self.mode].monthName[m-1],
            numLocal(y), self.ymd[(y, m, d)])
        else:
          return self.ymd[(y, m, d)]
        #print (y, m, d)
    if self.md!=None:
      if (m, d) in self.md:
        if self.show_date:
          return '%s %s %s: %s'%(numLocal(d), cal.modules[self.mode].monthName[m-1],
            numLocal(y), self.ymd[(y, m, d)])
          #return '%s %s: %s'%(numLocal(d), cal.modules[self.mode].monthName, self.md[(m, d)])
        else:
          return self.md[(m, d)]
        #print (m, d)
    #print (y, m, d)
    return ''
  def open_configure(self):
    pass
  def open_about(self):
    pass


def getPlugString(plug):
  return 'loadPlug("%s", enable=%s, show_date=%s)'\
      %(plug.path.replace('"', '\\"'),plug.enable,plug.show_date)


def getAllPlugListString():
  return '[' + ', \n'.join([getPlugString(p) for p in allPlugList]) + ']'


allPlugList = []


def loadExternalPlug(path, enable=True, show_date=True):
  if not os.path.isfile(path):
    print 'plugin file "%s" not found! maybe removed?'%path
    #try:
    #  plugIndex.remove(
    return None #?????????????????????????
    ##plug = BaseTextPlug(path, 0, 'Failed to load plugin', enable, show_date)
    ##plug.external = True
    ##return plug
  fname = os.path.split(path)[-1]
  direc = os.path.dirname(path)
  name = os.path.splitext(fname)[0]
  sys.path.append(direc)
  mod = __import__(name)
  sys.path.pop(-1)
  #mod.module_init(srcDir, 
  try:
    plug = mod.TextPlug(enable=enable, show_date=show_date)
  except:
    myRaise(__file__)
    print dir(mod)
    sys.exit(1)
  #plug.path = path
  return plug


def loadPlug(path, **kwargs):
    if not os.path.isfile(path):
      return None
    ext = os.path.splitext(path)[-1]
    try:
      if ext=='.spg':
        return BuiltinTextPlug(path, **kwargs)
      elif ext=='.hol':
        return HolidayPlug(path, **kwargs)
      elif ext=='.ics':
        return IcsTextPlug(path, **kwargs)
      elif ext=='.py' or ext=='.so':
        return loadExternalPlug(path, **kwargs)
      else:
        return None
    except:
      myRaise(__file__)
      return None


######### Remove plugIndex and apply in BuiltinTextPlug class and allPlugList list ?????????????????????
plugIndex = range(len(allPlugList))




customFile = os.path.join(confDir, '.starcal_extra.xml')
customdayModes=((_('Birthday'),			'balloons.png',		'balloons-2.png'),
                (_('Marriage Jubilee'),	'marriage.png',		'marriage-2.png'),
                (_('Obit'),				'shabdar.png',		'shabdar-2.png'),
                (_('Note'),				'note.png',			'note-2.png'),
                (_('Task'),				'task.png',			'task-2.png'),
                (_('Alarm'),			'alarm-clock.png',	'alarm-clock-2.png'))
customdayShowText=True
customdayShowIcon=True






#monthNameEn = [ mod.monthName for mod in cal.modules ]
#monthName = [ [_(name) for name in names] for names in monthNameEn]

#monthNameSynEn=[##????????????????????????????
#('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'),
#('Far', 'Ord', 'Khr', 'Tir', 'Mor', 'Shr', 'Meh', 'Abn', 'Azr', 'Dey', 'Bah', 'Esf'),
#('Moh', 'Saf', 'Rb1', 'Rb2', 'Jm1', 'Jm2', 'Raj', 'Shb', 'Ram', 'Shw', 'DhQ', 'DhH')]

			
weekDayName = (_('Sunday'),_('Monday'),_('Tuesday'),_('Wednesday'),_('Thursday'),_('Friday'),_('Saturday'))
weekDayNameSyn = (_('Sun'),_('Mon'),_('Tue'),_('Wed'),_('Thu'),_('Fri'),_('Sat'))



firstWeekDay=6 ## 6 means Saturday  ( 0 means Sunday)
firstWeekDayAuto=True
def getLocaleFirstWeekDay():
  return int(os.popen('locale first_weekday').read())-1
  #return int(os.popen('LANG=%s locale first_weekday'%langList[lang][1]).read())-1
  ##retrun int(trans('calendar:week_start:0').split(':')[-1]) ## "trans" must read from gtk-2.0.mo !!
wdaySyn = False



getWeekDayN = lambda i: weekDayName[(i+firstWeekDay)%7]

def getWeekDayAuto(i):
  if wdaySyn:
    return weekDayNameSyn[(i+firstWeekDay)%7]
  else:
    return weekDayName[(i+firstWeekDay)%7]


dayOfWeek=lambda year, month, day: cal.getWeekDay(year, month, day, primaryMode, firstWeekDay)

datesDiff=lambda y1,m1,d1,y2,m2,d2: int(cal.to_jd(y2,m2,d2,primaryMode))\
  - int(cal.to_jd(y1,m1,d1,primaryMode))

dayOfYear=lambda year, month, day: datesDiff(year, 1, 1, year, month, day)+1

weekNumberModeAuto = False#????????????
weekNumberMode = 7
# 0: First week contains first Sunday of year
# 4: First week contains first Thursday of year (ISO 8601, Gnome Clock)
# 6: First week contains first Saturday of year
# 7: First week contains first day of year
# 8: as Locale

## 1971(53), 1972(52), 1977, 1982, 1983, 1988, 1993, 1994
## 1999(53), 2000(52), 2005(53), 2010(53), 2011(52), 2016(53), 2021, 2022, 2027, 2028

#firstWeekDay=0 ## for test
def weekNumber(year, month, day):## week number in year
  first = dayOfWeek(year, 1, 1) - firstWeekDay - 1
  ## first = weekday of first day of year (Monday=0)
  if weekNumberMode==7:
    result = (datesDiff(year, 1, 1, year, month, day) + first%7) / 7 + 1
  else:
    result = (datesDiff(year, 1, 1, year, month, day) + first%7) / 7 + (first<weekNumberMode-firstWeekDay)
    #assert (result>0)==(first<weekNumberMode-firstWeekDay)
    if result==0:
      result = weekNumber(
        *cal.jd_to(cal.to_jd(year, month, day, primaryMode)-7, primaryMode)
      ) + 1
  return result
#for y in range(1970, 2030): ## for test
#  weekNumber(y, 1, 1)


def getLocaleweekNumberMode():##????????????
  return (int(os.popen('locale week-1stweek').read())-1)%8
  ## will be 7 for farsi (OK)
  ## will be 6 for english (usa) (NOT OK, must be 4)
  #return int(os.popen('LANG=%s locale first_weekday'%langList[lang][1]).read())-1


#holidayWeekDay=6 ## 6 means last day of week ( 0 means first day of week)
#thDay = (_('First day'), _('2nd day'), _('3rd day'), _('4th day'), _('5th day'), _('6th day'), _('Last day'))
#holidayWeekEnable = True

holidayWeekDays = [5] ## 5 means Friday (0 means Sunday)
## [5] or [4,5] in Iran
## [0] in most of contries





## stock image of "Next" and "Previous" buttons(year/month)
## STOCK_GO_BACK, STOCK_GO_FORWARD, STOCK_GO_DOWN, STOCK_GO_UP, STOCK_ZOOM_OUT, STOCK_ZOOM_IN
prevStock = gtk.STOCK_GO_BACK
nextStock = gtk.STOCK_GO_FORWARD

maxCache=7 ## maximum size of months status cache (max size of CalWidget.months)
showMain=True ## Show main window on start (or only goto tray)


def strftime(format, t=None, mode=cal.DATE_GREG):##?????????????????
  if t==None:
    t = cal.localtime(None, mode)
  #if t[0] >= 1900:
  #  return time.strftime(format, t)
  ## problem with %Y, %y, %C, %F, %D
  year = t[0]
  t[0] += 2000
  format = format\
      .replace('%%','\x00')\
      .replace('%F', '%Y-%m-%d')\
      .replace('%D', '%m/%d/%y')\
      .replace('%Y', '%d'%year)\
      .replace('%OY', numLocal(year))\
      .replace('%y', '%.2d'%(year%100))\
      .replace('%Oy', numLocal(year%100, fillSpace=2))\
      .replace('%C', '%.2d'%(year/100))\
      .replace('%Oy', numLocal(year/100, fillSpace=2))\
      .replace('\x00', '%%')
  return time.strftime(format, t).replace(str(year+2000), str(year))
  '''
  text = ''
  #text=text.replace('%Y', '%.4d'%t.tm_year).replace('%y', ('%.4d'%t.tm_year)[2:])
  n = len(format)
  i = 0
  while i<n:
    c = format[i]
    if c!='%':
      text+=c
      i+=1
      continue
    c = format[i+1]
    if c=='%':
      text+='%'
      i+=2
      continue
    elif c=='a':
      text+=weekDayNameSyn[t.tm_wday]
      i+=2
      continue
    elif c=='A':
      text+=weekDayName[t.tm_wday]
      i+=2
      continue
    elif c=='b':#?????????? Month Synapsis in Farsi??????
      text+=monthNameSyn[mode][t.tm_wday]
      i+=2
      continue
    elif c=='B':
      text+=monthName[mode][t.tm_wday]
      i+=2
      continue
    elif c=='c':
      text += '%s %s %2d %.2d:%.2d:%.2d %.4d'%(monthNameSyn[mode][t.tm_wday], weekDayNameSyn[t.tm_wday], t.tm_mday,
        t.tm_hour, t.tm_min, t.tm_sec, t.tm_year)
      i+=2
      continue
    elif c=='C':
      text += ('%.4d'%t.tm_year)[:2]
      i+=2
      continue
    elif c=='d':
      text += '%.2d'%t.tm_mday
      i+=2
      continue
    elif c=='D':
      text += (('%.4d'%t.tm_year)[2:] + '%.2d'%t.tm_mon + '%.2d'%t.tm_mday)
      i+=2
      continue
    elif c=='e':
      text += '%2d'%t.tm_mday
      i+=2
      continue
    elif c=='F':
      text += '%.4d/%.2d/%.2d'%(t.tm_year, t.tm_mon, t.tm_mday)
      i+=2
      continue
    '''

#"""
class FClockLabel(gtk.Label): ## Time is in Local
  def __init__(self, format='%T', selectable=False):
    '''format is a string that used in strftime(), it can contains markup that apears in GtkLabel
    for example format can be "<b>%T</b>"
    local is bool. if True, use Local time. and if False, use GMT time.
    selectable is bool that passes to GtkLabel'''
    gtk.Label.__init__(self)
    self.set_use_markup(True)
    self.set_selectable(selectable)
    self.set_direction(gtk.TEXT_DIR_LTR)
    self.format = format
    self.running = False
    #self.connect('button-press-event', self.button_press)
    self.start()#???
  def start(self):
    self.running = True
    self.update()
  def update(self):
    if self.running:
      timeout_add(int(1000*(1-time.time()%1)), self.update)
      self.set_label(strftime(self.format))
  def stop(self):
    self.running = False
#"""



##????????????????????? Tranparency problem
class FClockImage(gtk.Image): ## Time is in Local
  def __init__(self, format='%T'):
    '''format is a string that used in strftime(), it can contains markup that apears in GtkLabel
    for example format can be "<b>%T</b>"'''
    gtk.Image.__init__(self)
    self.set_direction(gtk.TEXT_DIR_LTR)
    self.format = format
    self.running = False
    #self.connect('button-press-event', self.button_press)
    self.start()#???
  def start(self):
    self.running = True
    self.update()
  def update(self):
    if self.running:
      timeout_add(int(1000*(1-time.time()%1)), self.update)
      self.set_label(strftime(self.format))
  def stop(self):
    self.running = False
  def set_label(self, text):
    textLay = self.create_pango_layout('') ## markup
    textLay.set_markup(text)
    if fontUseDefault:
      textLay.set_font_description(pango.FontDescription(fontDefault))
    else:
      textLay.set_font_description(pango.FontDescription(fontCustom))
    (w, h) = textLay.get_pixel_size()
    pmap = gtk.gdk.Pixmap(self.window, w, h, 24)
    pmap.set_colormap(self.get_screen().get_system_colormap())
    gc = pmap.new_gc(foreground=gdk.Color(pixel=0))
    pmap.draw_layout(gc, 0, 0, textLay, trayTextColor, trayBgColor)
    mask = None
    #mask = gdk.Pixmap(pmap, w, h, 1) ## first arg: self.window OR pmap
    #mask.set_colormap(self.get_screen().get_system_colormap())
    #gc = mask.new_gc(foreground=gdk.Color(pixel=0))
    #mask.draw_rectangle(gc, True, 0, 0, w, h)
    #mask.draw_layout(gc, 0, 0, textLay, trayTextColor, gdk.Color(pixel=0))
    self.set_from_pixmap(pmap, mask)
    ##### Write to file (for testing)
    #pixbuf = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, w, h)
    #pixbuf.get_from_drawable(pmap, self.get_colormap(), 0, 0, 0, 0, w, h)
    #pixbuf.save('%s.png'%time.time(), 'png')
    #pmap.new_gc(foreground=gdk.Color(pixel=0))
    #self.shape_combine_mask(pmap, 0, 0)


dateFormat = '%Y/%m/%d'
def dateStr(y, m, d):
  wday = (dayOfWeek(y,m,d)-1)%7 ## in time module, index 0 means Monday, and 6 means Sunday
  return strftime(dateFormat, [y, m, d] + list(time.localtime()[3:6]) + [wday, 1, 1]) ## skiping dayOfYear
  #return strftime(dateFormat, [y, m, d] + list(time.localtime()[3:6]) + [wday, dayOfYear(y,m,d), 1])

winKeepAbove = True
winSticky = True

def quit(*args):
  gtk.main_quit()
  #sys.exit(0)

prefText = prefText.replace('curser', 'cursor')## Forgive me for this miscue!!!!!!!!
exec(prefText)

try:
  version
except NameError:
  prefVersion = ''
else:
  prefVersion = version
  del version

liveConfPath = os.path.join(confDir, 'live-confg')
if os.path.isfile(liveConfPath):
  exec(file(liveConfPath).read())

def saveLiveConf():
  print 'com.saveLiveConf'
  text = ''
  for key in ('winX', 'winY', 'winWidth', 'winHeight', 
    'winKeepAbove', 'winSticky', 'showToolbar',
    'calHeightReq', 'lowerDocked', 'lowerExpanded'):
      text += '%s=%s\n'%(key, repr(eval(key)))
  file(liveConfPath, 'w').write(text)


def cmpVersion(v0, v1):
  assert type(v0)==type(v1)==str
  if v0=='':
    if v1=='':
      return 0
    else:
      return -1
  elif v1=='':
      return 1
  return cmp([ int(p) for p in v0.split('.') ],
             [ int(p) for p in v1.split('.') ])


### For compatibility with older versions
if prefVersion!='':
  if cmpVersion(prefVersion, '1.3.5') < 0:
    try:
      shownDates = shownDatesOrig
    except:
      pass
  if cmpVersion(prefVersion, '1.4.0') < 0:
    try:
      showWinController = winDecorated
    except:
      pass
      #myRaise(__file__)
    else:
      del winDecorated
    #if cmpVersion(prefVersion, '1.3.6') >= 0:
    #  try:
    #    plugIndex = [x[0] for x in extraIndex]
    #  except:
    #    myRaise(__file__)
del shownDatesOrig


n = len(allPlugList)
i = 0
while i<n:
  if allPlugList[i]==None:
    allPlugList.pop(i)
    n -= 1
    try:
      plugIndex.remove(i)
    except ValueError:
      pass
  else:
    i += 1
del i, n



plugNames = [os.path.split(plug.path)[-1] for plug in allPlugList]
##newPlugs = []#????????

for direc in (plugDir, plugDirUser):
  if not os.path.isdir(direc):
    continue
  for fname in os.listdir(direc):
    if fname=='__init__.py' or fname in plugNames:##??????????
      continue 
    path = '%s/%s'%(direc, fname)
    name = os.path.splitext(fname)[0]
    #if path in paths:## The plugin is not new, currently exists in allPlugList
      #print 'plugin "%s" already exists.'%path
      #continue
    if not os.path.isfile(path):
      continue
    plug = loadPlug(path)
    if plug==None:
      continue
    #try:
    plugIndex.append(len(allPlugList))
    allPlugList.append(plug)
    #except:
    #  myRaise(__file__)

del plugNames




#theme = 'Dark' # 'Default
if theme!=None:
  gtkrc = os.path.join(themeDir, theme, 'gtkrc')
  try:
    gtk.rc_parse(gtkrc)
    exec(file(os.path.join(themeDir, theme, 'starcalrc')).read())
  except:
    myRaise(__file__)

'''
#print gtk.rc_get_default_files() ## ('/etc/gtk-2.0/gtkrc', '/home/tux/.gtkrc-2.0')
themeList = os.listdir(themeDir)
try:
  themeI = themeList.index(theme)
except:
  myRaise(__file__)
  themeI = 0
themeName = themeList[themeI]
if os.path.isdir(themeName):
    gtkrc = os.path.join(themeDir, themeName, 'gtkrc')
    try:
      gtk.rc_parse(gtkrc)
    except:
      myRaise(__file__)
    try:
      exec(file(os.path.join(themeDir, themeName, 'starcalrc')).read())
    except:
      myRaise(__file__)
'''





shownDatesNum=len(shownDates)
primaryMode = shownDates[0]['mode']


if not fontUseDefault:
  settings.set_property('gtk-font-name', fontCustom)


#print settings.get_property('gtk-timeout-initial')## 200
#print settings.get_property('gtk-timeout-repeat')## 20
#settings.set_property('gtk-timeout-repeat', 100)##???????????????? Dosn't affect!!





#calHeight = int(calHeight)



def getSysDate(mode=None):
  if mode==None:
    mode=primaryMode
  if mode==cal.DATE_GREG:
    return time.localtime()[:3]
  else:
    (gy, gm, gd) = time.localtime()[:3]
    return cal.convert(gy, gm, gd, cal.DATE_GREG, mode)

"""
def keyval2char(keyval):
  if keyval<256:
    char = unichr(keyval).encode('utf-8')
  elif keyval>=0x110000:## گ ک ی پ ۰ ... ۹
    char = unichr(keyval-0x1000000).encode('utf-8')
  else:
    try:
      char = unichr(keyval+96).encode('utf-8')
    except:
      char = 'unknown'
  return '%s (%s)'%(keyval, char)
  #return char

def char2keyval(char):
  if type(char)==str:
    char = char.decode('utf-8')
  elif type(char)!=unicode:
    raise TypeError('bad argument given to char2keyval with type "%s"'%type(char))
  o = ord(char)
  if o<256:
    return o
  else:
    return o-96
"""

def gtkChildrenSearchType(widget, wType):
  ls = []
  if type(widget)==wType:
    ls.append(widget)
  try:
    childs = widget.get_children()
  except AttributeError:
    try:
      childs = [widget.child]
    except AttributeError:
      return ls
  for child in childs:
    if type(child)==wType:
      ls.append(child)
    ls2 = gtkChildrenSearchType(child, wType)
    if ls2==[]:
      continue
    else:
      ls += ls2
  return ls

(screenW, screenH) = rootWindow.get_size()

# How to define icon of custom stock????????????
#gtk.stock_add((
#('gtk-evolution', 'E_volution', gdk.BUTTON1_MASK, 0, 'gtk20')



licenseText=_('licenseText')
if licenseText=='licenseText':
  licenseText=file('%s/license'%srcDir).read()




def fontBottonDragBegin(fontb, context, parent):
    #print 'fontBottonDragBegin'## caled before dragCalDataGet
    textLay = parent.create_pango_layout(fontb.get_font_name())
    ##textLay.set_font_description(pango.FontDescription(fontb.get_font_name()))
    if not fontUseDefault:
       textLay.set_font_description(pango.FontDescription(fontCustom))
    (w, h) = textLay.get_pixel_size()
    pmap = gdk.Pixmap(None, w, h, 24)
    pmap.draw_layout(pmap.new_gc(), 0, 0, textLay, gdk.Color(0, 0, 0), gdk.Color(-1, -1, -1))## , foreground, background)
    pbuf = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, w, h)
    pbuf.get_from_drawable(pmap, parent.get_screen().get_system_colormap(), 0, 0, 0, 0, -1, -1)
    #fontb.drag_source_set_icon_pixbuf(pbuf)
    context.set_icon_pixbuf(pbuf, -16, -10)
    return True

"""
def fontBottonDragBegin(fontb, context, parent):
  fb = gtk.FontButton(fontb.get_font_name())
  fb.show_all()
  fb.realize()
  context.set_icon_widget(fb, 0, 0)
  return True

def fontBottonDragBegin(fontb, context, parent):
  w = fontb.allocation.width
  h = fontb.allocation.height
  pbuf = gtk.gdk.Pixbuf(gdk.COLORSPACE_RGB, False, 8, w, h)
  colormap = fontb.get_screen().get_system_colormap()
  #colormap = fontb.window.get_colormap()
  pbuf.get_from_drawable(fontb.window, colormap, 0, 0, 0, 0, w, h)
  context.set_icon_pixbuf(pbuf, 0, 0)
  return True

def fontBottonDragBegin(fontb, context, parent):
  w = fontb.allocation.width
  h = fontb.allocation.height
  context.set_icon_widget(fontb.window.get_image(0, 0, w, h), 0, 0)
  return True
"""



def fontButtonDragDataGet(fontb, context, selection, target_id, etime):
    #print 'fontButtonDragDataGet'
    selection.set_text(fontb.get_font_name())
    return True

def fontButtonDragDataRec(fontb, context, x, y, selection, target_id, etime):
    #dtype = selection.get_data_type()
    #print dtype ## UTF8_STRING
    text = selection.get_text()
    #print 'fontButtonDragDataRec  text=', text
    if text!=None:
      fontb.set_font_name(text)
    return True

def fontBottonDefineDrag(fontb, parent):
    fontb.drag_source_set(gdk.MODIFIER_MASK, (('a',1,1),), gdk.ACTION_COPY)
    fontb.drag_source_add_text_targets()
    fontb.connect('drag-data-get', fontButtonDragDataGet)
    fontb.connect('drag-begin', fontBottonDragBegin, parent)
    fontb.drag_dest_set(gdk.MODIFIER_MASK, (('b',0,0),), gdk.ACTION_COPY)
    fontb.drag_dest_add_text_targets()
    fontb.connect('drag-data-received', fontButtonDragDataRec)

def set_tooltip(widget, text):
  try:
    widget.set_tooltip_text(text)## PyGTK 2.12 or above
  except AttributeError:
    try:
      widget.set_tooltip(gtk.Tooltips(), text)
    except:
      myRaise(__file__)


class MyColorButton(gtk.ColorButton): ## for tooltip text
  def __init__(self):
    gtk.ColorButton.__init__(self)
    self.connect('color-set', self.update_tooltip)
    #self.set_direction(gtk.TEXT_DIR_LTR)
    """self.tt_win = gtk.Window()
    self.tt_win.set_decorated(False)
    self.tt_win.set_property('skip-taskbar-hint', False)
    self.tt_label = gtk.Label()
    self.tt_label.show()
    self.tt_win.add(self.tt_label)
    self.set_tooltip_window(self.tt_win)"""
  def update_tooltip(self, colorb=None):
    try:
      c = self.get_color()
      if self.get_use_alpha():
        text = '%s\n%s\n%s\n%s'%(c.red/256, c.green/256, c.blue/256, self.get_alpha()/256)
      else:
        text = '%s\n%s\n%s'%(c.red/256, c.green/256, c.blue/256)
      ##self.get_tooltip_window().set_direction(gtk.TEXT_DIR_LTR)
      ##print self.get_tooltip_window()
      self.set_tooltip_text(text) ##???????????????? Right to left
      #self.tt_label.set_label(text)##???????????? Dosent work
      ##self.set_tooltip_window(self.tt_win)
    except AttributeError:## Old PyGTK
      pass
      #myRaise(__file__)
  def set_color(self, color):
    gtk.ColorButton.set_color(self, color)
    self.update_tooltip()
  def set_alpha(self, alpha):
    gtk.ColorButton.set_alpha(self, alpha)
    self.update_tooltip()


needRestartPref = {}
for key in ('lang', 'winTaskbar', 'showYmArrows'): # 'showWinController', What other???? 
  needRestartPref[key] = eval(key)

def checkNeedRestart():
  for key in needRestartPref.keys():
    if needRestartPref[key] != eval(key):
      return True
  return False

focusTime = 0

menuActiveLabelColor = "#ff0000"

class MonthLabel(gtk.EventBox):
  highlightColor = gdk.Color(45000, 45000, 45000)
  getItemStr = lambda self, i: numLocal(i+1, fillZero=2)
  #getBoldStr = lambda self, s: '<b>%s</b>'%s
  getBoldStr = lambda self, s: '<span color="%s">%s</span>'%(menuActiveLabelColor, s)
  ##getItemStr = lambda self, i, mode: '%s: %s'%(numLocal(i+1, fillZero=2), monthName[mode][i])
  def __init__(self, mode, active=0):
    assert 0<=active<12
    gtk.EventBox.__init__(self)
    #self.set_border_width(1)#???????????
    #self.highlightColor=self.style.fg[gtk.STATE_PRELIGHT]##???????? how to get color from current theme
    self.mode = mode
    self.module = cal.modules[mode]
    s = _(self.module.monthName[active]) ##?????? getMonthLen(m, y)
    if boldYmLabel:
      s = '<b>%s</b>'%s
    self.label = gtk.Label(s)
    self.label.set_use_markup(True)
    self.add(self.label)
    menu = gtk.Menu()
    menuLabels = []
    for i in range(12):
      if monthRMenuNum:
        text = '%s: %s'%(self.getItemStr(i), _(self.module.monthName[i]))
      else:
        text = _(self.module.monthName[i])
      if i==active:
        text = self.getBoldStr(text)
      label = gtk.Label(text)
      #label.set_justify(gtk.JUSTIFY_LEFT)
      label.set_alignment(0, 0.5)
      label.set_use_markup(True)
      item = gtk.MenuItem()
      item.set_right_justified(True) ##?????????
      item.add(label)
      item.connect('activate', self.item_activate, i)
      menu.append(item)
      menuLabels.append(label)
    menu.show_all()
    self.menu = menu
    self.menuLabels = menuLabels
    self.connect('button-press-event', self._button_press)
    self.active = active
    self.set_active(active)
    ##########
    #self.menu.connect('map', lambda obj: self.drag_highlight())
    #self.menu.connect('unmap', lambda obj: self.drag_unhighlight())
    #########
    self.connect('enter-notify-event', self.highlight)
    self.connect('leave-notify-event', self.unhighlight)
    ####### update menu width
    if rtl:
      get_menu_pos = lambda widget: (screenW, 0, True)
      menu.popup(None, None, get_menu_pos, 3, 0)
      menu.hide()
  def set_active(self, active):
  ## (Performance) update menu here, or make menu entirly before popup ????????????????
    #assert 0<=active<12
    if monthRMenuNum:
      self.menuLabels[self.active].set_label('%s: %s'%(self.getItemStr(self.active), _(self.module.monthName[self.active])))
      s = _(self.module.monthName[active])
      self.menuLabels[active].set_label(self.getBoldStr('%s: %s'%(self.getItemStr(active), s)))
    else:
      self.menuLabels[self.active].set_label(_(self.module.monthName[self.active]))
      s = _(self.module.monthName[active])
      self.menuLabels[active].set_label(self.getBoldStr(s))
    if boldYmLabel:
        self.label.set_label('<b>%s</b>'%s)
    else:
        self.label.set_label(s)
    if lang>1:
      try:
        self.set_tooltip_text(self.module.monthName[active])### english, not translation
      except:
        pass
    self.active = active
  def change_mode(self, mode):
    self.mode = mode
    self.module = cal.modules[mode]
    if boldYmLabel:
      self.label.set_label('<b>%s</b>'%_(self.module.monthName[self.active]))
    else:
      self.label.set_label(_(self.module.monthName[self.active]))
    if monthRMenuNum:
      for i in range(12):
        self.menuLabels[i].set_label('%s: %s'%(self.getItemStr(i), _(self.module.monthName[i])))
    else:
      for i in range(12):
        self.menuLabels[i].set_label(_(self.module.monthName[i]))
  def item_activate(self, widget, item):
    self.set_active(item)
    self.emit('changed', item)
  def _button_press(self, widget, event):
    global focusTime
    if event.button==3:
      (x, y) = self.window.get_origin()
      y += self.allocation.height
      if rtl:
        mw = self.menu.allocation.width
        #print 'menu.allocation.width', mw
        if mw>1:
          x -= (mw - self.allocation.width)
      #x -= 7 ## ????????? because of menu padding
      focusTime = time.time()
      self.menu.popup(None, None, lambda widget: (x, y, True), event.button, event.time)
      return True
    else:
      return False
  def highlight(self, widget=None, event=None):
    #self.drag_highlight()
    if self.window==None:
      return
    cr = self.window.cairo_create()
    cr.set_source_color(self.highlightColor)
    #print tuple(self.allocation), tuple(self.label.allocation)
    (x, y, w, h) = self.allocation
    cr.rectangle(0, 0, w, 1)
    cr.fill()
    cr.rectangle(0, h-1, w, 1)
    cr.fill()
    cr.rectangle(0, 0, 1, h)
    cr.fill()
    cr.rectangle(w-1, 0, 1, h)
    cr.fill()
    cr.clip()
  def unhighlight(self, widget=None, event=None):
    #self.drag_unhighlight()
    if self.window==None:
      return
    (x, y, w, h) = self.allocation
    self.window.clear_area(0, 0, w, 1)
    self.window.clear_area(0, h-1, w, 1)
    self.window.clear_area(0, 0, 1, h)
    self.window.clear_area(w-1, 0, 1, h)


class IntLabel(gtk.EventBox):
  highlightColor = gdk.Color(45000, 45000, 45000)
  #getBoldStr = lambda self, s: '<b>%s</b>'%s
  getBoldStr = lambda self, s: '<span color="%s">%s</span>'%(menuActiveLabelColor, s)
  def __init__(self, height=9, active=0):
    gtk.EventBox.__init__(self)
    #self.set_border_width(1)#???????????
    self.height = height
    #self.delay = delay
    if boldYmLabel:
      s = '<b>%s</b>'%numLocal(active)
    else:
      s = numLocal(active)
    self.label = gtk.Label(s)
    self.label.set_use_markup(True)
    self.add(self.label)
    menu = gtk.Menu()
    ##########
    item = gtk.MenuItem()
    arrow = gtk.Arrow(gtk.ARROW_UP, gtk.SHADOW_IN)
    item.add(arrow)
    arrow.set_property('height-request', 10)
    #item.set_border_width(0)
    #item.set_property('height-request', 10)
    #print item.style_get_property('horizontal-padding') ## OK
    ###???????????????????????????????????
    #item.config('horizontal-padding'=0)
    #style = item.get_style()
    #style.set_property('horizontal-padding', 0)
    #item.set_style(style)
    menu.append(item)
    item.connect('select', self.arrow_select, -1)
    item.connect('deselect', self.arrow_deselect)
    item.connect('activate', lambda wid: False)
    ##########
    menuLabels = []
    for i in range(height):
      label = gtk.Label()
      label.set_use_markup(True)
      item = gtk.MenuItem()
      item.add(label)
      item.connect('activate', self.item_activate, i)
      menu.append(item)
      menuLabels.append(label)
    menu.connect('scroll-event', self.menuScroll)
    ##########
    item = gtk.MenuItem()
    arrow = gtk.Arrow(gtk.ARROW_DOWN, gtk.SHADOW_IN)
    arrow.set_property('height-request', 10)
    item.add(arrow)
    menu.append(item)
    item.connect('select', self.arrow_select, 1)
    item.connect('deselect', self.arrow_deselect)
    ##########
    menu.show_all()
    self.menu = menu
    self.menuLabels = menuLabels
    self.connect('button-press-event', self._button_press)
    self.active = active
    self.set_active(active)
    self.start = 0
    self._remain = 0
    self.etime = 0
    self.step = 0
    ##########
    #self.menu.connect('map', lambda obj: self.drag_highlight())
    #self.menu.connect('unmap', lambda obj: self.drag_unhighlight())
    #########
    #self.modify_base(gtk.STATE_NORMAL, gdk.Color(-1, 0, 0))#??????????
    self.connect('enter-notify-event', self.highlight)
    self.connect('leave-notify-event', self.unhighlight)
  def set_active(self, active):
    if boldYmLabel:
      self.label.set_label('<b>%s</b>'%numLocal(active))
    else:
      self.label.set_label(numLocal(active))
    self.active = active
  def update_menu(self, start=None):
    if start==None:
      start = self.active - self.height/2
    self.start = start
    for i in range(self.height):
      if start+i==self.active:
        self.menuLabels[i].set_label(self.getBoldStr(numLocal(start+i)))
      else:
        self.menuLabels[i].set_label(numLocal(start+i))
  def item_activate(self, widget, item):
    self.set_active(self.start+item)
    self.emit('changed', self.start+item)
  def _button_press(self, widget, event):
    global focusTime
    if event.button==3:
      self.update_menu()
      (x, y) = self.window.get_origin()
      y += self.allocation.height
      x -= 7 ## ????????? because of menu padding
      focusTime = time.time()
      self.menu.popup(None, None, lambda widget: (x, y, True), event.button, event.time)
      return True
    else:
      return False
  def arrow_select(self, item, plus):
    self._remain = plus
    timeout_add(int(labelMenuDelay*1000), self._arrow_remain, plus)
  def arrow_deselect(self, item):
    self._remain = 0
  def _arrow_remain(self, plus):
    t = time.time()
    #print t-self.etime
    if self._remain==plus:
      if t-self.etime<labelMenuDelay-0.02:
        if self.step>1:
          self.step = 0
          return False
        else:
          self.step += 1
          self.etime = t #??????????
          return True
      else:
        self.update_menu(self.start+plus)
        self.etime = t
        return True
    else:
      return False
  def menuScroll(self, widget, event):
    d = event.direction.value_nick
    if d=='up':
      self.update_menu(self.start-1)
    elif d=='down':
      self.update_menu(self.start+1)
    else:
      return False
  def highlight(self, widget=None, event=None):
    #self.drag_highlight()
    if self.window==None:
      return
    cr = self.window.cairo_create()
    cr.set_source_color(self.highlightColor)
    (x, y, w, h) = self.allocation
    cr.rectangle(0, 0, w, 1)
    cr.fill()
    cr.rectangle(0, h-1, w, 1)
    cr.fill()
    cr.rectangle(0, 0, 1, h)
    cr.fill()
    cr.rectangle(w-1, 0, 1, h)
    cr.fill()
    cr.clip()
  def unhighlight(self, widget=None, event=None):
    #self.drag_unhighlight()
    if self.window==None:
      return
    (x, y, w, h) = self.allocation
    self.window.clear_area(0, 0, w, 1)
    self.window.clear_area(0, h-1, w, 1)
    self.window.clear_area(0, 0, 1, h)
    self.window.clear_area(w-1, 0, 1, h)

gobject.type_register(MonthLabel)
gobject.signal_new('changed', MonthLabel, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [int])
gobject.type_register(IntLabel)
gobject.signal_new('changed', IntLabel, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [int])



## What is "GTK Window Decorator" ?????????? 
class WinController(gtk.HBox):
  BUTTON_MIN     = 0
  BUTTON_MAX     = 1
  BUTTON_CLOSE   = 2
  #BUTTON_STICK
  #BUTOON_ABOVE
  #BUTTON_BELOW
  SEP            = 4
  IMAGE_NAMES    = (('button-min.png', 'button-min-focus.png'),
                    ('button-max.png', 'button-max-focus.png'),
                    ('button-close.png', 'button-close-focus.png'))
  IMAGE_INACTIVE = 'button-inactive.png'
  TOOLTIPS = (_('Minimize Window'), _('Maximize Window'), _('Close Window'))
  def __init__(self, gtk_win, reverse=False, button_size=23, spacing=0):
    gtk.HBox.__init__(self, spacing=spacing)
    """cache=[]
    for i in range(3):### 3 or more ??????????
      im0 = gtk.Image()
      im0.set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[i][0]))
      im1 = gtk.Image()
      im1.set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[i][1]))
      cache.append((im0,im1))
    self.image_cache = cache
    self.image_inactive = gtk.Image()
    self.image_inactive.set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_INACTIVE))"""
    ###########
    if winTaskbar:
      buttons=[self.SEP, self.BUTTON_MIN, self.BUTTON_CLOSE]
    else:
      buttons=[self.SEP, self.BUTTON_CLOSE]
    if reverse:
      buttons.reverse()
    self.buttons = buttons
    self.images = [None]*3 ## 3 or more??????????
    for b in buttons:
      ev = gtk.EventBox()
      if b==self.SEP:
        self.pack_start(ev, 1, 1)
      else:
        im = gtk.Image()
        im.set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[b][0]))
        im.set_size_request(button_size, button_size)
        self.images[b] = im
        ev.add(im)
        ev.connect('enter-notify-event', self.button_enter_notify, b)
        ev.connect('leave-notify-event', self.button_leave_notify, b)
        ev.connect('button-press-event', self.button_press, b)
        ev.connect('button-release-event', self.button_release, b)
        try:
          ev.set_tooltip_text(self.TOOLTIPS[b])
        except AttributeError:## Oly PyGTK
          pass
        self.pack_start(ev, 0, 0)
    self.set_property('can-focus', True)
    ##################
    self.gtk_win = gtk_win
    ##gtk_win.connect('focus-in-event', self.window_focus_in)
    ##gtk_win.connect('focus-out-event', self.window_focus_out)
    self.gtk_win_focus = True
  #def motion_notify(self, widget, event):
  #  print 'motion_notify', time.time()
  def button_enter_notify(self, widget, event, num):
    self.images[num].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[num][1]))
  def button_leave_notify(self, widget, event, num):
    if self.gtk_win_focus:
      self.images[num].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[num][0]))
    else:
      self.images[num].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_INACTIVE))
    return False
  def button_press(self, widget, event, num):
    self.images[num].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[num][0]))
    return True
  def button_release(self, widget, event, num):
    if event.button!=1:
      return False
    if 0 <= event.x < widget.allocation.width and 0 <= event.y < widget.allocation.height:
      if num==self.BUTTON_MIN:
        self.gtk_win.iconify()
      elif num==self.BUTTON_MAX:
        if self.gtk_win.is_maximized:
          self.gtk_win.unmaximize()
        else:
          self.gtk_win.maximize()
      elif num==self.BUTTON_CLOSE:
        self.gtk_win.emit('delete-event', event)
    return False
  def window_focus_in(self, widget=None, event=None):
    for b in self.buttons:
      if b!=self.SEP:
        self.images[b].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_NAMES[b][0]))
    self.gtk_win_focus = True
    return False
  def window_focus_out(self, widget=None, event=None):
    for b in self.buttons:
      if b!=self.SEP:
        self.images[b].set_from_file('%s/wm/%s'%(pixDir, self.IMAGE_INACTIVE))
    self.gtk_win_focus = False
    return False
  

gtk.window_set_default_icon_from_file('%s%sstarcal.png'%(pixDir,os.sep))

if firstWeekDayAuto:
  firstWeekDay = getLocaleFirstWeekDay()

#if weekNumberModeAuto:##???????????????????????
#  weekNumberMode = getLocaleweekNumberMode()
weekNumberModeAuto = False

#print 'weekNumberModeAuto =', weekNumberModeAuto
#print 'weekNumberMode =', weekNumberMode

if lang==0:#???????????????????????
  weekDayNameSyn = os.popen('locale abday').read()[:-1].split(';')
  weekDayName = os.popen('locale day').read()[:-1].split(';')
  ##monthNameSyn[0] = os.popen('locale abmon')[:-1].read().split(';')
  #monthName[0] = os.popen('locale mon').read()[:-1].split(';')
  #rtl = os.popen('locale cal_direction').read()=='3\n'
  ##clockFormat = os.popen('locale t_fmt').read()
  ##dateFormat = os.popen('locale d_fmt').read()



#if hasattr(gtk, 'image_new_from_file'):
#  image_from_file = gtk.image_new_from_file
def image_from_file(path):
  im = gtk.Image()
  im.set_from_file(path)
  return im
  

n = len(plugIndex)
m = len(allPlugList)
i = 0
while i<n:
  if plugIndex[i]<m:
    i += 1
  else:
    plugIndex.pop(i)
    n -= 1
del n, m, i

if menuTextColor==None:
  menuTextColor = borderTextColor


