#!/usr/bin/python
# -*- coding: utf-8 -*-
#    
#    Copyright (C) 2007  Mola Pahnadayan
#    Copyright (C) 2009  Saeed Rasooli <saeed.gnu@gmail.com> (ilius)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program. If not, see <http://www.gnu.org/licenses/gpl.txt>.
#    Or on Debian systems, from /usr/share/common-licenses/GPL


import common as com
from common import rootWindow, cal, myRaise, numLocal, showYmArrows, rtl, rtlSgn,\
timeout_add, gobject, time, sys, os, gtk, gdk, pango, FClockLabel, set_tooltip

_ = com.translator

from math import pi
import struct
import os.path, cairo, desktop
#import wallpaper

from xml.dom.minidom import parse #, getDOMImplementation
#from xml.parsers.expat import ExpatError

t0 = time.time()


def fillColorA(cr, color, alpha):
  cr.set_source_rgba(color.red   /65535.0,
                     color.green /65535.0,
                     color.blue  /65535.0,
                     alpha       /65535.0)
  cr.fill()


class Cell:## status and information of a cell
  def __init__(self):
    self.day = 1
    self.dates = [None for i in range(cal.modNum)]
    self.gray = 0
    self.holiday = False
    self.customday = None
    self.extraday = ''


class MonthStatus(list):
  def __init__(self):
    list.__init__(self)



def _get_text(nodelist):
  rc = u''
  name = nodelist.nodeName
  for node in nodelist.childNodes:
      if node.nodeType == node.TEXT_NODE:
          rc = rc + node.data
  return name, rc.strip()

class PCal(gtk.DrawingArea):## or gtk.Widget
  def __init__(self):
    gtk.Widget.__init__(self)
    if not hasattr(self, 'is_composited'):
      self.is_composited = lambda: False
  def do_realize(self):
    self.set_flags(self.flags() | gtk.REALIZED)
    self.window = gdk.Window(
                             self.get_parent_window(), 
                             width=self.allocation.width, 
                             height=self.allocation.height, 
                             window_type=gdk.WINDOW_CHILD, 
                             wclass=gdk.INPUT_OUTPUT, 
                             event_mask=self.get_events() | gdk.EXPOSURE_MASK
                             | gdk.BUTTON1_MOTION_MASK | gdk.BUTTON_PRESS_MASK
                             | gdk.POINTER_MOTION_MASK | gdk.POINTER_MOTION_HINT_MASK)
                             #colormap=self.get_screen().get_rgba_colormap())
    #self.window.set_composited(True)
    #print 'window.get_depth()', self.window.get_depth()
    self.window.set_user_data(self)
    #self.style.attach(self.window)#?????? Needed??
    self.style.set_background(self.window, gtk.STATE_NORMAL)
    self.window.move_resize(*self.allocation)
    #self.set_property('height-request', com.calHeightReq)
    #self.window.enable_synchronized_configure()##???????????
    #self.window.set_override_redirect(True)## TMP
    ############
    """
    screen = self.get_screen()
    colormap = screen.get_rgba_colormap()
    if screen.is_composited() and colormap!=None:
      self.set_colormap(colormap)
      #self.have_argb_visual = True
    else:
      self.set_colormap(screen.get_default_colormap())
      #self.have_argb_visual = False
    """






gobject.type_register(PCal)


class MainDialog(gtk.Window):
  calMinW = 480 ## minimum suitable width for calendar (window_width - 18). user CAN NOT resize window to a smaller
  cx = [0, 0, 0, 0, 0, 0, 0] ##[(w-self.calMinW)/14 + (w-com.calLeftMargin)*(7-j)/7 for j in xrange(7)]
  days=[]
  calW = calMinW
  menuCellWidth = 145
  menuMainWidth = 145
  def updateTextWidth(self):
    lay = self.create_pango_layout('') ## a pango.Layout object
    if com.fontUseDefault:
      lay.set_font_description(pango.FontDescription(com.fontDefault))
    else:
      lay.set_font_description(pango.FontDescription(com.fontCustom))
    ############### update width of month labels
    width = []
    for module in cal.modules:
      wm = 0
      for m in range(module.getMonthsInYear(None)):
        name = _(module.getMonthName(m, None))
        if com.boldYmLabel:
          lay.set_markup('<b>%s</b>'%name)
        else:
          lay.set_text(name) ## OR lay.set_markup
        w = lay.get_pixel_size()[0]
        if w > wm:
          wm = w
      width.append(wm)
    #self.monthLabel[0].set_property('width-request', width[com.primaryMode])
    for i in xrange(len(com.shownDates)):
      mode = com.shownDates[i]['mode']
      if mode!=cal.DATE_JD:
        self.monthLabel[i].set_property('width-request', width[mode])
    ############# update width of week days names (to understand may be synopsis or no)
    wm = 0 ## max width
    for i in xrange(7):
      lay.set_text(com.weekDayName[i])
      w = lay.get_pixel_size()[0] ## ???????? returns larger that real size!!
      #w = lay.get_pixel_extents()[0] ## ????????
      #print w, 
      if w > wm:
        wm = w
    self.wdaysWidth = wm*7 + com.calLeftMargin ## ????????
    #self.wdaysWidth = wm*7*0.7 + com.calLeftMargin ## ????????
    #print 'max =', wm, '   wdaysWidth =', self.wdaysWidth
  def saveLiveConf(self, widget=None, event=None):
    #print 'mainWin.saveLiveConf() called'
    tm = time.time()
    if tm-self.confEvTime > 1.0:
      com.saveLiveConf()
      #print 'com.saveLiveConf', tm
      return False ## Finish loop
    return True ## Continue loop
  def screenChanged(self, widget, event=None):
    screen = widget.get_screen()
    try:
      colormap = screen.get_rgba_colormap()
    except AttributeError:
      colormap = screen.get_rgb_colormap()
    if colormap == None:
      colormap = screen.get_rgb_colormap()
      print 'colormap==None'
    widget.set_colormap(colormap)
    return False
  def hide_list(self, widgets):
    for w in widgets:
      w.hide()
  def show_list(self, widgets):
    for w in widgets:
      w.show()
  def show_all_list(self, widgets):
    for w in widgets:
      w.show_all()
  def onRootWinEvent(self, event):
    print event.type.value_name, time.time()
    return True
  def __init__(self, year, month, day, starcal):
    gtk.Window.__init__(self)##, gtk.WINDOW_POPUP) ## ????????????
    ##################
    self.kTime = 0
    self.starcal = starcal
    self.day=day
    self.month=month
    self.year=year
    #########
    self.set_decorated(False)
    self.set_property('skip-taskbar-hint', not com.winTaskbar)
    self.set_role('starcal')
    #self.set_focus_on_map(True)#????????
    self.set_default_size(com.winWidth, 1)
    #############################################################
    self.cal = PCal()
    lowerWin = gtk.Window()## gtk.WINDOW_POPUP) #?????????????????
    self.add_events(gdk.POINTER_MOTION_MASK | gdk.FOCUS_CHANGE_MASK | gdk.BUTTON_MOTION_MASK |
                    gdk.BUTTON_PRESS_MASK | gdk.BUTTON_RELEASE_MASK | gdk.SCROLL_MASK |
                    gdk.KEY_PRESS_MASK | gdk.VISIBILITY_NOTIFY_MASK | gdk.EXPOSURE_MASK)
    lowerWin.add_events(gdk.POINTER_MOTION_MASK | gdk.FOCUS_CHANGE_MASK | gdk.BUTTON_MOTION_MASK |
                    gdk.BUTTON_PRESS_MASK | gdk.BUTTON_RELEASE_MASK | gdk.SCROLL_MASK |
                    gdk.KEY_PRESS_MASK | gdk.VISIBILITY_NOTIFY_MASK | gdk.EXPOSURE_MASK)
    ######################
    self.cal.drag_source_set(gdk.MODIFIER_MASK,(('',0,0),),gdk.ACTION_COPY)
    self.cal.drag_source_add_text_targets()
    self.cal.connect('drag-data-get', self.dragCalDataGet)
    self.cal.connect('drag-begin', self.dragCalBegin)
    self.cal.connect('drag-data-received', self.dragCalDataRec)
    self.cal.drag_dest_set(gdk.MODIFIER_MASK,\
      (('', 0, 0),('application/x-color', 0, 0)), gdk.ACTION_COPY)
    self.cal.drag_dest_add_text_targets()
    self.cal.drag_dest_add_uri_targets()
    
    
    """
    
    ## ACTION_MOVE ?????????????????????
    ## if source ACTION was ACTION_COPY, calendar recieves its own dragged day
    ## just like gnome-calendar-applet (but it seems not a logical behaviar)
    #self.cal.drag_source_add_uri_targets()#???????
    ##self.cal.connect('drag-end', self.dragCalEnd)
    ##self.cal.connect('drag-drop', self.dragCalDrop)
    ##self.cal.connect('drag-failed', self.dragCalFailed)
    #self.cal.connect('drag-leave', self.dragCalLeave)
    """
    #######################
    self.cal.connect('expose-event', self.updateCalAll)
    self.connect('focus-in-event', self.focusIn, 'Main')
    self.connect('focus-out-event', self.focusOut, 'Main')
    lowerWin.connect('focus-in-event', self.focusIn, 'Lower')
    lowerWin.connect('focus-out-event', self.focusOut, 'Lower')
    self.cal.connect('button-press-event', self.calButtonPress)
    self.connect('button-press-event', self.buttonPress)
    #self.connect('map', lambda widget: lowerWin.show())
    self.connect('map', self.window_map)
    self.connect('unmap', lambda widget: lowerWin.hide())
    self.connect('key-press-event', self.keyPress)
    self.connect('scroll-event', self.scroll)
    
    #self.cal.connect('realize', self.calRealize)
    #self.cal.connect('screen-changed', self.screenChanged)
    #self.connect('screen-changed', self.screenChanged)

    self.connect('configure-event', self.configureEvent)
    #lowerWin.connect('button-press-event', self.winActivate)##???????????????????? NOT WORKS
    
    
    self.connect('window-state-event', self.windowState)
    lowerWin.connect('window-state-event', self.windowState)


    lowerWin.connect('delete-event', self.starcal.dialogClose)
    lowerWin.connect('key-press-event', self.keyPress)
    #lowerWin.connect('realize', lambda obj: lowerWin.window.set_override_redirect(True))
    
    
    self.connect('button-release-event', self.buttonRelease)
    #self.connect('check-resize', self.checkWinResize)
    #self.connect('event', com.show_event)
    """
    #self.movingButton=0
    #self.connect('button-release-event', self.buttonRelease)
    #self.add_events(gdk.VISIBILITY_NOTIFY_MASK)
    #self.connect('frame-event', com.show_event)
    ## Compiz does not send configure-event(or any event) when MOVING window(sends in last point,
    ## when moving completed)
    #self.connect('drag-motion', com.show_event)
    com.rootWindow.set_events(...   
    com.rootWindow.add_filter(self.onRootWinEvent)
    #self.realize()
    #gdk.flush()
    #self.configureEvent(None, None)
    #self.connect('drag-motion', com.show_event)
    ######################
    ## ????????????????????????????????????????????????
    ## when button is down(before button-release-event), motion-notify-event does not recived!
    """
    ####################
    #self.calcCoord()##????????? Needed
    #self.cal.set_property('width-request',self.calMinW)#????????? set_size_request(self.calMinW, -1)
    self.today = [year, month, day]
    self.customDB = []
    self.months = {}
    self.cell = None
    #self.ocell = None
    ######## Transparency ????????????
    #self.set_opacity(0.5) ## Works with KWin and Compiz, not with Metacity(without any effects)
    #self.supports_alpha = self.cal.window.is_composited()
    #self.cal.do_realize()
    #if self.supports_alpha:
    self.cal.set_app_paintable(True)
    self.set_app_paintable(True)#????????
    #self.cal.add_events(gdk.BUTTON_PRESS_MASK)
    #self.cal.add_events(gdk.ALL_EVENTS_MASK)
    #self.add_events(gdk.VISIBILITY_NOTIFY_MASK)
    self.screenChanged(self)
    self.screenChanged(self.cal)
    ##################
    self.date_label = []
    self.statusBox = gtk.HBox()
    #n = com.shownDatesNum
    for i in xrange(cal.modNum):
      label = gtk.Label()
      label.set_use_markup(True)
      label.set_selectable(True)
      label.connect('populate-popup', self.populatePopup)
      self.date_label.append(label)
      self.statusBox.pack_start(label, 1, 0, 0)
      ####### How to make label's cursor to be invisible ???????????????
      ####### like gtk.TextView.set_cursor_visible
      #eb = gtk.EventBox()
      #eb.add(label)
      #self.statusBox.pack_start(eb, 1, 0, 0)
      #eb.connect('realize', lambda wid: eb.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.BOAT)))
      ## eb.window==None, label.window==None
    #####
    fixdHeightButton = gtk.ToggleButton()
    fixdHeightButton.set_image(gtk.image_new_from_stock(gtk.STOCK_GOTO_TOP, gtk.ICON_SIZE_SMALL_TOOLBAR))
    self.statusBox.pack_start(fixdHeightButton, 0, 0)
    self.fixdHeightButton = fixdHeightButton
    set_tooltip(fixdHeightButton, _('fixed-height calendar'))
    #####
    dockButton = gtk.ToggleButton()
    dockButton.set_image(gtk.image_new_from_stock(gtk.STOCK_GOTO_BOTTOM, gtk.ICON_SIZE_SMALL_TOOLBAR))
    self.statusBox.pack_start(dockButton, 0, 0)
    self.dockButton = dockButton
    dockButton.set_active(com.lowerDocked)
    dockButton.connect('toggled', self.dockButtonToggled)
    set_tooltip(dockButton, _('docked lower box'))
    #####
    sbar = gtk.Statusbar()
    if rtl:
      self.statusBox.set_direction(gtk.TEXT_DIR_LTR)
      #stderr = sys.stderr
      #sys.stderr = None
      ## GtkWarning: gdk_window_set_cursor: assertion `GDK_IS_WINDOW (window)' failed #???????????
      sbar.set_direction(gtk.TEXT_DIR_LTR) 
      #sys.stderr = stderr
    sbar.set_property('width-request', 18)
    sbar.connect('button-press-event', self.startResize)
    self.statusBox.pack_start(sbar, 0, 0)
    self.sbar = sbar
    ####
    self.lowerBox = gtk.VBox()
    #self.lowerBox.pack_start(self, 1, 1)
    self.extraText=gtk.TextView()
    self.extraText.set_wrap_mode(gtk.WRAP_WORD)
    self.extraText.set_editable(False)
    self.extraText.set_cursor_visible(False)
    self.extraText.set_justification(gtk.JUSTIFY_CENTER)
    self.extraTextBuf = self.extraText.get_buffer()
    self.lowerBox.pack_start(self.extraText, 0, 0)
    self.extraText.show()
    self.extraText.connect('populate-popup', self.populatePopup)
    ###########
    self.customDayHBox = gtk.HBox()
    self.customDayText = gtk.TextView()
    self.customDayText.set_wrap_mode(gtk.WRAP_WORD)
    self.customDayText.set_editable(False)
    self.customDayText.set_cursor_visible(False)
    #self.customDayText.set_justification(gtk.JUSTIFY_LEFT)
    self.customDayBuf = self.customDayText.get_buffer()
    self.customDayIcon = gtk.Image()
    self.customDayHBox.pack_start(self.customDayIcon, 0, 0)
    self.customDayHBox.pack_start(self.customDayText, 1, 1)
    self.hReq = -1
    self.lowerBox.connect('size-request', self.checkResize) #??????? Needed?
    self.lowerBox.pack_start(self.customDayHBox, 0, 0)#????????
    self.customDayHBox.show_all()
    self.customDayText.connect('populate-popup', self.populatePopup)
    self.lowerBox.show_all()
    ###########
    #self.extraText.connect('visibility-notify-event', self.lowerWinVisibilityNotify)
    #self.customDayText.connect('visibility-notify-event', self.lowerWinVisibilityNotify)
    self.extraText.connect('visibility-notify-event', self.winActivate)
    self.customDayText.connect('visibility-notify-event', self.winActivate)
    #self.extraText.connect('visibility-notify-event', self.winActivate, 'extraText:visibility-notify-event')
    ##lowerWin.connect('button-press-event', self.winActivate)##???????????????????? NOT WORKS
    self.extraText.connect('button-press-event', self.winActivate)
    self.customDayText.connect('button-press-event', self.winActivate)
    ##self.customDayIcon.connect('button-press-event', self.winActivate)##???????????????????? NOT WORKS
    ############
    lowerWin.set_decorated(False)
    lowerWin.set_property('skip-taskbar-hint', True)
    lowerWin.set_property('skip-pager-hint', True)
    lowerWin.set_title('starcal_lower_window')
    #self.lowerBox.show()
    #self.show_all = lowerWin.show_all
    self.lowerWin = lowerWin
    self.focus = False
    self.focusOutTime = 0
    self.winActive = False
    #self.connect('realize', lambda obj: self.window.set_override_redirect(True))
    ## problem when swiching from (foreign) "On Top" window to the lowerWin window.
    #win_sgroup = gtk.SizeGroup(gtk.SIZE_GROUP_HORIZONTAL)
    #win_sgroup.add_widget(self.lowerBox)
    ###########
    self.connect('destroy',self.starcal.quit)
    #################################### Building Toolbar #################################################
    toolbar=gtk.Toolbar()
    #toolbar.set_icon_size(gtk.ICON_SIZE_SMALL_TOOLBAR)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_HOME,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('Select Today'))
    tb.connect('clicked', self.goToday)
    toolbar.insert(tb, 0)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_INDEX,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('Select Date...'))
    tb.connect('clicked', self.starcal.selectDate)
    toolbar.insert(tb, -1)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_ADD,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('Add Custom Day'))
    tb.connect('clicked', self.starcal.showCustomDay)
    toolbar.insert(tb, -1)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_CONVERT,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('Export to HTML'))
    tb.connect('clicked', self.starcal.exportClicked)
    toolbar.insert(tb, -1)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_PREFERENCES,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('Preferences'))
    tb.connect('clicked', self.starcal.prefShow)
    toolbar.insert(tb, -1)
    #######
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_ABOUT,gtk.ICON_SIZE_SMALL_TOOLBAR))
    set_tooltip(tb, _('About StarCalendar'))
    tb.connect('clicked', self.starcal.aboutShow)
    toolbar.insert(tb, -1)
    #######
    if self.starcal.trayMode!=1:
      tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_QUIT,gtk.ICON_SIZE_SMALL_TOOLBAR))
      set_tooltip(tb, _('Quit'))
      tb.connect('clicked', self.starcal.quit)
      toolbar.insert(tb, -1)
      #self.quitToolButton = tb
    #######
    #toolbar.insert(gtk.SeparatorToolItem(), 3) ## OK
    #######
    self.toolbar = toolbar
    hbox = gtk.HBox()
    hbox.pack_start(toolbar, 1, 1)
    if com.showDigClockTb:
      self.clock = FClockLabel(com.clockFormat)
      hbox.pack_start(self.clock, 0, 0)
    else:
      self.clock = None
    self.toolbBox = hbox
    #####################################################################################################
    self.labelBox=gtk.HBox()
    #self.labelBox.set_border_width(2)
    self.wgroup = [[], [], []]
    self.yearNum = [None, None, None]
    self.monthLabel = [None, None, None]
    #############################
    if showYmArrows:
      self.labelBox.pack_start(gtk.Label(''), 0, 1)
      self.arrowL=gtk.Button()
      self.arrowL.set_relief(2)
      self.labelBox.pack_start(self.arrowL, 0, 0)
      self.wgroup[0].append(self.arrowL)
    self.yearNum[0]=com.IntLabel()
    self.yearNum[0].connect('changed', self.yearLabelChange, 0)
    self.labelBox.pack_start(self.yearNum[0], 0, 0)
    self.wgroup[0].append(self.yearNum[0])
    if showYmArrows:
      self.arrowR=gtk.Button()
      self.arrowR.set_relief(2)
      self.labelBox.pack_start(self.arrowR, 0, 0)
      self.wgroup[0].append(self.arrowR)
      sep = gtk.VSeparator()
      self.labelBox.pack_start(sep, 1, 1)
      self.wgroup[0].append(sep)
      self.arrowLM=gtk.Button()
      self.arrowLM.set_relief(2)
      self.labelBox.pack_start(self.arrowLM, 0, 0)
      self.wgroup[0].append(self.arrowLM)
    self.monthLabel[0]=com.MonthLabel(com.primaryMode)
    self.monthLabel[0].connect('changed', self.monthLabelChange)
    self.labelBox.pack_start(self.monthLabel[0], 0, 0)
    self.wgroup[0].append(self.monthLabel[0])
    if showYmArrows:
      self.arrowRM=gtk.Button()
      self.arrowRM.set_relief(2)
      self.labelBox.pack_start(self.arrowRM, 0, 0)
      self.wgroup[0].append(self.arrowRM)
      #######
      self.arrowsUpdate()
    sep = gtk.VSeparator()
    self.labelBox.pack_start(sep, 1, 1)
    self.wgroup[0].append(sep)
    self.wgroup[1].append(sep) ##??????????
    ################################
    self.yearNum[1]=com.IntLabel()
    self.yearNum[1].connect('changed', self.yearLabelChange, 1)
    self.labelBox.pack_start(self.yearNum[1], 0, 0)
    self.wgroup[1].append(self.yearNum[1])
    self.monthLabel[1]=com.MonthLabel(com.shownDates[1]['mode'])
    self.monthLabel[1].connect('changed', self.monthLabelChange)
    self.labelBox.pack_start(self.monthLabel[1], 0, 0)
    self.wgroup[1].append(self.monthLabel[1])
    #######
    sep = gtk.VSeparator()
    self.labelBox.pack_start(sep, 1, 1)
    self.wgroup[1].append(sep)
    self.wgroup[2].append(sep) ##??????????
    ###################################
    self.yearNum[2]=com.IntLabel()
    self.yearNum[2].connect('changed', self.yearLabelChange, 2)
    self.labelBox.pack_start(self.yearNum[2], 0, 0)
    self.wgroup[2].append(self.yearNum[2])
    self.monthLabel[2]=com.MonthLabel(com.shownDates[2]['mode'])
    self.monthLabel[2].connect('changed', self.monthLabelChange)
    self.labelBox.pack_start(self.monthLabel[2], 0, 0)
    self.wgroup[2].append(self.monthLabel[2])
    #######
    ###################################
    self.updateTextWidth()
    ######################
    self.labelBox.show_all()
    if showYmArrows:
      self.arrowL.connect('pressed',self.yearButtonPress,-1)
      self.arrowR.connect('pressed',self.yearButtonPress, 1)
      self.arrowL.connect('activate',self.yearButtonPress,-1, False)
      self.arrowR.connect('activate',self.yearButtonPress, 1, False)
      self.arrowL.connect('released',self.arrowRelease)
      self.arrowR.connect('released',self.arrowRelease)
      self.arrowLM.connect('pressed',self.monthButtonPress,-1)
      self.arrowRM.connect('pressed',self.monthButtonPress, 1)
      self.arrowLM.connect('activate',self.monthButtonPress,-1, False)
      self.arrowRM.connect('activate',self.monthButtonPress, 1, False)
      self.arrowLM.connect('released',self.arrowRelease)
      self.arrowRM.connect('released',self.arrowRelease)
      ###################
      set_tooltip(self.arrowL, _('Previous Year'))
      set_tooltip(self.arrowR, _('Next Year'))
      set_tooltip(self.arrowLM, _('Previous Month'))
      set_tooltip(self.arrowRM, _('Next Month'))
    ############################################################################################
    self.loadExtraDaysDB()
    self.loadCustomDB()
    self.computeCurrentMonth(True)
    self.updateYearMonthLabels()
    self.updateDateLabels()
    ####################
    self.vbox = gtk.VBox()
    ##############
    self.vbox.pack_start(self.toolbBox, 0, 0)
    self.vbox.pack_start(self.labelBox, 0, 0)
    if com.showWinController:
      self.buildWinCont()
    else:
      self.win_con = None
    ########
    self.cal.show()
    if com.calHeightReq==-1:
      #self.cal.set_property('height-request', -1) ## No need
      self.vbox.pack_start(self.cal, 1, 1)
      fixdHeightButton.set_active(False)
    else:
      self.cal.set_property('height-request', com.calHeightReq)
      self.vbox.pack_start(self.cal, 0, 0)
      fixdHeightButton.set_active(True)
    fixdHeightButton.connect('toggled', self.fixdHeightButtonToggled)
    ########
    self.vbox.pack_start(self.statusBox, 0, 0)
    self.add(self.vbox)
    self.vbox.show_all() ## needed ## NO NOT REMOVE
    ####################
    slabel=self.cell.extraday
    if slabel!='':
      self.extraTextBuf.set_text(slabel)
      if not self.extraText.get_property('visible'):
        self.extraText.show()
    elif self.extraText.get_property('visible'):
      self.extraText.hide()
    self.updateCustomDay()
    ############
    self.is_maximized = False
    self.expanding = False
    ############
    self.moving = False
    self.movingDef = (0, 0)
    self.toolbar.add_events(gdk.POINTER_MOTION_MASK)
    self.connect('motion-notify-event', self.updateManualMoving)
    ###########
    exp = gtk.Expander()
    #exp.set_resize_mode(gtk.RESIZE_PARENT)
    exp.set_expanded(True)
    exp.connect('activate', self.lowerExpanded)#????????????????????
    #exp.connect('button-press-event', self.lowerExpanded)
    #exp.connect('expose-event', self.expanderExpose)
    #exp.connect('event', com.show_event)
    self.vbox.pack_start(exp, 0, 0)
    if com.lowerDocked:
      exp.add(self.lowerBox)
      exp.set_expanded(com.lowerExpanded)
      exp.show()
    else:
      lowerWin.add(self.lowerBox)
      #lowerWin.show()
    self.lowerExp = exp
    #######
    self.confEvTime = 0
    ###############
    self.move(com.winX, com.winY)
    self.resize(com.winWidth, com.winHeight)
  def buildWinCont(self):
    self.win_con = com.WinController(self, reverse=True)
    self.win_con.set_property('height-request', 15)
    self.vbox.pack_start(self.win_con, 0, 0)
    self.vbox.reorder_child(self.win_con, 0)
    self.win_con.show_all()
  def destroyWinCont(self):
    self.win_con.destroy()
    self.win_con = None
  def fixdHeightButtonToggled(self, widget):
    if self.fixdHeightButton.get_active():
      com.calHeightReq = self.cal.allocation.height
      self.cal.set_property('height-request', com.calHeightReq)
      self.vbox.set_child_packing(self.cal, 0, 0, 0, gtk.PACK_START)
    else:
      com.calHeightReq = -1
      self.vbox.set_child_packing(self.cal, 1, 1, 0, gtk.PACK_START)
      self.cal.set_property('height-request', -1)
    com.saveLiveConf()
  def dockButtonToggled(self, widget):
    com.lowerDocked = self.dockButton.get_active()
    (ww, wh) = self.get_size()
    lh = self.lowerExp.allocation.height
    if com.lowerDocked:
      self.lowerWin.hide()
      self.lowerBox.reparent(self.lowerExp)
      self.lowerExp.show()
      if self.lowerExp.get_expanded():
        self.resize(ww, wh+lh)
      if com.calHeightReq!=-1:####???????????????????????????????? NOT WORKS
        self.resize(self.get_size()[0], 2)
        self.cal.queue_draw() #### queue_draw_area ???????????
    else:
      self.lowerExp.hide()
      self.lowerBox.reparent(self.lowerWin)
      if self.get_property('visible'):
        self.lowerWin.show()
      if self.lowerExp.get_expanded():
        self.resize(ww, wh-lh)
      (ww, wh) = self.get_size()
      (wx, wy) = self.get_position() ## ==self.window.get_origin()
      self.lowerWin.move(wx, wy+wh)
      if com.calHeightReq!=-1:####???????????????????????????????? NOT WORKS
        self.lowerWin.resize(self.lowerWin.get_size()[0], 2)
        self.cal.queue_draw() #### queue_draw_area ???????????
    #timeout_add(300, self.setWindowRounded)
  def lowerExpanded(self, widget, event=None):
    if com.calHeightReq!=-1:
      (ww, wh) = self.get_size()
      timeout_add(200, self.resize, ww, 2)
      """
      hp = self.lowerBox.allocation.height
      #print 'lowerExpanded: hp=%s\twinH=%s'%(hp, self.get_size()[1])
      if hp<2:
        timeout_add(100, self.lowerExpandedAfter, wh)
      else:
        if self.lowerExp.get_expanded():
          hp = -hp
        self.setWindowRounded(wh+hp)
    ######################
      #print wh, self.vbox.allocation.height
      #self.resize(ww, 2)
      #print wh, self.vbox.allocation.height
      #self.queue_resize()
      #print 'expanded =', self.lowerExp.get_expanded()
      #if self.lowerExp.get_expanded():
        #self.resize(ww, wh-self.lowerExp.allocation.height)
      #if self.lowerExp.get_expanded():
      #  self.lowerBox.hide()
      #else:
      #  self.lowerBox.show()
    #print time.time(), 'lowerExpanded'
    #self.cal.window.set_geometry_hints(max_height=self.cal.allocation.height)
    self.cal.set_property('height-request', self.cal.allocation.height)
    self.vbox.set_child_packing(self.cal, 0, 0, 0, gtk.PACK_START)
    #while gtk.events_pending():
    #  gtk.main_iteration_do(False)
    #self.resize_children()
    #self.check_resize()
    (ww, wh) = self.get_size()
    #self.queue_resize()
    #self.resize(ww, 2)
    #self.vbox.set_child_packing(self.cal, 1, 1, 0, gtk.PACK_START)
    #self.cal.set_property('height-request', -1)
    self.expanding = True
    lh = self.lowerBox.allocation.height
    if self.lowerExp.get_expanded():
      self.resize(ww, wh+lh)
    else:
      self.resize(ww, wh-lh)
    timeout_add(100, self.expanderExpose)
    
  def lowerExpandedAfter(self, wh):
    if self.lowerExp.get_expanded():
      hp = self.lowerBox.allocation.height
      #print 'lowerExpandedAfter: hp=%s\twinH=%s'%(hp, self.get_size()[1])
      if hp<2:
        timeout_add(100, self.lowerExpandedAfter, wh)
      else:
        self.setWindowRounded(wh+hp)
    #  if not self.lowerExp.get_expanded():
    #    hp = -hp
    #  self.setWindowRounded(hp)"""
  def window_map(self, widget):
    if not com.lowerDocked:
      (wx, wy) = self.window.get_origin()
      (ww, wh) = self.get_size()
      self.lowerWin.move(wx, wy+wh)
      self.lowerWin.show()
  """def unmap(self, widget):
    (com.winX, com.winY) = self.dialog.get_position()
    if widget==self:
      self.lowerWin.hide()
    elif widget==self.lowerWin:
      self.hide()
    return True"""
  def windowState(self, widget, event):
    if widget==self:
      other = self.lowerWin
      #print 'other = self.lowerWin'
      name = 'MainWin'
    elif widget==self.lowerWin:
      other = self
      #print 'other = self'
      name = 'LowerWin'
    else:
      print 'Unknown window!'
      return
    #print
    #print name, event.changed_mask, event.new_window_state
    #print dir(event)
    #return True
    ## PyGTK says: window unsticked just after sticked
    ## But the window is aleady sticky (after sticked ckeckbutton clicked)
    ## So PyGTK says wrong!!!!! ??????????????????????
    ## and PyGTK does not sent any signal, when window realy unsticked !!!
    ########################
    if event.changed_mask & gtk.gdk.WINDOW_STATE_ICONIFIED:
      if event.new_window_state & gtk.gdk.WINDOW_STATE_ICONIFIED:
        #print time.time(), name, 'was minimized!'
        #print event.changed_mask, event.new_window_state
        #print
        if widget==self:
          other.iconify()
      else:
        #print time.time(), name, 'was unminimized!'
        #print
        other.deiconify()
    if event.changed_mask & gtk.gdk.WINDOW_STATE_MAXIMIZED:
      self.is_maximized = bool(event.new_window_state & gtk.gdk.WINDOW_STATE_MAXIMIZED)
      #print 'is_maximized =', self.is_maximized
    return False
    """if event.changed_mask & gtk.gdk.WINDOW_STATE_STICKY:
      if event.new_window_state & gtk.gdk.WINDOW_STATE_STICKY:
        print name, 'was sticked!'
        #other.stick()
        #self.starcal.checkSticky.set_active(True)
      else:
        print name, 'was unsticked!'
        #other.unstick()
        #self.starcal.checkSticky.set_active(False)
    if event.changed_mask & gtk.gdk.WINDOW_STATE_ABOVE:
      if event.new_window_state & gtk.gdk.WINDOW_STATE_ABOVE:
        print name, 'was set above!'
        #other.set_keep_above(True)
        #self.starcal.checkAbove.set_active(True)
      else:
        print name, 'was set not above!'
        #other.set_keep_above(False)
        #self.starcal.checkAbove.set_active(True)
    if event.changed_mask & gtk.gdk.WINDOW_STATE_BELOW:
      if event.new_window_state & gtk.gdk.WINDOW_STATE_BELOW:
        print name, 'was set below!'
        #other.set_keep_below(True)
      else:
        print name, 'was set not below!'
        #other.set_keep_below(False)"""
  #def drag_motion(self, *args):
  #  print time.time(), args
  def populatePopup(self, widget, event):
    com.focusTime = time.time()
    self.winActivate()##????????????????????
  def focusIn(self, widegt, event, data=None):
    #print time.time(), 'focusIn'
    #print 'focusIn   ', data #, time.time()-self.focusOutTime, 'after last focusOut'
    #print 'focusIn   ', event.get_state(), event.get_axis(0), event.get_coords(), event.get_root_coords()
    #print dir(event)
    self.focus = True
    #self.set_keep_above(True)
    ##self.lowerWin.set_keep_above(True)
    #self.set_keep_below(False)
    ##self.lowerWin.set_keep_below(False)
    if self.win_con!=None:
      self.win_con.window_focus_in()
    #self.deiconify()#???????????
  def focusOut(self, widegt, event, data=None):
  ## runs 0.0004 sec (max) after focusIn (if swiched between two windows)
    #print time.time(), 'focusOut  '#, data #, time.time()%10
    #t = time.time()
    #if t-self.focusOutTime>0.0004:
    #self.focusOutTime = time.time()#t
    #############
    if self.moving:##?????????????????????????
      self.endManualMoving()
      return
    ##############
    dt = time.time()-com.focusTime
    #print 'menu dt=%s'%dt
    if dt>0.02: ## max=0.011 for first populate popup of textbiew
      self.focus = False
      self.winActive = False
      timeout_add(2, self.focusOutDo)
  def focusOutDo(self):
    #t = time.time()
    #print time.time(), 'focusOutDo'#, t-self.focusOutTime, 'after last focusOut\n'
    #self.focusOutTime = 0
    if not self.focus:# and t-self.focusOutTime>0.002:
      #self.focusOutTime = 0
      ab = self.starcal.checkAbove.get_active()
      self.set_keep_above(ab)
      self.lowerWin.set_keep_above(ab)
      #self.set_keep_below(not ab)
      ##self.lowerWin.set_keep_below(not ab)
      if self.win_con!=None:
        self.win_con.window_focus_out()
    return False
  def yearLabelChange(self, ylabel, item, num):
    mode = com.shownDates[num]['mode']
    (y, m, d) = self.cell.dates[mode]
    self.dateChange((item, m, d), mode)
  def monthLabelChange(self, mlabel, item):
    (y, m, d) = self.cell.dates[mlabel.mode]
    self.dateChange((y, item+1, d), mlabel.mode)
  def monthLabelUpdateMode(self):
    for i in xrange(len(self.monthLabel)):
      self.monthLabel[i].change_mode(com.shownDates[i]['mode'])
  def dragCalBegin(self, obj, context):
    com.focusTime = time.time()
    colormap = self.cal.get_screen().get_system_colormap()
    #colormap = self.cal.get_screen().get_rgba_colormap()
    #colormap = self.cal.window.get_colormap()
    if com.dragIconCell:
      (sx, sy) = self.cell.pos
      if com.cursorFixed:
        x = int(self.cx[sx]-com.cursorW/2.0-com.cursorD)
        y = int(self.cy[sy]-com.cursorH/2.0-com.cursorD)
        w = int(com.cursorW + 2*com.cursorD)
        h = int(com.cursorH + 2*com.cursorD) 
      else:
        x = int(self.cx[sx]-self.dx/2.0+1)
        y = int(self.cy[sy]-self.dy/2.0+1)
        w = int(self.dx)
        h = int(self.dy)
      (px, py) = self.pointer
      """
      #import pdb
      #pdb.set_trace()
      pmap = gdk.Pixmap(self.window, w, h, 32) ##???????????????????
      #pmap.get_visual().depth = 32
      print self.window.get_visual().depth
      #print pmap.get_visual().depth#??????????
      print self.window.get_depth()
      print pmap.get_depth()

      pmap.set_colormap(colormap)
      pmap.draw_drawable(pmap.new_gc(),self.cal.window,x,y,0,0,w,h) #a black thin outline ????????????????? ## X Error on On Ubuntu 9.10

       On Ubuntu 9.10:
      The program 'main.py' received an X Window System error.
This probably reflects a bug in the program.
The error was 'BadMatch (invalid parameter attributes)'.
  (Details: serial 9106 error_code 8 request_code 62 minor_code 0)
  (Note to programmers: normally, X errors are reported asynchronously;
   that is, you will receive the error a while after causing it.
   To debug your program, run it with the --sync command line
   option to change this behavior. You can then get a meaningful
   backtrace from your debugger if you break on the gdk_x_error() function.)
      """



      """cr = pmap.cairo_create()
      cr.set_line_width(0)#??????????????
      cr.rectangle(0, 0, w, h)
      cr.set_source_color(com.cursorOutColor)
      cr.fill()"""
      pbuf = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, w , h)
      pbuf.get_from_drawable(self.cal.window, colormap , x, y, 0, 0, w, h)
      
      ########## Making Cursor Mask
      ## round_oval ??????????
      mask = gdk.Pixmap(None, w, h, 1)
      cr = mask.cairo_create()
      cr.rectangle(0, 0, w, h)
      cr.set_operator(cairo.OPERATOR_CLEAR)
      cr.fill()
      cr.set_operator(cairo.OPERATOR_SOURCE)
      if com.cursorR==0:
        cr.rectangle(0, 0, w, h)
        cr.fill()
        return mask
      ## Circular Rounded
      ro = min(com.cursorR, w/2, h/2)
      ## Outline:
      x0 = y0 = 0
      #e = 0.2
      #x0 = 2*e
      #y0 = 2*e
      #w -= 2*e
      #h -= 2*e
      ####
      cr.move_to(x0+ro, y0)
      cr.line_to(x0+w-ro, y0)
      cr.arc(x0+w-ro, y0+ro, ro, 3*pi/2, 2*pi) ## up right corner
      cr.line_to(x0+w, y0+h-ro)
      cr.arc(x0+w-ro, y0+h-ro, ro, 0, pi/2) ## down right corner
      cr.line_to(x0+ro, y0+h)
      cr.arc(x0+ro, y0+h-ro, ro, pi/2, pi) ## down left corner
      cr.line_to(x0, y0+ro)
      cr.arc(x0+ro, y0+ro, ro, pi, 3*pi/2) ## up left corner
      #####
      """cr.move_to(ro, 0)
      cr.line_to(w-ro, 0)
      cr.arc(w-ro, ro, ro, 3*pi/2, 2*pi) ## up right corner
      cr.line_to(w, h-ro)
      cr.arc(w-ro, h-ro, ro, 0, pi/2) ## down right corner
      cr.line_to(ro, h)
      cr.arc(ro, h-ro, ro, pi/2, pi) ## down left corner
      cr.line_to(0, ro)
      cr.arc(ro, ro, ro, pi, 3*pi/2) ## up left corner"""
      ##
      cr.close_path()
      cr.fill()
      ############ End of Making Cursor Mask
      #context.set_icon_pixmap(colormap, pmap, mask, px-x, py-y)
      #pbuf.add_alpha(True, '0', '0', '0')
      #context.set_icon_pixbuf(pbuf, px-x, py-y)
      pmap = gdk.Pixmap(None, w, h, 24) ##???????????????????
      pmap.set_colormap(colormap)
      pmap.draw_pixbuf(pmap.new_gc(), pbuf, 0, 0, 0, 0)
      ##, width=-1, height=-1, dither=gtk.gdk.RGB_DITHER_NORMAL, x_dither=0, y_dither=0)
      context.set_icon_pixmap(colormap, pmap, mask, px-x, py-y)
      return True
    #############################################
    #text = com.dateStr(*self.cell.dates[com.dragGetMode]) ## RTL ??????
    text = '%.2d/%.2d/%.2d'%self.cell.dates[com.dragGetMode]
    textLay = self.create_pango_layout(text)
    if not com.fontUseDefault:
       textLay.set_font_description(pango.FontDescription(com.fontCustom))
    (w, h) = textLay.get_pixel_size()
    pmap = gdk.Pixmap(None, w, h, 24)
    pmap.set_colormap(colormap)
    gc = pmap.new_gc()
    gc.set_foreground(com.bgColor)
    pmap.draw_rectangle(gc, True, 0, 0, w, h)
    #gc.set_background(com.bgColor)
    ##pmap.set_direction(gtk.DIR_LTR)#????????
    pmap.draw_layout(gc, 0, 0, textLay, com.shownDates[0]['color'], com.bgColor)
    #c = com.shownDates[0]['color']
    #pmap.draw_layout(gc, 0, 0, textLay, c, com.gdkColorInvert(c))##??????????
    pbuf = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, w , h)
    pbuf.get_from_drawable(pmap, colormap, 0, 0, 0, 0, -1, -1)
    context.set_icon_pixbuf(pbuf, w/2-10, -20) ## x offset ???????????
    return True
  def dragCalDataGet(self, obj, context, selection, target_id, etime):
    #text = com.dateStr(*self.cell.dates[com.dragGetMode])
    text = '%.2d/%.2d/%.2d'%self.cell.dates[com.dragGetMode]
    #print 'dragCalDataGet', text
    #selection.set(selection.target, 8, text)
    selection.set_text(text)
    return True
  def dragCalLeave(self, obj, context, etime):
    #print 'dragCalLeave'
    #context.drag_status(gdk.ACTION_ASK, etime)
    #context.finish(False, True, etime)
    context.drop_reply(False, etime)
    #context.drop_finish(False, etime)
    #context.drag_abort(etime)##Segmentation fault
    return True
  def dragCalDataRec(self, obj, context, x, y, selection, target_id, etime):
    try:
      dtype = selection.get_data_type()
    except AttributeError:## Old PyGTK
      dtype = selection.type
    text = selection.get_text()
    ## data_type: "UTF8_STRING", "application/x-color", "text/uri-list", 
    if dtype=='UTF8_STRING':
      #text = selection.get_text()
      #print 'Dropped text "%s"'%text
      if text.startswith('file://'):
        path = com.urlToPath(text)
        try:
          t = os.stat(path).st_mtime
        except OSError:
          print 'Dropped invalid file "%s"'%path
        else:
          (y, m, d) = time.localtime(t)[:3]
          print 'Dropped file "%s", modification time: %s/%s/%s'%(path, y, m, d)
          self.dateChange(cal.convert(y, m, d, cal.DATE_GREG, com.primaryMode))
        """
      elif text.startswith('#') and len(text)>=7:## not occures! disable it????
        com.bgColor = com.htmlColorToGdk(text)
        print 'dropped color %s'%text
        self.starcal.colorbBg.set_color(com.bgColor)
        self.cal.queue_draw()"""
      else:
        date = com.parseDroppedDate(text)
        if date==None:
          ## Hot to deny(throw down) dragged object (to return to it's first location)
          ##??????????????????????????????????????????????????????
          print 'Dropped unknown text "%s"'%text
          #print etime
          #context.drag_status(gdk.ACTION_DEFAULT, etime)
          #context.drop_reply(False, etime)
          #context.drag_abort(etime)##Segmentation fault
          #context.drop_finish(False, etime)
          #context.finish(False, True, etime)
          #return True
        else:
          print 'Dropped date: %d/%d/%d'%date
          if com.dragRecMode == com.primaryMode:
            self.dateChange(date)
          else:
            self.dateChange(cal.convert(date[0], date[1], date[2],
              com.dragRecMode, com.primaryMode))
    elif dtype=='application/x-color':
      ## selection.get_text()==None
      text = selection.data
      try:
        unpack = struct.unpack_from
        r = unpack('=H', text, 0)[0] 
        g = unpack('=H', text, 2)[0] 
        b = unpack('=H', text, 4)[0]
        a = unpack('=H', text, 6)[0]
      except AttributeError:## Old PyGTK #?????????????
        r = ord(text[1])*256
        g = ord(text[3])*256
        b = ord(text[5])*256
        a = ord(text[7])*256
        #print r, g, b, a
      print 'Dropped color (%s, %s, %s, %s)'%(r, g, b, a)
      com.bgColor = gdk.Color(r, g, b)
      com.bgColorAlpha = a
      self.starcal.colorbBg.set_color(com.bgColor)
      self.starcal.colorbBg.set_alpha(a)
      self.cal.queue_draw()
    elif dtype=='text/uri-list':
        path = com.urlToPath(selection.data)
        try:
          t = os.stat(path).st_mtime
        except OSError:
          print 'Dropped invalid uri "%s"'%path
          return True
        else:
          (y, m, d) = time.localtime(t)[:3]
          print 'Dropped file "%s", modification time: %s/%s/%s'%(path, y, m, d)
          self.dateChange(cal.convert(y, m, d, cal.DATE_GREG, com.primaryMode))
    else:
      print 'Unknown dropped data type "%s", text="%s", data="%s"'%(dtype,text,selection.data)
      return True
    return False
  def arrowsUpdate(self):
    if showYmArrows:
      if type(com.prevStock)==str:
        self.arrowL.set_image(gtk.image_new_from_stock(com.prevStock, gtk.ICON_SIZE_SMALL_TOOLBAR))
        self.arrowLM.set_image(gtk.image_new_from_stock(com.prevStock, gtk.ICON_SIZE_SMALL_TOOLBAR))
      elif type(com.prevStock)==gtk._gtk.ArrowType:
        if self.arrowL.child!=None:
          self.arrowL.remove(self.arrowL.child)
        arrow = gtk.Arrow(com.prevStock, gtk.SHADOW_IN)
        self.arrowL.add(arrow)
        arrow.show()
        ######
        if self.arrowLM.child!=None:
          self.arrowLM.remove(self.arrowLM.child)
        arrow = gtk.Arrow(com.prevStock, gtk.SHADOW_IN)
        self.arrowLM.add(arrow)
        arrow.show()
      #################
      if type(com.nextStock)==str:
        self.arrowR.set_image(gtk.image_new_from_stock(com.nextStock, gtk.ICON_SIZE_SMALL_TOOLBAR))
        self.arrowRM.set_image(gtk.image_new_from_stock(com.nextStock, gtk.ICON_SIZE_SMALL_TOOLBAR))
      elif type(com.nextStock)==gtk._gtk.ArrowType:
        if self.arrowR.child!=None:
          self.arrowR.remove(self.arrowR.child)
        arrow = gtk.Arrow(com.nextStock, gtk.SHADOW_IN)
        self.arrowR.add(arrow)
        arrow.show()
        ######
        if self.arrowRM.child!=None:
          self.arrowRM.remove(self.arrowRM.child)
        arrow = gtk.Arrow(com.nextStock, gtk.SHADOW_IN)
        self.arrowRM.add(arrow)
        arrow.show()
  def showToolbarActivate(self, checkb=None):
    show = self.checkTb.get_active()
    if show:
      self.toolbBox.show()
    else:
      self.toolbBox.hide()
    com.showToolbar = show
    self.updateMonth()
    com.saveLiveConf()
  def setShowToolbar(self, show=True):
    self.checkTb.set_active(show)
    if show:
      self.toolbBox.show()
    else:
      self.toolbBox.hide()
    com.showToolbar = show
    self.updateMonth()
  def loadExtraDaysDB(self, check=True):
    if check and not com.extradayEnable:
      for i in com.plugIndex:
      #for i in xrange(len(com.allPlugList)) ##?????????????????????
        plug = com.allPlugList[i]
        plug.clear()
      return
    for i in com.plugIndex:
      plug = com.allPlugList[i]
      if plug.enable:
        plug.load()
      else:
        plug.clear()
  def loadCustomDB(self):
    if not os.path.isfile(com.customFile):
      self.customDB = None
      return
    tmp = parse(com.customFile).documentElement
    db=tmp.getElementsByTagName('day')
    self.customDB = []
    for record in db:
      ls = []
      for element in record.childNodes:
        if element.nodeType != element.TEXT_NODE:
          if element.nodeType != element.TEXT_NODE:
            name, data = _get_text(element)
            if name=='num':
              sp=data.split('/')
              ls.append(int(sp[0]))
              ls.append(int(sp[1]))
            if name=='kind':
              ls.append(int(data))
            if name=='desc':
              ls.append(data)
      self.customDB.append(ls)
    #print self.customDB
  def updateCustomDay(self):
    if self.customDB==None or not com.customdayShowText:
      self.customDayHBox.hide()
      return False
    find=False
    for x in self.customDB:
      if x[0]==self.month and x[1]==self.day:
        typ = x[2]
        desc = x[3]
        find = True
        break
    if find:
      try:
        self.customDayIcon.set_from_file('%s%s%s'%(com.pixDir, os.sep, com.customdayModes[typ][1]))
        self.customDayIcon.show()
      except:
        self.customDayIcon.hide()
      self.customDayBuf.set_text(desc)
      self.customDayHBox.show()
    else:
      self.customDayHBox.hide()
    return find
  def updateDateLabels(self):
    for i in xrange(com.shownDatesNum):
      if com.shownDates[i]['enable']:
        self.date_label[i].show()
        mode = com.shownDates[i]['mode']
        if mode==cal.DATE_JD:
          text = str(self.cell.jd)
        else:
          text = com.dateStr(*self.cell.dates[mode])
        if i==0:
          self.date_label[i].set_label('<b>%s</b>'%text)
        else:
          self.date_label[i].set_label(text)
      else:
          self.date_label[i].hide()
  """def checkWinResize(self, widget=None):
    #self.lowerWinUpdate()
    if self.expanding:
      self.vbox.set_child_packing(self.cal, 1, 1, 0, gtk.PACK_START)
      self.cal.set_property('height-request', -1)
      self.expanding = False
      self.queue_resize()
    return False
  def lowerWinUpdate(self):
    (ww, wh) = self.get_size()
    (wx, wy) = self.get_position() ## ==self.window.get_origin()
    self.lowerWin.move(wx, wy+wh)
    self.lowerWin.resize(ww, 1)"""
  def checkResize(self, widget, req):
    if self.hReq!=req.height:# and com.winWidth==req.width:
      #print req.width, req.height
      if req.height==0:
        req.height=1
      #self.setLowerWindowRounded(req.width, req.height)##?????????????????
      ### ?????????????? Makes problem in KWin
      #self.lowerWin.set_geometry_hints(self.lowerBox, max_width=com.winWidth)
      #self.lowerWin.resize(com.winWidth, req.height)
      self.hReq = req.height
  def configureEvent(self, widget, event):
    #print 'configureEvent', time.time()
    #if event.get_state() & gtk.gdk.BUTTON1_MASK:### ??????????????? Always true
    #  print time.time(), 'button1 is down'
    #else:
    #  print time.time(), 'button1 is up'
    tm = time.time()
    if tm-self.confEvTime > 1.0:
      timeout_add(1000, self.saveLiveConf)
    self.confEvTime = tm
    ###########
    self.winActivate()
    (wx, wy) = self.window.get_origin()## self.get_position() when not decorated
    (ww, wh) = self.get_size()
    if not self.moving:## if moving window with window manager itself (on metacity or xfwm)
      ##(lw, lh) = self.lowerWin.get_size()
      ##ww += (ww-lw)/2
      if not com.lowerDocked:# and self.lowerWin.get_size()[0]!=ww:
        self.lowerWin.set_geometry_hints(self.lowerBox, max_width=ww)
        self.lowerWin.resize(ww, 2)
        self.lowerWin.move(wx, wy+wh)
    if com.bgUseDesk and abs(com.winX-wx) > 1 or abs(com.winY-wy) > 1:
      self.cal.queue_draw()
    com.winX = wx
    com.winY = wy
    com.winWidth = ww
    com.winHeight = wh
    #com.focusTime = time.time() ##????????????
    #print com.focusTime
    return False
  def winActivate(self, widget=None, event=None, data=None):
    #print 'winActivate:  focus=%s, winActive=%s, data=%s'%(self.focus, self.winActive, data)
    if self.focus and not self.winActive:
      self.winActive = True
      self.set_keep_above(True)
      self.lowerWin.set_keep_above(True)
    return False ##????????????
  def keyPress(self, arg, event):
    t = time.time()
    if t-self.kTime < com.keyDelay:
      return True
    k = event.keyval
    #print gdk.keyval_name(k), k
    #if gdk.keyval_name(k).startswith('Alt'):
    #  return True
    ## How to disable Alt+Space of metacity ?????????????????????
    if k==65362:		# Up
      self.jdAdd(-7)
    elif k==65364:		# Down
      self.jdAdd(7)
    elif k==65363:		# Right
      if rtl:
        self.jdAdd(-1)
      else:
        self.jdAdd(1)
    elif k==65361:		# Left
      if rtl:
        self.jdAdd(1)
      else:
        self.jdAdd(-1)
    elif k==32 or k==65360:	# Space or Home
      self.goToday()
    elif k==65367:		# End
      self.dateChange((self.year, self.month, com.getMonthLen(self.year, self.month, com.primaryMode)))
    elif k==65365:		# Page Up
      self.monthPlus(-1)
    elif k==65366:		# Page Down
      self.monthPlus(1)
    elif k==65307:		# Esc
      self.starcal.dialogEsc()
    elif k==65470:		# F1:
      self.starcal.aboutShow()
    elif k in (65379,43,65451):	# Insert or plus or KP_Add
      self.starcal.showCustomDay(month=self.month, day=self.day)
    elif k==65383:		# Simulate right click (key beside Right-Ctrl)
      self.popupMenu(event, True)
    elif k in (65479,109,77):	# F10 or m or M
      if event.state & gdk.SHIFT_MASK:
        self.popupMenu(event, True)# Simulate right click (key beside Right-Ctrl)
      else:
        com.focusTime = time.time()
        self.menuMain.popup(None, None, self.getMainMenuPos, 1, event.time)
    elif k in (113,81,1494):	# q Q
      self.starcal.quit()
    #elif gdk.keyval_name(k).startswith('ALT'):## Alt+F7 ##???????????? Does not receive "F7"
    #  self.startManualMoving()
    else:
      return False
    return True
  """def beginMoveUpdate(self, button):
    print 'beginMoveUpdate', button
    if self.movingButton==button:
      (ww, wh) = self.get_size()
      if (com.winWidth, com.winHeight) != (ww, wh):
        (wx, wy) = self.window.get_origin()## self.get_position() when not decorated
        (com.winWidth, com.winHeight) = (ww, wh)
        self.lowerWin.move(wx, wy+wh)
        self.lowerWin.resize(ww, 2)
        self.lowerWin.show()#queue_draw()
      timeout_add(10, self.beginMoveUpdate, button)"""
  def startManualMoving(self, etime=0):
      (x, y, mask) = rootWindow.get_pointer()
      (wx, wy) = self.window.get_origin()
      self.movingDef = (x-wx, y-wy)
      self.moving = True
      self.window.set_cursor(gdk.Cursor(gdk.FLEUR))
  def endManualMoving(self):
    self.moving = False
    self.window.set_cursor(gdk.Cursor(gdk.LEFT_PTR))
  def updateManualMoving(self, w, e):
    #print 'updateManualMoving', self.moving
    if not self.moving:
      return True
    ## event.state & gtk.gdk.CONTROL_MASK: #?????????
    (dx, dy) = self.movingDef
    (x, y, mask) = rootWindow.get_pointer()
    wx = x-dx
    wy = y-dy
    self.move(wx, wy)
    if not com.lowerDocked:
      (ww, wh) = self.get_size()
      self.lowerWin.move(wx, wy+wh)
      if self.lowerWin.get_size()[0]!=ww:
        self.lowerWin.set_geometry_hints(self.lowerBox, max_width=ww)
        self.lowerWin.resize(ww, 2)
      ## How to prevent expose-event (to dont call updateCalAll)
  def buttonRelease(self, widget, event):
    self.endManualMoving()
    #self.lowerWin.resize(com.winWidth, 2)
  def buttonPress(self, obj, event):
    self.winActivate()
    b = event.button
    #print 'buttonPress', b
    if b==3:
      com.focusTime = time.time()
      self.menuMain.popup(None, None, None, 3, event.time)
      self.endManualMoving()
    elif b==1:
      if com.lowerDocked:
        (x, y, mask) = rootWindow.get_pointer()
        self.begin_move_drag(event.button, x, y, event.time)
      else:
        self.startManualMoving()
    return False
  """
  def startMove(self, widget, event):
    self.menuMain.hide()
    (x, y, mask) = rootWindow.get_pointer()
    #print 'begin_move_drag started'
    self.begin_move_drag(event.button, x, y, event.time)
    #print 'begin_move_drag finished\n\n'
    #self.movingButton = b
    #self.beginMoveUpdate(b)
    return True"""
  def startResize(self, widget, event):
    self.menuMain.hide()
    (x, y, mask) = rootWindow.get_pointer()
    self.begin_resize_drag(gdk.WINDOW_EDGE_SOUTH_EAST, event.button, x, y, event.time)
    return True
  def scroll(self, widget, event):
    d = event.direction.value_nick
    if d=='up':
      self.jdAdd(-7)
    elif d=='down':
      self.jdAdd(7)
    else:
      return False
  jdAdd=lambda self, num: self.dateChange(cal.jd_to(cal.to_jd\
    (self.year, self.month, self.day, com.primaryMode)+num, com.primaryMode))
  goToday=lambda self, but=None: self.dateChange(com.getSysDate())
  def dayChange(self, month, year, day):
    self.dateChange((year, month, day))
  def dateChange(self, date, mode=None):
  #?????? Must enhance (only update few cells, not all cells)
    if mode!=None:# and mode!=com.primaryMode:
      date = com.convert(date[0], date[1], date[2], mode, com.primaryMode)
    (self.year, self.month, self.day) = date
    self.computeCurrentMonth()
    self.cal.queue_draw() #### queue_draw_area ???????????

    #for j in xrange(len(com.plugIndex)):##????????????????????
      #com.allPlugList[com.plugIndex[j]].emit('date-change', *date)
    self.updateYearMonthLabels()
    self.updateDateLabels()
    slabel=self.cell.extraday
    if slabel!='':
      self.extraTextBuf.set_text(slabel)
      if not self.extraText.get_property('visible'):
        self.extraText.show()
    elif self.extraText.get_property('visible'):
      self.extraText.hide()
    self.updateCustomDay()
    if com.calHeightReq!=-1:
       self.resize(self.get_size()[0], 2)
    if self.cell.customday!=None:#if Cell has CustomDay
      self.menuCell = self.menuCell2
    else:
      self.menuCell = self.menuCell1
    for j in xrange(len(com.plugIndex)):
      com.allPlugList[com.plugIndex[j]].emit('date-change-after', *date)
  def updateMonth(self):
    self.computeCurrentMonth()
    self.updateYearMonthLabels()
    self.updateDateLabels()
    slabel=self.cell.extraday
    if slabel!='':
      self.extraTextBuf.set_text(slabel)
      if not self.extraText.get_property('visible'):
        self.extraText.show()
    elif self.extraText.get_property('visible'):
      self.extraText.hide()
    self.updateCustomDay()
    self.cal.queue_draw()
    if com.calHeightReq!=-1:
       self.resize(self.get_size()[0], 2)
  def updateYearMonthLabels(self):
    if com.shownDates[0]['enable']:
      self.monthLabel[0].set_active(self.month-1)
      self.yearNum[0].set_active(self.year)
      self.show_list(self.wgroup[0])
    else:
      self.hide_list(self.wgroup[0])
    for i in (1, 2):
      if com.shownDates[i]['enable']:
        mode = com.shownDates[i]['mode']
        if mode==cal.DATE_JD:
          self.hide_list(self.wgroup[i])
          continue
        (y, m, d) = self.cell.dates[mode]
        self.monthLabel[i].set_active(m-1)
        self.yearNum[i].set_active(y)
        self.show_list(self.wgroup[i])
      else:
        self.hide_list(self.wgroup[i])
  def monthPlus(self, plus=1):
    (d, m) = divmod(self.month+plus-1, 12)
    self.month = m+1
    self.year += d
    self.computeCurrentMonth()
    mLen = com.getMonthLen(self.year, self.month, com.primaryMode)
    if self.day > mLen:
      self.day = mLen
    self.updateYearMonthLabels()
    self.updateDateLabels()
    slabel=self.cell.extraday
    if slabel!='':
      self.extraTextBuf.set_text(slabel)
      if not self.extraText.get_property('visible'):
        self.extraText.show()
    elif self.extraText.get_property('visible'):
      self.extraText.hide()
    self.updateCustomDay()
    self.cal.queue_draw()
    if com.calHeightReq!=-1:
       self.resize(self.get_size()[0], 2)
  def monthButtonPress(self, widget, plus, remain=True):
    self._remain = remain
    self.monthPlus(plus)
    timeout_add(300, self.monthButtonRemain, plus)
  def monthButtonRemain(self, plus):
    if self._remain:
      self.monthPlus(plus)
      timeout_add(150, self.monthButtonRemain, plus)
  def yearPlus(self, plus=1):
    self.year+=plus
    self.cal.queue_draw()
    self.computeCurrentMonth()
    mLen = com.getMonthLen(self.year, self.month, com.primaryMode)
    if self.day > mLen:
      self.day = mLen
    self.updateYearMonthLabels()
    self.updateDateLabels()
    slabel=self.cell.extraday
    h0 = self.lowerBox.allocation.height
    if slabel!='':
      self.extraTextBuf.set_text(slabel)
      if not self.extraText.get_property('visible'):
        self.extraText.show()
    elif self.extraText.get_property('visible'):
      self.extraText.hide()
    self.updateCustomDay()
    self.cal.queue_draw()
    if com.calHeightReq!=-1:
       self.resize(self.get_size()[0], 2)
  def yearButtonPress(self, widget, plus, remain=True):
    self._remain = remain
    self.yearPlus(plus)
    timeout_add(300, self.yearButtonRemain, plus)
  def yearButtonRemain(self, plus):
    if self._remain:
      self.yearPlus(plus)
      timeout_add(150, self.yearButtonRemain, plus)
  def arrowRelease(self, widget):
    self._remain = False
  ################################ PCalendar #########################################
  '''
  def setColorsByStyle(self):
    self.colormap = self.get_colormap()
    com.bgColor = self.style.base[gtk.STATE_NORMAL]
    com.borderTextColor = self.style.text[gtk.STATE_SELECTED]
  def getMousePos(self, *args):
    x, y, w, h = self.cal.allocation
    return (x, y)
  def drawRectAlpha(self, x0, y0, w, h, color, alpha=65535):
    #cr = self.cal.window.cairo_create()
    cr = self.cr
    cr.rectangle(x0, y0, w, h)
    cr.fillColorA(cr, color, alpha)
  '''
  def drawCursor(self, x0, y0, w, h, in_xy=True, round_oval=False):
    d=com.cursorD
    if in_xy:
      x0 -= d
      y0 -= d
      w += 2*d
      h += 2*d
    cr = self.cr
    if com.cursorR==0:
      cr.rectangle(x0, y0, w, h)
      fillColorA(cr, com.cursorBgColor, com.cursorBgAlpha)
      return
    if round_oval:
      ## Oval Rounded
      yscale = float(h/w)
      cr.scale(1, yscale)
      y0 /= yscale
      h = w  
    ######### Circular Rounded
    ro = min(com.cursorR, w/2, h/2)
    #a = min(w, h); ri = ro*(a-2*d)/a
    ri = max(ro-d, 0)
    ######### Outline:
    cr.move_to(x0+ro, y0)
    cr.line_to(x0+w-ro, y0)
    cr.arc(x0+w-ro, y0+ro, ro, 3*pi/2, 2*pi) ## up right corner
    cr.line_to(x0+w, y0+h-ro)
    cr.arc(x0+w-ro, y0+h-ro, ro, 0, pi/2) ## down right corner
    cr.line_to(x0+ro, y0+h)
    cr.arc(x0+ro, y0+h-ro, ro, pi/2, pi) ## down left corner
    cr.line_to(x0, y0+ro)
    cr.arc(x0+ro, y0+ro, ro, pi, 3*pi/2) ## up left corner
    ####
    cr.close_path()
    fillColorA(cr, com.cursorBgColor, com.cursorBgAlpha)
    if round_oval:
      cr.scale(1, 1.0/yscale)
  def drawCursorOut(self, x0, y0, w, h, in_xy=True, round_oval=False):
    d=com.cursorD
    if in_xy:
      x0 -= d
      y0 -= d
      w += 2*d
      h += 2*d
    cr = self.cr
    cr.set_source_color(com.cursorOutColor)
    if com.cursorR==0:
      cr.rectangle(x0, y0, w, d)
      cr.fill()
      cr.rectangle(x0, y0+h-d, w, d)
      cr.fill()
      cr.rectangle(x0, y0, d, h)
      cr.fill()
      cr.rectangle(x0+w-d, y0, d, h)
      cr.fill()
      return
    if round_oval:
      ## Oval Rounded
      yscale = float(h/w)
      cr.scale(1, yscale)
      y0 /= yscale
      h = w  
    ######### Circular Rounded
    ro = min(com.cursorR, w/2, h/2)
    #a = min(w, h); ri = ro*(a-2*d)/a
    ri = max(ro-d, 0)
    ######### Outline:
    cr.move_to(x0+ro, y0)
    cr.line_to(x0+w-ro, y0)
    cr.arc(x0+w-ro, y0+ro, ro, 3*pi/2, 2*pi) ## up right corner
    cr.line_to(x0+w, y0+h-ro)
    cr.arc(x0+w-ro, y0+h-ro, ro, 0, pi/2) ## down right corner
    cr.line_to(x0+ro, y0+h)
    cr.arc(x0+ro, y0+h-ro, ro, pi/2, pi) ## down left corner
    cr.line_to(x0, y0+ro)
    cr.arc(x0+ro, y0+ro, ro, pi, 3*pi/2) ## up left corner
    #### Inline:
    cr.move_to(x0+ro, y0+d) ## or line to?
    cr.arc_negative(x0+ro, y0+ro, ri, 3*pi/2, pi) ## up left corner
    cr.line_to(x0+d, y0+h-ro)
    cr.arc_negative(x0+ro, y0+h-ro, ri, pi, pi/2) ## down left
    cr.line_to(x0+w-ro, y0+h-d)
    cr.arc_negative(x0+w-ro, y0+h-ro, ri, pi/2, 0) ## down right
    cr.line_to(x0+w-d, y0+ro)
    cr.arc_negative(x0+w-ro, y0+ro, ri, 2*pi, 3*pi/2) ## up right
    cr.line_to(x0+ro, y0+d)
    ####
    cr.close_path()
    cr.fill()
    if round_oval:
      cr.scale(1, 1.0/yscale)
  def calRealize(self, widget, event=None):
    #gtk.Widget.realize(self.cal)
    screen = self.cal.get_screen()
    try:
      colormap = screen.get_rgba_colormap()
    except AttributeError:
      self.cal.set_colormap(screen.get_default_colormap())
      self.have_argb_visual = False
    else:
      if screen.is_composited() and colormap!=None:
        self.cal.set_colormap(colormap)
        self.have_argb_visual = True
      else:
        self.cal.set_colormap(screen.get_default_colormap())
        self.have_argb_visual = False
    #gtk.Widget.realize(self.cal)
  def updateCalAll(self, widget=None, event=None, cr=None, cursor=True):
    #print time.time(), 'updateCalAll', tuple(event.area), tuple(self.cal.allocation)
    self.calcCoord()
    x, y, w, h = self.cal.allocation
    if cr==None:
      cr = self.cal.window.cairo_create()
      #cr.set_line_width(0)#??????????????
      #cr.scale(0.5, 0.5)
    self.cr = cr
    ###??????????????????????? Transparency ?????????????????????????????????
    if com.bgUseDesk:
        """
      if self.cal.is_composited():
        cr0 = self.window.cairo_create()
        #cr.set_line_width(0)#??????????????
        cr.set_source_rgba(1, 1, 1, 0)
        cr.set_operator (cairo.OPERATOR_SOURCE)
        cr.paint()
        ########
        #cr.save()
        cr.set_source_rgba(1, 1, 1, 0)
        cr.set_operator (cairo.OPERATOR_SOURCE)
        #cr.rectangle(0, 0, w, h)
        cr.fill()
        cr.paint()
        ########
        #cr.restore()
        #cr.clip()
        #cr.set_operator (cairo.OPERATOR_OVER)
      else:
        #"""
        (wx, wy) = self.get_position()
        coord = self.cal.translate_coordinates(self, wx, wy)
        if len(coord)==2:
          (x0, y0) = coord
          try:
            bg = desktop.get_wallpaper(x0, y0, w, h)
          except:
            print 'Could not get wallpaper!'
            myRaise(__file__)
            os.popen('gnome-settings-daemon')
            #com.bgUseDesk = False
            self.starcal.checkDeskBg.set_active(False)
          else:
            cr.set_source_pixbuf(bg, 0, 0)
            cr.paint()
        else:
          print coord
    cr.rectangle(0, 0, w, h)
    fillColorA(cr, com.bgColor, com.bgColorAlpha)
    s = self.computeCurrentMonth()
    self.mstatus = s
    #################################### Drawing Border
    ##s = self.mstatus
    if com.calTopMargin>0:
      ##### Drawing border top background
      ##menuBgColor == borderColor ##???????????????
      cr.rectangle(0, 0, w, com.calTopMargin)
      fillColorA(cr, com.borderColor, com.borderColorAlpha)
      ######## Drawing weekDays names
      cr.set_source_color(com.borderTextColor)
      dx = 0
      com.wdaySyn = (self.wdaysWidth > self.calW)
      for i in xrange(7):
        wday = self.create_pango_layout(com.getWeekDayAuto(i))
        if not com.fontUseDefault:
          wday.set_font_description(pango.FontDescription(com.fontCustom))
        try:
          (fontw, fonth) = wday.get_pixel_size()
        except:
          myRaise(__file__)
          (fontw, fonth) = wday.get_pixel_size()
        cr.move_to(self.cx[i]-fontw/2.0, (com.calTopMargin-fonth)/2.0-1)
        cr.show_layout(wday)
      ######## Drawing "Menu" label
      cr.set_source_color(com.menuTextColor)
      text = self.create_pango_layout(_('Menu'))
      if not com.fontUseDefault:
        text.set_font_description(pango.FontDescription(com.fontCustom))
      (fontw, fonth) = text.get_pixel_size()
      if rtl:
        cr.move_to(w-(com.calLeftMargin+fontw)/2.0-3, (com.calTopMargin-fonth)/2.0-1)
      else:
        cr.move_to((com.calLeftMargin-fontw)/2.0, (com.calTopMargin-fonth)/2.0-1)
      cr.show_layout(text)
    if com.calLeftMargin>0:
      ##### Drawing border left background
      if rtl:
        cr.rectangle(self.calW-com.calLeftMargin, com.calTopMargin, com.calLeftMargin, h-com.calTopMargin)
      else:
        cr.rectangle(0, com.calTopMargin, com.calLeftMargin, h-com.calTopMargin)
      fillColorA(cr, com.borderColor, com.borderColorAlpha)
      ######## Drawing week numbers
      cr.set_source_color(com.borderTextColor)
      for i in xrange(6):
        lay = self.create_pango_layout(com.numLocal(s.weekNum[i]))
        if not com.fontUseDefault:
          lay.set_font_description(pango.FontDescription(com.fontCustom))
        fontw, fonth = lay.get_pixel_size()
        if rtl:
          cr.move_to(w-(com.calLeftMargin+fontw)/2.0, self.cy[i]-fonth/2.0+2)
        else:
          cr.move_to((com.calLeftMargin-fontw)/2.0, self.cy[i]-fonth/2.0+2)
        cr.show_layout(lay)
    ############################## drawDayMonth
    ##s = self.mstatus
    self.drawCells([s[i][j] for i in xrange(6) for j in xrange(7)], cursor)
    ############################## drawGrid
    if com.calGrid:
      c = com.gridColor
      cr.set_source_rgba(c.red/65535.0, c.green/65535.0, c.blue/65535.0, com.gridAlpha/65535.0)
      #cr.set_source_color(com.gridColor)
      for i in xrange(7):
        cr.rectangle(self.cx[i]+rtlSgn()*self.dx/2.0, 0, 1, h)
        cr.fill()
      for i in xrange(6):
        cr.rectangle(0, self.cy[i]-self.dy/2.0, self.calW, 1)
        cr.fill()
    #cr.rectangle(0, 0, w, h)#????????
    #cr.clip()#???????
    #self.cal.draw(cr)
    #self.setWindowRounded()
    return False
  def setWindowRounded(self, height=None):
      #print 'setWindowRounded: height=%s, self.get_size()[1]=%s'%(height, self.get_size()[1])
      (w, h) = self.get_size()
      #h = com.winHeight
      if height!=None:
        h = height
      mask = gdk.Pixmap(None, w, h, 1)
      cr = mask.cairo_create()
      cr.rectangle(0, 0, w, h)
      cr.set_operator(cairo.OPERATOR_CLEAR)
      cr.fill()
      cr.set_operator(cairo.OPERATOR_SOURCE)
      ro=8
      cr.move_to(ro, 0)
      cr.line_to(w-ro, 0)
      cr.arc(w-ro, ro, ro, 3*pi/2, 2*pi) ## up right corner
      if com.lowerDocked:
        cr.line_to(w, h-ro)
        cr.arc(w-ro, h-ro, ro, 0, pi/2) ## down right corner
        cr.line_to(ro, h)
        cr.arc(ro, h-ro, ro, pi/2, pi) ## down left corner
      else:
        cr.line_to(w, h)
        cr.line_to(0, h)
      cr.line_to(0, ro)
      cr.arc(ro, ro, ro, pi, 3*pi/2) ## up left corner"""
      cr.close_path()
      cr.fill()
      self.shape_combine_mask(mask, 0, 0)
  def setLowerWindowRounded(self, w, h):
      if not com.lowerDocked:
        #(w, h) = self.lowerWin.get_size()
        #print 'lowerWin.get_size()=', (w, h)
        #if height!=None:
        #w = com.winWidth
        #h = height
        #print tuple(self.lowerBox.allocation)
        mask = gdk.Pixmap(None, w, h, 1)
        cr = mask.cairo_create()
        cr.rectangle(0, 0, w, h)
        cr.set_operator(cairo.OPERATOR_CLEAR)
        cr.fill()
        cr.set_operator(cairo.OPERATOR_SOURCE)
        ro=8
        cr.move_to(0, 0)
        cr.line_to(w, 0)
        cr.line_to(w, h-ro)
        cr.arc(w-ro, h-ro, ro, 0, pi/2) ## down right corner
        cr.line_to(ro, h)
        cr.arc(ro, h-ro, ro, pi/2, pi) ## down left corner
        cr.line_to(0, 0)
        cr.close_path()
        cr.fill()
        self.lowerWin.shape_combine_mask(mask, 0, 0)
  def expanderExpose(self, w=None, e=None):
    #print 'expanderExpose'
    #(ww, wh) = self.get_size()
    #if not self.lowerExp.get_expanded():
      #self.resize(ww, self.vbox.allocation.height)
    #self.queue_resize()
    self.vbox.set_child_packing(self.cal, 1, 1, 0, gtk.PACK_START)
    self.cal.set_property('height-request', -1)
    #self.expanding = False#"""
  def buildStatus(self, year, month, addCache=True):
    print 'Building cache (%s, %s)'%(year, month)
    self.loadExtraDaysDB()##### for memory emhancement
    num = len(com.shownDates)
    s = MonthStatus()#s = []
    s.year = year
    s.month = month
    pyear = year
    pmonth = month -1
    if pmonth <= 0 :
      pmonth =12
      pyear -=1
    prevMonthLen = com.getMonthLen(pyear, pmonth, com.primaryMode)
    currentMonthLen = com.getMonthLen(year, month, com.primaryMode)
    s.monthLen = currentMonthLen
    ##################################
    s.weekNum = [com.weekNumber(year, month, 1+7*i) for i in xrange(6)]
    offset = com.dayOfWeek(year, month, 1)
    if offset==0:
      ###### Which Method ????????????????????
      #day = prevMonthLen - 6 ; s.weekNum = [com.weekNumber(year, month, 1+7*i)-1 for i in xrange(6)]
      day = 1
    else:
      day = prevMonthLen - offset + 1
    s.monthStartOffset = offset
    ##################################
    for i in xrange(6):
      s.append([])
      for j in xrange(7):
        c = Cell()
        c.pos = (j, i)
        s[i].append(c)
        c.day = day
        c.jd = cal.to_jd(year, month, day, com.primaryMode)
        if i<2 and day>15:
          c.gray = -1
          c.dates[com.primaryMode] = (pyear, pmonth, day)
          #c.ym = (pyear, pmonth)
        elif i>=4 and day<20:
          c.gray = 1
          nyear = year
          nmonth = month +1
          if nmonth > 12 :
            nmonth =1
            nyear += 1
          c.dates[com.primaryMode] = (nyear, nmonth, day)
          #c.ym = (nyear, nmonth)
        else:
          c.gray = 0
          c.dates[com.primaryMode] = (year, month, day)
          #c.ym = (year, month)
        (cyear, cmonth, cday) = c.dates[com.primaryMode]
        for mode in xrange(cal.modNum):
          if mode!=com.primaryMode:
            c.dates[mode]=cal.convert(cyear, cmonth, cday, com.primaryMode, mode)
        #for k in xrange(1, num):
        #  mode = com.shownDates[k]['mode']
        #  if mode!=com.primaryMode:
        #    c.dates[mode]=cal.convert(cyear, cmonth, cday, com.primaryMode, mode)
        #### com.primaryMode == com.shownDates[0]['mode']
        if c.gray==0:
          for k in com.plugIndex:
            plug = com.allPlugList[k]
            if plug.enable:
              plug.update_cell(c)
          c.holidayExtra = c.holiday
          wd = (com.firstWeekDay + j) % 7 ##??????????
          if wd in com.holidayWeekDays:
            c.holiday = True
          if self.customDB!=None:
            for x in self.customDB:
              if x[0]==month and x[1]==day:
                c.customday = (x[2], x[3])
        day+=1
        if i>3 and day>currentMonthLen:
          day =1
          sday=1
        if i<2 and day>prevMonthLen:
          day =1
    if addCache:
      ## Clean Cache
      n = len(self.months)
      #print 'Cache size: %s'%n
      if n >= com.maxCache:
        keys = self.months.keys()
        keys.sort()
        if keys[n/2] < (year, month):
          rm = keys[0]
          if rm==self.today[:2]:
            rm = keys[1]
        else:
          rm = keys[-1]
          if rm==self.today[:2]:
            rm = keys[-2]
        #if rm != (year, month):
        print 'Removing cache (%s, %s)'%(rm[0], rm[1])
        self.months.pop(rm)
    try:#### for memory emhancement
      del self.months[(year, month)]
    except:
      pass
    self.months[(year, month)] = s
    return s
  def computeCurrentMonth(self, overwrite=False):
    if overwrite:
      status = self.buildStatus(self.year, self.month)
    else:
      try:
        status = self.months[(self.year, self.month)]
      except KeyError:
        status = self.buildStatus(self.year, self.month)
    (sy, sx) = divmod(status.monthStartOffset + self.day - 1, 7)
    self.cell = status[sy][sx]
    return status
  def getDateCell(self, y, m, d):
    try:
      status = self.months[(y, m)]
    except KeyError:
      status = self.buildStatus(y, m)
    for i in xrange(6):
      for j in xrange(7):
        c = status[i][j]
        if not c.gray and c.day==d:
          return c
    raise RuntimeError('No cell found %d/%d/%d'%(y, m, d))
  def drawCells(self, cells, cursor=True):
          cr = self.cr
          (sx, sy) = self.cell.pos
          shown = com.shownDates
          '''
          if ovcal.enable:
            hpix={}
            for ind in ovcal.numList:
              hpix[ind] = gdk.pixbuf_new_from_file(ovcal.getImageName(ind))'''
          for c in cells:
            (j, i) = c.pos
            x0 = self.cx[j]
            y0 = self.cy[i]
            if cursor and i==sy and j==sx:
              if com.cursorFixed:
                  self.drawCursor(x0-com.cursorW/2.0, y0-com.cursorH/2.0,com.cursorW,com.cursorH)
              else:
                  self.drawCursor(x0-self.dx/2.0+1, y0-self.dy/2.0+1,self.dx-1,self.dy-1,False)
            if c.customday!=None and com.customdayShowIcon:
              try:
                pix = gdk.pixbuf_new_from_file(os.path.join(com.pixDir, com.customdayModes[c.customday[0]][2]))
              except:
                myRaise(__file__)
              else:
                w = pix.get_width()
                h = pix.get_height()
                ## right buttom corner ?????????????????????
                x1 = self.cx[j] + self.dx/2.0 - w # right side
                y1 = self.cy[i] + self.dy/2.0 - h # buttom side
                cr.set_source_pixbuf(pix, x1, y1)
                cr.rectangle(x1, y1, w, h)
                cr.fill()
            if shown[0]['enable']:
              mode = shown[0]['mode']
              if mode==cal.DATE_JD:
                daynum = self.create_pango_layout(str(int(c.jd)))
              else:
                daynum = self.create_pango_layout(numLocal(c.dates[mode][2], mode+1))
              daynum.set_font_description(pango.FontDescription(shown[0]['font']))
              (fontw, fonth) = daynum.get_pixel_size()
              if c.gray!=0:
                clr = com.inactiveColor
                cr.set_source_rgba(clr.red/65535.0, clr.green/65535.0, clr.blue/65535.0, com.inactiveColorAlpha/65535.0)
              elif c.holiday:
                cr.set_source_color(com.holidayColor)
              else:
                cr.set_source_color(shown[0]['color'])
              cr.move_to(x0 - fontw/2.0 + shown[0]['x'], y0 - fonth/2.0 + shown[0]['y'])
              cr.show_layout(daynum)
            if c.gray==0:
              for item in shown[1:]:
                if item['enable']:
                  mode = item['mode']
                  if mode==cal.DATE_JD:
                    daynum = self.create_pango_layout(str(int(c.jd)))
                  else:
                    daynum = self.create_pango_layout(numLocal(c.dates[mode][2], mode+1))
                  daynum.set_font_description(pango.FontDescription(item['font']))
                  (fontw, fonth) = daynum.get_pixel_size()
                  cr.set_source_color(item['color'])
                  cr.move_to(x0 - fontw/2.0 + item['x'], y0 - fonth/2.0 + item['y'])
                  cr.show_layout(daynum)
              if i==sy and j==sx:
                if com.cursorFixed:
                  self.drawCursorOut(x0-com.cursorW/2.0, y0-com.cursorH/2.0,com.cursorW,com.cursorH)
                else:
                  self.drawCursorOut(x0-self.dx/2.0+1, y0-self.dy/2.0+1,self.dx-1,self.dy-1,False)
  def updateCell(self):
    (sx, sy) = self.cell.pos
    self.cell = self.months[(self.year, self.month)][sy][sx]
  #def updateWindow(self):
  #  if self.cal.window==None:
  #    return
  #  alloc = self.get_allocation()
  #  self.cal.window.invalidate_rect(gdk.Rectangle(0, 0, alloc.width, alloc.height), True)
  #  #self.cal.window.invalidate_rect(self.get_allocation(), True)
  #  self.cal.queue_draw()
  #  print 'updateWindow'
  def calButtonPress(self, obj, event):
    self.winActivate()
    b = event.button
    (x, y, mask) = event.window.get_pointer() # or self.get_pointer()
    self.pointer = (x, y)
    if b==2:
      return False
    col=self.findCol(x)
    row=self.findRow(y)
    status = self.computeCurrentMonth()
    if row==-1 or col==-1:
      com.focusTime = time.time()
      self.menuMain.popup(None, None, None, 3, event.time)
      #self.menuMainWidth = self.menuMain.allocation.width ## menu.allocation[3]
    elif row>=0 and col>=0:
      self.day = status[row][col].dates[com.primaryMode][2]
      if row==0 and self.day>15:
        self.month -= 1
        if self.month <= 0 :
          self.month =12
          self.year -=1
        gray = -1
        ##row = 5
      elif row>3 and self.day<15:
        self.month += 1
        if self.month > 12 :
          self.month =1
          self.year +=1
        gray = 1
        ##row = 0
      else:
        gray = 0
      self.dateChange((self.year, self.month, self.day))
      #assert gray==self.cell.gray ### OK except when clicked on a gray day
      if event.type==gdk._2BUTTON_PRESS:
        self.dayOpenEvolution()
      if b==3 and gray==0:## right click
        self.popupMenu(event, False)
    return True
  def dayOpenEvolution(self, arg=None):
    ##(y, m, d) = cal.jd_to(self.cell.jd-1, cal.DATE_GREG) ## in gnome-cal opens prev day! why??
    (y, m, d) = self.cell.dates[cal.DATE_GREG]
    os.popen2('evolution calendar:///?startdate=%.4d%.2d%.2d'%(y, m, d))
    #os.popen2('evolution calendar:///?startdate=%.4d%.2d%.2dT120000Z'%(y, m, d))
    ## What "Time" pass to evolution? like gnome-clock: T193000Z (19:30:00) / Or ignore "Time"
    ## evolution calendar:///?startdate=$(date +"%Y%m%dT%H%M%SZ")
    print 'dayOpenEvolution', (y, m, d)
  def dayOpenSunbird(self, arg=None):
    (y, m, d) = self.cell.dates[cal.DATE_GREG]
    os.popen2('sunbird -showdate %.4d/%.2d/%.2d'%(y, m, d))
    print 'dayOpenSunbird', (y, m, d)
  ## How do this with KOrginizer ????????????????????????????????
  def popupMenu(self, event, keyPress=False):
    #if self.cell.customday!=None:#if Cell has CustomDay
    #  menu = self.menuCell2
    #else:
    #  menu = self.menuCell1
    menu = self.menuCell ## dynamic attribute
    com.focusTime = time.time()
    if keyPress:
      menu.popup(None, None, self.getCellPos, 3, event.time)
    else:
      menu.popup(None, None, None, 3, event.time)
    #self.menuCellWidth = menu.allocation.width ## menu.allocation[3]
  def findCol(self, x):
    for i in xrange(7):
      if abs(x-self.cx[i]) <= self.dx/2.0:
        return i
    return -1
  def findRow(self, y):
    for i in xrange(6):
      if abs(y-self.cy[i]) <= self.dy/2.0:
        return i
    return -1
  def calcCoord(self):## calculates coordidates (x and y of cells centers)
    x, y, w, h = self.cal.allocation
    self.calW = w
    if rtl:
      self.cx = [ (self.calW-com.calLeftMargin)*(13.0-2*i)/14.0 for i in xrange(7) ] ## centers x
    else:
      self.cx = [com.calLeftMargin + (self.calW-com.calLeftMargin)*(1.0+2*i)/14.0 for i in xrange(7) ] ## centers x
    self.cy = [com.calTopMargin + (h-com.calTopMargin)*(1.0+2*i)/12.0 for i in xrange(6) ] ## centers y
    self.dx = (self.calW-com.calLeftMargin)/7.0 ## delta x
    self.dy = (h-com.calTopMargin)/6.0 ## delta y
  def getCellPos(self, menu, event=None):
    (wx, wy) = self.get_position()
    (x0, y0) = self.cal.translate_coordinates(self, wx, wy)
    x1, y1, w, h = self.cal.allocation
    (sx, sy) = self.cell.pos
    x = x0 + self.cx[sx]
    y = y0 + self.cy[sy] + self.dy/2.0
    if rtl:
      mw = menu.allocation.width
      if mw < 2:# menu width
        mw = 145
      x -= mw
    return (int(x), int(y), True)
  def getMainMenuPos(self, menu):#???????????????????
    x, y, w, h = self.cal.allocation
    (wx, wy) = self.get_position()
    (x0, y0) = self.cal.translate_coordinates(self, wx, wy)## (x0, y0) = (wx+x+.., xy+y+..)
    if rtl:
      mw = menu.allocation.width
      if mw < 2:# menu width
        mw = 145
      return (int(x0 + w - com.calLeftMargin/2.0 - mw),
              int(y0 + com.calTopMargin/2.0 ), True)
    else:
      return (int(x0 + com.calLeftMargin/2.0),
                int(y0 + com.calTopMargin/2.0 ), True)
  def nextMonth(self):
    self.month += 1
    if self.month > 12 :
      self.month =1
      self.year +=1
    self.cal.queue_draw()
  def prevMonth(self):
    self.month -= 1
    if self.month <= 0 :
      self.month =12
      self.year -=1
    self.cal.queue_draw()
  def getMonthDesc(self, status=None):
    if status==None:
      status = self.computeCurrentMonth()
    first = None
    last = None
    for i in xrange(6):
      for j in xrange(7):
        c = status[i][j]
        if first==None:
          if c.gray:
            continue
          else:
            first = c
        else:
          if c.gray:
            break
          else:
            last = c
    text = ''
    for item in com.shownDates:
      if text!='':
        text+='\n'
      mode = item['mode']
      module = cal.modules[mode]
      if mode==cal.DATE_JD:
        continue
      if mode==com.primaryMode:
        (y, m) = first.dates[mode][:2] ## = (self.year, self.month)
        text += '%s %s'%(_(cal.modules[mode].getMonthName(m, y), numLocal(y)))
      else:
        (y1, m1) = first.dates[mode][:2]
        (y2, m2) = last.dates[mode][:2]
        monthsInYear = module.getMonthsInYear(y1)
        dy = y2 - y1
        if dy==0:
          dm = m2 - m1
        elif dy==1:
          dm = m2+monthsInYear - m1
          assert dm > 0
        else:
          raise RuntimeError('y1=%d, m1=%d, y2=%d, m2=%d'%(y1, m1, y2, m2))
        if dm==0:
          text += '%s %s'%(_(module.getMonthName(m1,y1)), numLocal(y1))
        elif dm==1:
          if dy==0:
            text += '%s %s %s %s'%(_(module.getMonthName(m1,y1)), _('and'),\
            _(module.getMonthName(m2,y1)), numLocal(y1))
          else:
            text += '%s %s %s %s %s'%(_(module.getMonthName(m1,y1)), numLocal(y1),\
            _('and'), _(module.getMonthName(m2,y2)), numLocal(y2))
        elif dm==2:
          if dy==0:
            text += '%s%s %s %s %s %s'%(_(module.getMonthName(m1,y1)), _(','),\
            _(module.getMonthName(m1+1,y1)),_('and'), _(module.getMonthName(m2,y1)), numLocal(y1))
          else:
            if m1==monthsInYear-1:
              text += '%s %s %s %s %s %s %s'%(_(module.getMonthName(m1,y1)), _('and'),\
              _(module.getMonthName(m1+1,y1)), numLocal(y1),\
              _('and'), _(module.getMonthName(1,y2)), numLocal(y2))
            elif m1==monthsInYear:
              text += '%s %s %s %s %s %s %s'%(_(module.getMonthName(m1,y1)), numLocal(y1),\
              _('and'), _(module.getMonthName(1,y2)),\
              _('and'), _(module.getMonthName(2,y2)), numLocal(y2))
    return text


