#!/usr/bin/python
# -*- coding: utf-8 -*-
from mywidgets import *

def example1():
  #from gtk import Dialog, HBox, Label, STOCK_MEDIA_PLAY, STOCK_MEDIA_STOP, STOCK_PRINT, RESPONSE_CLOSE, main_quit
  dialog = gtk.Dialog()
  dialog.set_title('Date & Time')
  hbox = gtk.HBox(spacing=2)
  hbox.pack_start(gtk.Label('Date:'), 0, 0)
  datebox = DateBox(date=localtime()[:3])
  #datebox.set_date(localtime()[:3])
  hbox.pack_start(datebox, 0, 0)
  hbox.pack_start(gtk.Label(''), 1, 1)
  hbox.pack_start(gtk.Label('Time:'), 0, 0)
  timebox = TimerBox(hms=localtime()[3:6])
  #timebox.set_time(localtime()[3:6])
  hbox.pack_start(timebox, 0, 0)
  timebox.connect('first-max', lambda widget: datebox.entry_plus(1))
  timebox.connect('first-min', lambda widget: datebox.entry_plus(-1))
  dialog.vbox.pack_start(hbox, 0, 0)
  currentB = dialog.add_button('Current', 0)
  currentB.connect('clicked', lambda widget: (datebox.set_date(localtime()[:3]),timebox.set_time(localtime()[3:6])) )
  #######
  playB = dialog.add_button(gtk.STOCK_MEDIA_PLAY, 0)
  playB.connect('clicked', lambda widget: timebox.timer_start())
  stopB = dialog.add_button(gtk.STOCK_MEDIA_STOP, 0)
  stopB.connect('clicked', lambda widget: timebox.timer_stop())
  #timebox.tPlus = -1
  timebox.connect('time-elapse', lambda widget: sys.stdout.write('TimeBox Timer Elapsed!\n'))
  #######
  printB = dialog.add_button(gtk.STOCK_PRINT, 0)
  printB.connect('clicked', lambda widget: sys.stdout.write('Date: %s\tTime: %s\n'%(datebox.get_date(), timebox.get_time())))
  closeB = dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
  closeB.connect('clicked', lambda widget: gtk.main_quit())
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def example2():
  #from gtk import Dialog, HBox, Label, STOCK_PRINT, RESPONSE_CLOSE, main_quit
  dialog = gtk.Dialog()
  dialog.set_title('Day & Time')
  hbox = gtk.HBox(spacing=2)
  hbox.pack_start(gtk.Label('Day and Time:'), 0, 0)
  hbox.pack_start(gtk.Label(''), 1, 1)
  dtbox = DayTimeBox(hms=localtime()[3:6])
  hbox.pack_start(dtbox, 0, 0)
  dialog.vbox.pack_start(hbox, 0, 0)
  #######
  dtbox.connect('time-elapse', lambda widget: sys.stdout.write('DayTimeBox Timer Elapsed!\n'))
  dtbox.set_time((0, 2, 0))
  #dtbox.tPlus = -3600 ; dtbox.spin.set_value(4.0)
  #dtbox.tPlus = 10000 ; dtbox.elapse = 360000
  #######
  printB = dialog.add_button(gtk.STOCK_PRINT, 0)
  printB.connect('clicked', lambda widget: sys.stdout.write('Day: %s\tTime: %s:%s:%s\n'%dtbox.get_day_time()))
  closeB = dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
  closeB.connect('clicked', lambda widget: gtk.main_quit())
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def example3():
  #from gtk import Dialog, HBox, Label, STOCK_PRINT, RESPONSE_CLOSE, main_quit
  dialog = gtk.Dialog()
  dialog.set_title('Day & Time')
  hbox = gtk.HBox(spacing=2)
  hbox.pack_start(gtk.Label('Day and Time:'), 0, 0)
  hbox.pack_start(gtk.Label(''), 1, 1)
  dtbox = DateTimeBox(date_time=localtime()[:6], lang="fa")
  hbox.pack_start(dtbox, 0, 0)
  dialog.vbox.pack_start(hbox, 0, 0)
  #######
  #dtbox.connect('time-elapse', lambda widget: sys.stdout.write('DateTimeBox Timer Elapsed!\n'))
  #dtbox.set_date_time((2007, 1, 1, 0, 2, 0))
  #dtbox.tPlus = -3600 ; dtbox.spin.set_value(4.0)
  #dtbox.tPlus = 10000 ; dtbox.elapse = 360000
  #######
  printB = dialog.add_button(gtk.STOCK_PRINT, 0)
  printB.connect('clicked', lambda widget: sys.stdout.write('Date: %s/%s/%s\tTime: %s:%s:%s\n'%tuple(dtbox.get_date_time())))
  #printB.connect('clicked', lambda widget: sys.stdout.write(str(dtbox.get_date_time())+'\n'))
  closeB = dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
  closeB.connect('clicked', lambda widget: gtk.main_quit())
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def example4():
  #from gtk import Dialog, HBox, Label, STOCK_PRINT, RESPONSE_CLOSE, main_quit
  dialog = gtk.Dialog()
  dialog.set_title('Real Clock')
  hbox = gtk.HBox(spacing=2)
  hbox.pack_start(gtk.Label('Clock:'), 0, 0)
  timebox = TimerBox(hms=localtime()[3:6])
  hbox.pack_start(timebox, 0, 0)
  dialog.vbox.pack_start(hbox, 0, 0)
  playB = dialog.add_button(gtk.STOCK_MEDIA_PLAY, 0)
  playB.connect('clicked', lambda widget: timebox.clock_start())
  stopB = dialog.add_button(gtk.STOCK_MEDIA_STOP, 0)
  stopB.connect('clicked', lambda widget: timebox.clock_stop())
  #######
  printB = dialog.add_button(gtk.STOCK_PRINT, 0)
  printB.connect('clicked', lambda widget: sys.stdout.write('Time: %s:%s:%s\n'%tuple(timebox.get_time())))
  closeB = dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
  closeB.connect('clicked', lambda widget: gtk.main_quit())
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def example5():
  #from gtk import Dialog, HBox, SpinButton, STOCK_PRINT, RESPONSE_CLOSE, main_quit
  dialog = gtk.Dialog()
  dialog.set_title('Spin Test')
  hbox = gtk.HBox(spacing=2)
  #hbox.pack_start(gtk.Label('Clock:'), 0, 0)
  spin = gtk.SpinButton()
  #spin.set_increments(1, 10)
  #spin.set_range(0, 10000)
  spin.connect('key_press_event', key_press)
  spin.connect('button_press_event', button_press)
  #spin.connect('event', showEvent)
  spin.set_text('123')
  hbox.pack_start(spin, 0, 0)
  dialog.vbox.pack_start(hbox, 0, 0)
  #######
  closeB = dialog.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
  closeB.connect('clicked', lambda widget: gtk.main_quit())
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def example6():
  dialog = gtk.Dialog()
  hbox = gtk.HBox()
  tbox = TimeBox()
  hbox.pack_start(tbox, 0, 0)
  hbox.pack_start(gtk.Label(''), 1, 1)
  spin = gtk.SpinButton()
  spin.set_increments(1, 10)
  spin.set_range(0, 999)
  #spin.set_width_chars(0)
  hbox.pack_start(spin, 0, 0)
  dialog.vbox.pack_start(hbox, 1, 1)
  dialog.connect('delete-event', lambda widget, event: gtk.main_quit())
  dialog.show_all()

def spin_activate(spin):
  s = spin.get_text()
  print s
  spin.set_text(s)
  return True

def key_press(widget, event):
  k = event.keyval
  print k
  if k==65293:
    #widget.set_text('OK')
    return True
  elif k==65362:
    return True
  elif k==65364:
    return True
  else:
    return False

def button_press(widget, e):
  if e.button==1:
    print e.x, e.y
    #print dir(e)
  else:
    return False

def showEvent(widget, event=None):
  print event.type.value_name  



if __name__=='__main__':
  import sys
  #from gtk import main
  #import psyco
  #psyco.full()
  example1()
  gtk.main()

