#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#    Copyright (C) 2009 Saeed Rasooli <saeed.gnu@gmail.com> (ilius)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program. If not, see <http://www.gnu.org/licenses/gpl.txt>.
#    Or on Debian systems, from /usr/share/common-licenses/GPL

import sys
from os.path import dirname, join

thisDir = dirname(sys.argv[0])
rootDir = dirname(thisDir)
srcDir = join(rootDir, 'src')

sys.path.append(srcDir)

from starcal_main import *
_ = com.translator

import gnomeapplet


#class MyApplet(gnomeapplet.Applet):
#  def __init__(self, applet):
#    applet.__init__(self)


class StarCalApplet(StarCal):
  def getattribute(self, atrib):
    #if 'allocation' in atrib:
    #print 'getattribute', atrib
    return object.__getattribute__(self, atrib)
  def __init__(self, applet, iid):
    #self.applet = MyApplet(applet)
    self.applet = applet
    self.applet.__getattribute__ = self.getattribute
    #self.applet.get_property('popup')
    applet.connect('change_background', self.onChangeBg)
    StarCal.__init__(self, trayMode=1)
    timeout_add(self.timeout, self.trayUpdate)
    self.cbStartCommon.hide() ##set_sensitive(False)
    self.cbShowMain.hide() ##set_sensitive(False)
    ##self.dialog.quitToolButton.set_sensitive(False)
    #print 'self.applet', type(self.applet)
    ##self.menu = self.menu_get_for_attach_widget()##????????
    self.dialog.connect('unmap', lambda w: self.tbutton.set_active(False))##???????
  def dialogClose(self, *args):
    self.tbutton.set_active(False)
    self.dialog.hide()
  def dialogEsc(self):
    self.tbutton.set_active(False)
    self.dialog.hide()
  def trayInit(self):
    self.image = gtk.Image()
    self.tooltips = gtk.Tooltips()
    self.tbutton = gtk.ToggleButton()
    self.tbutton.set_relief(gtk.RELIEF_NONE)
    self.tbutton.connect('toggled', self.trayClicked)
    self.tbutton.connect('button_press_event', self.appletButtonPress)
    self.applet.setup_menu(
'''<popup name="button3">
<menuitem name="ctime"	verb="ctime"  label="%s" pixtype="stock" pixname="gtk-copy"/>
<menuitem name="cdate"	verb="cdate"  label="%s" pixtype="stock" pixname="gtk-copy"/>
<menuitem name="adjust"	verb="adjust" label="%s" pixtype="stock" pixname="gtk-preferences"/>
<menuitem name="add"	verb="add"    label="%s" pixtype="stock" pixname="gtk-add"/>
<menuitem name="export"	verb="export" label="%s" pixtype="stock" pixname="gtk-convert"/>
<menuitem name="pref"	verb="pref"   label="%s" pixtype="stock" pixname="gtk-preferences"/>

<menuitem name="about" 	verb="about"  label="%s" pixtype="stock" pixname="gtk-about"/>
</popup>'''%(
_('Copy _Time'),
_('Copy _Date'),
_('Ad_just System Time'),
_('_Add Custom Day'),
_('_Export to HTML'),
_('_Preferences'),
_('_About')
),
[
  ('ctime',		self.copyTime),
  ('cdate',		self.copyDateToday),
  ('adjust',	self.adjustTime),
  ('add',		self.showCustomDayTray),
  ('pref',		self.prefShow),
  ('export',	self.exportClickedTray),
  ('about',		self.aboutShow)
], None)
    ###################################
    #popup = self.applet.get_popup_component()
    #print type(popup)
    ###################################
    hbox = gtk.HBox()
    hbox.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(self.image, 0, 0)
    self.clockTr = None
    self.trayHbox = hbox
    self.updateTrayClock()
    self.tbutton.add(hbox)
    self.applet.add(self.tbutton)
    #######
    self.applet.show_all()
    #self.applet.set_background_widget(self.applet)#????????
    self.trayPix = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, com.traySize, com.traySize)
  def trayClicked(self, toggle):
    ##print tuple(self.menu.allocation)
    #print 'self.sicon.get_size()', self.sicon.get_size() ## height of panel - 2
    if toggle.get_active():
      if (com.winX, com.winY) == (-1, -1):
        try:
          (x0, y0) = self.applet.window.get_origin()
          com.winX = x0 + (self.applet.allocation.width-com.winWidth)/2
          com.winY = y0 + self.applet.allocation.height - 3
        except:
          com.myRaise(__file__)
      self.dialog.move(com.winX, com.winY)
      ## every calling of .hide() and .present(), makes dialog not on top (forgets being on top)
      act = self.checkAbove.get_active()
      self.dialog.set_keep_above(act)
      self.dialog.lowerWin.set_keep_above(act)
      if self.checkSticky.get_active():
        self.dialog.stick()
        self.dialog.lowerWin.stick()
      self.dialog.deiconify()
      self.dialog.present()
    else:
      (com.winX, com.winY) = self.dialog.get_position()
      self.dialog.hide()
  def appletButtonPress(self, widget, event):
    #print 'appletButtonPress', event.button
    if event.button != 1:
      widget.stop_emission('button_press_event')
    return False
  def updateTrayClock(self):
    if com.showDigClockTr:
      if self.clockTr==None:
        self.clockTr = com.FClockLabel(com.clockFormat) ## OR FClockImage
        self.trayHbox.pack_start(self.clockTr, 0, 0)
        self.clockTr.show()
      else:
        self.clockTr.format = com.clockFormat
    else:
      if self.clockTr!=None:
        self.clockTr.destroy()
        self.clockTr = None
  def trayUpdate(self, gdate=None, check=True):
    if gdate==None:
      gdate = time.localtime()[:3]
    #print 'trayUpdate', self.lastGDate, gdate
    if self.lastGDate!=gdate or not check:
      jd = cal.modules[cal.DATE_GREG].to_jd(*gdate)
      if com.primaryMode==cal.DATE_GREG:
        ddate = gdate
      else:
        ddate = cal.modules[com.primaryMode].jd_to(jd)
      print('Updating tray to date %s'%com.dateStr(*ddate))
      self.lastGDate = gdate
      self.todayCell = self.dialog.getDateCell(*ddate)
      if self.todayCell.holiday:
        pixbuf = gdk.pixbuf_new_from_file(com.trayImageHoli)
      else:
        pixbuf = gdk.pixbuf_new_from_file(com.trayImage)
      ##pixbuf.scale() #????????????
      ###################### PUTTING A TEXT ON A PIXBUF
      pmap = pixbuf.render_pixmap_and_mask(alpha_threshold=127)[0] ## pixmap is also a drawable
      textLay = self.dialog.create_pango_layout(numLocal(ddate[2]))
      if com.trayFont==None:
        if not com.fontUseDefault:
          textLay.set_font_description(pango.FontDescription(com.fontCustom))
      else:
        textLay.set_font_description(pango.FontDescription(com.trayFont))
      (w, h) = textLay.get_pixel_size()
      s = com.traySize
      if com.trayY0 == None:
        y = s/4+int((0.9*s-h)/2)
      else:
        y = com.trayY0
      pmap.draw_layout(pmap.new_gc(), (s-w)/2, y, textLay, com.trayTextColor)## , foreground, background)
      self.trayPix.get_from_drawable(pmap, self.dialog.get_screen().get_system_colormap(), 0, 0, 0, 0, s, s)
      ######################################
      self.image.set_from_pixbuf(self.trayPix)
      wd = cal.getWeekDay(ddate[0], ddate[1], ddate[2], com.primaryMode, com.firstWeekDay)
      tt = com.getWeekDayN(wd)
      #if com.extradayTray:##?????????
      #  sep = _(',')+' '
      #else:
      sep = '\n'
      for item in com.shownDates:
        if item['enable']:
          mode = item['mode']
          (y, m, d) = self.todayCell.dates[mode]
          tt += '%s%s %s %s'%(sep, numLocal(d), _(cal.modules[mode].getMonthName(m, y)), numLocal(y))
      if com.extradayTray:
        self.dialog.loadExtraDaysDB(False)
        text = self.todayCell.extraday
        if text!='':
          tt += '\n\n%s'%text.replace('\t', '\n') #????????????
      try:
        self.tooltips.set_tip(self.tbutton, tt)
      except:
        com.myRaise(__file__)
    return True
  def onChangeBg(self, applet, typ, color, pixmap):
    applet.set_style(None)
    rc_style = gtk.RcStyle()
    applet.modify_style(rc_style)
    if (typ == gnomeapplet.COLOR_BACKGROUND):
      applet.modify_bg(gtk.STATE_NORMAL, color)
    elif (typ == gnomeapplet.PIXMAP_BACKGROUND):
      style = applet.style
      style.bg_pixmap[gtk.STATE_NORMAL] = pixmap
      applet.set_style(style)  
  def restart(self):
    #os.popen2('killall \'%s\''%os.path.split(__file__)[1])
    sys.exit(0)


def starcalAppletFactory(applet, iid):
  scal = StarCalApplet(applet, iid)
  return True


if len(sys.argv)>1 and sys.argv[1] in ('run-in-window', '-w', '--window'):
  main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
  main_window.set_title('StarCalendar Gnome Applet')
  main_window.connect('destroy', gtk.main_quit) 
  app = gnomeapplet.Applet()
  starcalAppletFactory(app, None)
  app.reparent(main_window)
  main_window.show_all()
  sys.exit(gtk.main())

if __name__ == '__main__':
  gnomeapplet.bonobo_factory('OAFIID:GNOME_StarCalendarApplet_Factory',
                             gnomeapplet.Applet.__gtype__,
                             'StarCalendar', '0', starcalAppletFactory)


