#!/usr/bin/env python
# -*- coding: utf-8 -*-
#    
#    Copyright (C) 2007  Mola Pahnadayan
#    Copyright (C) 2009  Saeed Rasooli <saeed.gnu@gmail.com> (ilius)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License,  or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful, 
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License along
#    with this program. If not, see <http://www.gnu.org/licenses/gpl.txt>.
#    Or on Debian systems, from /usr/share/common-licenses/GPL


VERSION='1.5.3'
#COMMAND='starcal'


homePage = 'http://starcal.sourceforge.net/'
## http://ospdev.net/projects/starcal


import sys, os
if len(sys.argv)>1:
  if sys.argv[1] in ('--help', '-h'):
    print 'No help implemented yet!'
    sys.exit(0)
  elif sys.argv[1]=='--version':
    print(VERSION)
    sys.exit(0)

def getOsDesc():
  name = ''
  if os.path.isfile('/etc/lsb-release'):
    lines = file('/etc/lsb-release').read().split('\n')
    for line in lines:
      if line.startswith('DISTRIB_DESCRIPTION='):
        name = line.split('=')[1]
        if name[0]=='"' and name[-1]=='"':
          return name[1:-1]
  if os.path.isfile('/suse/etc/SuSE-release'):
    return file('/suse/etc/SuSE-release').read().split('\n')[0]
  if os.name=='posix':
    osType = os.getenv('OSTYPE')
    if osType!='':
      return osType
  return os.name

print('StarCalendar %s\n%s\nPython %s'%(VERSION, getOsDesc(), sys.version.replace('\n', ' ')))

import gobject
import common as com ### Here pointer chnages to clock
from common import os, time, cal, convert, timeout_add, gtk, gdk, pango, numLocal,\
  getSysDate, gdkColorToHtml, image_from_file, MyColorButton, set_tooltip
from mywidgets import DateBox, YearMonthBox
#from mywidgets2 import DateButtonOption
##############
_ = com.translator
import maindialog, customday
'''
    try:
      import psyco
    except ImportError:
      print('Warning: module "psyco" not found. It could speed up execution.')
      psyco_found=False
    else:
      psyco.full()
      print('Using module "psyco" to speed up execution.')
      psyco_found=True'''



## (VAR_NAME, bool,	CHECKBUTTON_TEXT)					## ChekButton
## (VAR_NAME, list,	LABEL_TEXT, (ITEM1, ITEM2, ...))	## ComboBox
## (VAR_NAME, int,	LABEL_TEXT, MIN, MAX)				## SpinButton
## (VAR_NAME, float,LABEL_TEXT, MIN, MAX, DIGITS)		## SpinButton
class OptionLayer:
  def __init__(self, mod, opt):
    t = opt[1]
    self.opt = opt ## needed??
    self.module = mod
    self.type = t
    self.var = opt[0]
    hbox = gtk.HBox()
    if t==bool:
      w = gtk.CheckButton(_(opt[2]))
      self.get_value = w.get_active
      self.set_value = w.set_active
    elif t==list:
      hbox.pack_start(gtk.Label(_(opt[2])), 0, 0)
      w = gtk.combo_box_new_text() ### or RadioButton
      for s in opt[3]:
        w.append_text(_(s))
      self.get_value = w.get_active
      self.set_value = w.set_active
    elif t==int:
      hbox.pack_start(gtk.Label(_(opt[2])), 0, 0)
      w = gtk.SpinButton()
      w.set_increments(1, 10)
      w.set_range(opt[3], opt[4])
      w.set_digits(0)
      w.set_direction(gtk.TEXT_DIR_LTR)
      self.get_value = w.get_value
    elif t==float:
      hbox.pack_start(gtk.Label(_(opt[2])), 0, 0)
      w = gtk.SpinButton()
      w.set_increments(0.1, 1)
      w.set_range(opt[3], opt[4])
      w.set_digits(opt[5])
      w.set_direction(gtk.TEXT_DIR_LTR)
      self.get_value = w.get_value
      self.set_value = w.set_value
    else:
      raise RuntimeError('bad option type "%s"'%t)
    hbox.pack_start(w, 0, 0)
    self.widget = hbox
    ####
    self.update_var = lambda: setattr(self.module, self.var, self.get_value())
    self.update_widget = lambda: self.set_value(getattr(self.module, self.var))

  

class StarCal(gobject.GObject):
  timeout = 1000 ## mili second
  def __init__(self, trayMode=3):
    gobject.GObject.__init__(self)
    ## trayMode:
      ## ('none', 'none')
      ## ('tray', 'normal')
      ## ('tray', 'egg')
      ## ('applet', 'gnome')
      ## ('applet', 'kde')
      ##
      ## 0: none (simple window)
      ## 1: applet
      ## 2: standard tray icon
      ## 3: egg tray icon
    self.trayMode = trayMode
    self.customDay = customday.CustomDayDialog(self)
    ###########
    date = com.getSysDate()    
    self.year=date[0]
    self.month=date[1]
    self.day=date[2]
    self.dialog=maindialog.MainDialog(self.year,  self.month,  self.day,  self)
    ############
    self.lastGDate = None
    ############
    #self.connect('main-show', lambda arg: self.dialog.present())
    #self.connect('main-hide', lambda arg: self.dialog.hide())
    ############
    self.pref={}
    self.prefKeys=[]
    ############## making preferences (prefInit) ##############################
    self.dialog_pref = gtk.Dialog(title=_('Preferences'))
    self.dialog_pref.connect('delete-event', self.prefHide)
    self.dialog_pref.set_has_separator(False)
    #self.dialog_pref.set_skip_taskbar_hint(True)
    cancelB = self.dialog_pref.add_button(gtk.STOCK_CANCEL, 1)
    applyB = self.dialog_pref.add_button(gtk.STOCK_APPLY, 2)
    okB = self.dialog_pref.add_button(gtk.STOCK_OK, 3)
    if com.autoLocal:
      cancelB.set_label(_('_Cancel'))
      cancelB.set_image(gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON))
      applyB.set_label(_('_Apply'))
      applyB.set_image(gtk.image_new_from_stock(gtk.STOCK_APPLY,gtk.ICON_SIZE_BUTTON))
      okB.set_label(_('_OK'))
      okB.grab_default()#?????????
      #okB.grab_focus()#?????????
    cancelB.connect('clicked', self.prefCancel)
    applyB.connect('clicked', self.prefApply)
    okB.connect('clicked', self.prefOk)
    set_tooltip(okB, _('Apply and Close'))
    ##########
    self.vbox_pref = self.dialog_pref.vbox
    ################################ Tab 1 ############################################
    vbox = gtk.VBox()
    vbox1 = vbox
    hb = gtk.HBox(spacing=3)
    hb.pack_start(gtk.Label(_('Language')), 0, 0)
    ##combo = gtk.combo_box_new_text()
    ls = gtk.ListStore(gdk.Pixbuf, str)
    combo = gtk.ComboBox(ls)
    ###
    cell = gtk.CellRendererPixbuf()
    combo.pack_start(cell, False)
    combo.add_attribute(cell, 'pixbuf', 0)  
    ###
    cell = gtk.CellRendererText()
    combo.pack_start(cell, True)
    combo.add_attribute(cell, 'text', 1)  
    ###
    for item in com.langList:
      im = item[3]
      if im==None:
        pix = im
      else:
        if not im.startswith('/'):
          im = '%s%s%s'%(com.pixDir,os.sep,im)
        pix = gdk.pixbuf_new_from_file(im)
      ls.append([pix, item[0]])
    ###  
    hb.pack_start(combo, 0, 0)
    self.combo_lang = combo
    hb.pack_start(gtk.Label('Language'), 0, 0)
    vbox.pack_start(hb, 0, 0)
    sgroupFont = gtk.SizeGroup(gtk.SIZE_GROUP_HORIZONTAL)
    ##########################
    exp = gtk.Expander(_('Shown Calendars'))
    exp.set_expanded(True)
    vboxE = gtk.VBox()
    #vbox.pack_start(gtk.Label(_('Shown Calendars')), 0, 0) 
    self.hbox=[]
    self.checkb=[]
    self.combo=[]
    self.label=[]
    self.spinX=[]
    self.spinY=[]
    self.fontb=[]
    self.colorb=[]
    for i in xrange(max(com.shownDatesNum,3)):
      hb = gtk.HBox()
      ##########
      checkb = gtk.CheckButton()
      set_tooltip(checkb, _('Enable/Disable'))
      self.checkb.append(checkb)
      hb.pack_start(checkb, 0, 0)
      ####
      combo = gtk.combo_box_new_text()
      for m in cal.modules:
        combo.append_text(_(m.desc))
      #if i>0:#????????????
      #  combo.append_text(_('Julian Day'))
      self.combo.append(combo)
      hb.pack_start(combo, 0, 0)
      hb.pack_start(gtk.Label(''), 1, 1)
      ###
      label = gtk.Label(_(' position'))
      self.label.append(label)
      ###
      hb.pack_start(label, 0, 0)
      ###
      spin = gtk.SpinButton()
      spin.set_increments(1, 10)
      spin.set_range(-99, 99)
      spin.set_digits(1)
      #spin.set_width_chars(3)
      self.spinX.append(spin)
      spin.set_direction(gtk.TEXT_DIR_LTR)
      hb.pack_start(spin, 0, 0)
      ###
      spin = gtk.SpinButton()
      spin.set_increments(1, 10)
      spin.set_range(-99, 99)
      spin.set_digits(1)
      #spin.set_width_chars(3)
      self.spinY.append(spin)
      spin.set_direction(gtk.TEXT_DIR_LTR)
      hb.pack_start(spin, 0, 0)
      ####
      hb.pack_start(gtk.Label(''), 1, 1)
      ###
      fontb=gtk.FontButton()
      self.fontb.append(fontb)
      hb.pack_start(fontb, 0, 0)
      sgroupFont.add_widget(fontb)
      ##
      com.fontBottonDefineDrag(fontb, self.dialog)
      ####
      colorb=MyColorButton()
      self.colorb.append(colorb)
      hb.pack_start(colorb, 0, 0)
      ##########
      vboxE.pack_start(hb, 0, 0)
      self.hbox.append(hb)
    exp.add(vboxE)
    vbox.pack_start(exp, 0, 0)
    ##########################
    ####
    hb = gtk.HBox(spacing=3)
    self.cbStartCommon = gtk.CheckButton(_('Run on session startup'))
    set_tooltip(self.cbStartCommon,\
      'Run on startup of Gnome, KDE, Xfce, LXDE, ...\nFile: %s'%com.comDesk)
    hb.pack_start(self.cbStartCommon, 1, 1)
    vbox.pack_start(hb, 0, 0)
    ######
    self.cbShowMain = gtk.CheckButton(_('Show main window on start'))
    #hb.pack_start(self.cbShowMain, 1, 1)
    vbox.pack_start(self.cbShowMain, 0, 0) 
    #### calHeight
    #hbox = gtk.HBox(spacing=3)
    #vbox.pack_start(hbox, 0, 0)
    ####### 
    hbox = gtk.HBox(spacing=3)
    ##
    self.checkTaskbar = gtk.CheckButton(_('Window in Taskbar'))
    hbox.pack_start(self.checkTaskbar, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ##
    self.checkWinCont = gtk.CheckButton(_('Show Window Controllers'))
    hbox.pack_start(self.checkWinCont, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ##
    vbox.pack_start(hbox, 0, 0)
    #######
    #self.checkShowToolbar = gtk.CheckButton(_('Show Toolbar'))
    #vbox.pack_start(self.checkShowToolbar, 0, 0)
    #######
    hbox = gtk.HBox(spacing=3)
    hbox.pack_start(gtk.Label(_('Show Digital Clock:')), 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    self.checkClockTb = gtk.CheckButton(_('On Toolbar'))
    if trayMode==1:
      self.checkClockTr = gtk.CheckButton(_('On Applet'))
      set_tooltip(self.checkClockTr, 'Panel Applet')
    else:
      self.checkClockTr = gtk.CheckButton(_('On Tray'))
      set_tooltip(self.checkClockTr, 'Notification Area')
    hbox.pack_start(self.checkClockTb, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(self.checkClockTr, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    vbox.pack_start(hbox, 0, 0)
    ################################ Tab 2 ################################################
    vbox = gtk.VBox()
    vbox2 = vbox
    hbox = gtk.HBox(spacing=2)
    self.cbGrid = gtk.CheckButton(_('Grid'))
    hbox.pack_start(self.cbGrid, 0, 0)
    self.colorbGrid = MyColorButton()
    self.colorbGrid.set_use_alpha(True)
    hbox.pack_start(self.colorbGrid, 0, 0)
    self.cbGrid.connect('clicked', lambda wid: self.colorbGrid.set_sensitive(wid.get_active()))
    ##
    hbox.pack_start(gtk.Label(''), 1, 1)
    self.checkbFont = gtk.CheckButton(_('Use system font'))
    set_tooltip(self.checkbFont, com.fontDefault)
    hbox.pack_start(self.checkbFont, 0, 0)
    self.fontbApp = gtk.FontButton()
    hbox.pack_start(self.fontbApp, 0, 0)
    com.fontBottonDefineDrag(self.fontbApp, self.dialog)
    hbox.pack_start(gtk.Label(''), 1, 1)
    #self.checkbFont.connect('clicked', self.checkbFontClicked)
    self.checkbFont.connect('clicked', lambda widget: self.fontbApp.set_sensitive(not self.checkbFont.get_active()))
    vbox.pack_start(hbox, 0, 0)
    ######
    hbox = gtk.HBox(spacing=2)
    self.cbCustTxt = gtk.CheckButton(_('Custom days text (below calendar)'))
    hbox.pack_start(self.cbCustTxt, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    #vbox.pack_start(hbox, 0, 0)
    ###
    #hbox = gtk.HBox(spacing=3)
    self.cbCustIcon = gtk.CheckButton(_('Custom days icon (in the calendar)'))
    hbox.pack_start(self.cbCustIcon, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    vbox.pack_start(hbox, 0, 0)
    ########################### Theme #####################
    hbox = gtk.HBox(spacing=3)
    self.checkDeskBg = gtk.CheckButton(_('Use Desktop Background'))
    hbox.pack_start(self.checkDeskBg, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    vbox.pack_start(hbox, 0, 0)
    #####################
    hbox = gtk.HBox(spacing=3)
    lab = gtk.Label('<b>%s:</b> '%_('Colors'))
    lab.set_use_markup(True)
    hbox.pack_start(lab, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    hbox.pack_start(gtk.Label(_('Background')), 0, 0)
    self.colorbBg = MyColorButton()
    self.colorbBg.set_use_alpha(True)
    hbox.pack_start(self.colorbBg, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    hbox.pack_start(gtk.Label(_('Border')), 0, 0)
    self.colorbBorder = MyColorButton()
    self.colorbBorder.set_use_alpha(True)
    hbox.pack_start(self.colorbBorder, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    hbox.pack_start(gtk.Label(_('Cursor')), 0, 0)
    self.colorbCursor = MyColorButton()
    hbox.pack_start(self.colorbCursor, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    hbox.pack_start(gtk.Label(_('Cursor BG')), 0, 0)
    self.colorbCursorBg = MyColorButton()
    self.colorbCursorBg.set_use_alpha(True)
    hbox.pack_start(self.colorbCursorBg, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    vbox.pack_start(hbox, 0, 0)
    ####################
    hbox = gtk.HBox(spacing=3)
    lab = gtk.Label('<b>%s:</b> '%_('Font Colors'))
    lab.set_use_markup(True)
    hbox.pack_start(lab, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ####
    hbox.pack_start(gtk.Label(_('Holiday')), 0, 0)
    self.colorbHoliday = MyColorButton()
    hbox.pack_start(self.colorbHoliday, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ###
    hbox.pack_start(gtk.Label(_('Inactive Day')), 0, 0)
    self.colorbInactive = MyColorButton()
    self.colorbInactive.set_use_alpha(True)
    hbox.pack_start(self.colorbInactive, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ####
    hbox.pack_start(gtk.Label(_('Border')), 0, 0)
    self.colorbBorderText = MyColorButton()
    hbox.pack_start(self.colorbBorderText, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    ####
    vbox.pack_start(hbox, 0, 0)
    ###################
    hbox = gtk.HBox(spacing=3)
    hbox2 = gtk.HBox(spacing=3)
    self.checkYmArrows = gtk.CheckButton('')
    self.checkYmArrows.connect('clicked', self.checkYmArrowsClicked)
    self.ymArrowHbox = hbox2
    #self.checkYmArrows.connect('clicked', lambda obj: hbox2.set_sensitive(self.checkYmArrows.get_active()))
    hbox.pack_start(self.checkYmArrows, 0, 0)
    hbox2.pack_start(gtk.Label(_('Previous year/month button')), 0, 0)
    im1 = gtk.Image()
    ev1 = gtk.EventBox()
    ev1.add(im1)
    ev1.connect('button-press-event', self.imageClicked, 1)
    hbox2.pack_start(ev1, 0, 0)
    ##
    hbox2.pack_start(gtk.Label(''), 1, 1)
    hbox2.pack_start(gtk.Label(_('Next')), 0, 0)
    im2 = gtk.Image()
    ev2 = gtk.EventBox()
    ev2.add(im2)
    ev2.connect('button-press-event', self.imageClicked, 2)
    hbox2.pack_start(ev2, 0, 0)
    ##
    menu = gtk.Menu()
    for stock in (gtk.STOCK_GO_UP,gtk.STOCK_GO_DOWN,gtk.STOCK_GO_BACK,gtk.STOCK_GO_FORWARD,\
    gtk.STOCK_ZOOM_IN,gtk.STOCK_ZOOM_OUT,gtk.STOCK_ADD,gtk.STOCK_REMOVE):
        menu.add(self.stockMenuItem(stock, self.imageSet, stock))
    for arrow in (gtk.ARROW_LEFT, gtk.ARROW_RIGHT, gtk.ARROW_UP, gtk.ARROW_DOWN):
        menu.add(self.newArrowMenuItem(arrow, self.imageSet, arrow))
    menu.show_all()
    self.menu_im = menu
    self.im1 = im1
    self.im2 = im2
    self.ev1 = ev1
    self.ev2 = ev2
    hbox2.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(hbox2, 1, 1)
    #########
    hbox.pack_start(gtk.Label(_('Left Margin')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 100)
    spin.set_width_chars(2)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(spin, 0, 0)
    self.spinLeftMar = spin
    ####
    hbox.pack_start(gtk.Label(_('Top')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 100)
    spin.set_width_chars(2)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(spin, 0, 0)
    self.spinTopMar = spin
    hbox.pack_start(gtk.Label(''), 1, 1)
    ####
    vbox.pack_start(hbox, 0, 0)
    ################
    hbox = gtk.HBox(spacing=1)
    label = gtk.Label('<b>%s</b>:'%_('Cursor'))
    label.set_use_markup(True)
    hbox.pack_start(label, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(gtk.Label(_('Diameter')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 20)
    spin.set_width_chars(2)
    spin.set_digits(1)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(spin, 0, 0)
    self.spinCurD = spin
    ###
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(gtk.Label(_('Round')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 99)
    spin.set_width_chars(2)
    spin.set_digits(1)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(spin, 0, 0)
    #hbox.pack_start(gtk.Label(''), 1, 1)
    self.spinCurR = spin
    ###
    hbox2 = gtk.HBox(spacing=1)
    self.cursorFixedHbox = hbox2
    self.cursorFixedCheck = gtk.CheckButton(_('Fixed Size'))
    self.cursorFixedCheck.connect('clicked', self.cursorFixedClicked)
    hbox2.set_sensitive(com.cursorFixed)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(self.cursorFixedCheck, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox2.pack_start(gtk.Label(_('Width')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 100)
    spin.set_width_chars(2)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox2.pack_start(spin, 0, 0)
    #hbox.pack_start(gtk.Label(''), 1, 1)
    self.spinCurW = spin
    ####
    hbox2.pack_start(gtk.Label(_('Height')), 0, 0)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 100)
    spin.set_width_chars(2)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox2.pack_start(spin, 0, 0)
    self.spinCurH = spin
    #hbox2.pack_start(gtk.Label(''), 1, 1)
    ####
    hbox.pack_start(hbox2, 1, 1)
    vbox.pack_start(hbox, 0, 0)
    #############
    hbox = gtk.HBox(spacing=1)
    hbox.pack_start(gtk.Label(_('Drag & Drop Icon:')), 0, 0)
    radio0 = gtk.RadioButton(label=_('Date String'))
    set_tooltip(radio0, 'yyyy/mm/dd')
    radio1 = gtk.RadioButton(label=_('Cell Image'), group=radio0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(radio0, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    hbox.pack_start(radio1, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    radio0.set_active(True)
    #self.dragRadio0 = radio0
    self.dragRadio1 = radio1
    vbox.pack_start(hbox, 0, 0)
    ################################ Tab 3 (Advanced) ###########################################
    vbox = gtk.VBox()
    sgroup = gtk.SizeGroup(gtk.SIZE_GROUP_HORIZONTAL)
    ######
    hbox = gtk.HBox(spacing=5)
    label = gtk.Label(_('Date Format'))
    label.set_alignment(0, 0.5)
    hbox.pack_start(label, 0, 0)
    sgroup.add_widget(label)
    #hbox.pack_start(gtk.Label(''), 1, 1)
    combo = gtk.combo_box_entry_new_text()
    combo.append_text('%Y/%m/%d')
    combo.append_text('%Y-%m-%d')
    combo.append_text('%y/%m/%d')
    combo.append_text('%y-%m-%d')
    if com.lang==2:
      combo.append_text('%OY/%Om/%Od')
      combo.append_text('%OY-%Om-%Od')
    combo.append_text('%m/%d')
    combo.append_text('%m/%d/%Y')
    ##combo.child.set_width_chars(20)
    hbox.pack_start(combo, 1, 1)
    self.dateFormatEntry = combo.child
    vbox.pack_start(hbox, 0, 0)
    ###
    hbox = gtk.HBox(spacing=5)
    #hbox.pack_start(gtk.Label(''), 1, 1)
    label = gtk.Label(_('Digital Clock Format'))
    label.set_alignment(0, 0.5)
    hbox.pack_start(label, 0, 0)
    sgroup.add_widget(label)
    combo = gtk.combo_box_entry_new_text()
    combo.append_text('%T')
    combo.append_text('%X')
    combo.append_text('%Y/%m/%d - %T')
    if com.lang==2:
      combo.append_text('%OY/%Om/%Od - %X')
    ## %O? is define only for persian ?????!
    combo.append_text('<i>%Y/%m/%d</i> - %T')
    combo.append_text('<b>%T</b>')
    combo.append_text('<b>%X</b>')
    combo.append_text('%H:%M')
    combo.append_text('<b>%H:%M</b>')
    combo.append_text('<span size="smaller">%OY/%Om/%Od</span>,%X')
    combo.append_text('%OY/%Om/%Od,<span color="#ff0000">%X</span>')
    combo.append_text('<span font="bold">%X</span>')
    if com.lang==2:
      combo.append_text('%OH:%OM')
      combo.append_text('<b>%OH:%OM</b>')
    ##combo.child.set_width_chars(20)
    self.clockFormatEntry = combo.child
    hbox.pack_start(combo, 1, 1)
    vbox.pack_start(hbox, 0, 0)
    ######
    hbox = gtk.HBox(spacing=5)
    label = gtk.Label(_('Cache Size for Months'))
    label.set_alignment(0, 0.5)
    hbox.pack_start(label, 0, 0)
    ##sgroup.add_widget(label)
    spin = gtk.SpinButton()
    spin.set_increments(1, 10)
    spin.set_range(0, 10000)
    spin.set_width_chars(3)
    spin.set_direction(gtk.TEXT_DIR_LTR)
    hbox.pack_start(spin, 0, 0)
    self.spinCache = spin
    vbox.pack_start(hbox, 0, 0)
    vbox4 = vbox
    ########
    hbox = gtk.HBox(spacing=3)
    hbox.pack_start(gtk.Label(_('First day of week')), 0, 0)
    self.comboFirstWD = gtk.combo_box_new_text()
    for item in com.weekDayName:
      self.comboFirstWD.append_text(item)
    self.comboFirstWD.append_text(_('Automatic'))
    self.comboFirstWD.connect('changed', self.comboFirstWDChanged)
    hbox.pack_start(self.comboFirstWD, 0, 0)
    vbox.pack_start(hbox, 0, 0)
    #########
    hbox0 = gtk.HBox(spacing=0)
    hbox0.pack_start(gtk.Label(_('Holidays:')+'  '), 0, 0)
    hbox = gtk.HBox(spacing=0)
    hbox.set_homogeneous(True)
    cbList = [gtk.CheckButton(item) for item in com.weekDayName]
    f = com.firstWeekDay
    for i in range(6):
      hbox.pack_start(cbList[(f+i)%7], 1, 1)
    hbox.pack_start(cbList[(f+6)%7], 1, 1)
    self.holidayWeekDaysCb = cbList
    self.holidayHbox = hbox
    hbox0.pack_start(hbox, 1, 1)
    vbox.pack_start(hbox0, 0, 0)
    #########
    hbox = gtk.HBox(spacing=3)
    hbox.pack_start(gtk.Label(_('First week of year containts:')), 0, 0)
    combo = gtk.combo_box_new_text()
    texts = [_('First %s of year')%name for name in com.weekDayName]+[_('First day of year')]
    texts[4] += ' (ISO 8601)' ##??????
    for text in texts:
      combo.append_text(text)
    #combo.append_text(_('Automatic'))## (as Locale)#?????????????????
    hbox.pack_start(combo, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    vbox.pack_start(hbox, 0, 0)
    self.comboWeekYear = combo
    ################################
    options = []
    for mod in cal.modules:
      for opt in mod.options:
        optl = OptionLayer(mod, opt)
        options.append(optl)
        vbox.pack_start(optl.widget, 0, 0)
    self.options = options
    ################################ Tab 4 (Manage DB) ############################################
    #'''
    vbox = gtk.VBox()
    vbox3 = vbox
    ####
    ##extradayEnable:
    hb = gtk.HBox()
    self.checkbExtradayEnable = gtk.CheckButton(_('Show below calendar'))
    #self.checkbExtradayEnable.connect('clicked', self.checkbExtradayEnableClicked)#???????
    hb.pack_start(self.checkbExtradayEnable, 0, 0)
    #vbox.pack_start(hb, 0, 0)
    #####
    ##extradayTray:
    #hb = gtk.HBox()
    hb.pack_start(gtk.Label(''), 1, 1)
    if self.trayMode==1:
      self.checkbExtradayTray = gtk.CheckButton(_('Show in applet (for today)'))
    else:
      self.checkbExtradayTray = gtk.CheckButton(_('Show in tray (for today)'))
    #self.checkbExtradayTray.connect('clicked', self.checkbExtradayTrayClicked)
    hb.pack_start(self.checkbExtradayTray, 0, 0)
    hb.pack_start(gtk.Label(''), 1, 1)
    vbox.pack_start(hb, 0, 0)
    #####
    treev = gtk.TreeView()
    treev.set_headers_clickable(True)
    #treev.connect('cursor-changed', self.plugTreeviewButtonPress)
    trees = gtk.ListStore(int, bool, bool, str)
    treev.set_model(trees)
    treev.enable_model_drag_source(gdk.BUTTON1_MASK,
      [('row', gtk.TARGET_SAME_WIDGET, 0)], gdk.ACTION_MOVE)
    treev.enable_model_drag_dest([('row', gtk.TARGET_SAME_WIDGET, 0)], gdk.ACTION_MOVE)
    treev.connect('drag_data_received', self.plugTreevDragReceived)
    treev.connect('cursor-changed', self.plugTreevCursorChanged)
    treev.connect('row-activated', self.plugTreevRActivate)
    ###
    #treev.drag_source_set_icon_stock(gtk.STOCK_CLOSE)
    #treev.drag_source_add_text_targets()
    #treev.drag_source_add_uri_targets()
    #treev.drag_source_unset()
    ###
    swin = gtk.ScrolledWindow()
    swin.add(treev)
    swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    ######
    cell = gtk.CellRendererToggle()
    #cell.set_property('activatable', True)
    cell.connect('toggled', self.plugTreeviewCellToggled)
    col = gtk.TreeViewColumn(_('Enable'), cell)
    col.add_attribute(cell, "active", 1)
    #cell.set_active(False)
    col.set_resizable(True)
    treev.append_column(col)
    ######
    cell = gtk.CellRendererToggle()
    #cell.set_property('activatable', True)
    cell.connect('toggled', self.plugTreeviewCellToggled2)
    col = gtk.TreeViewColumn(_('Show Date'), cell)
    col.add_attribute(cell, "active", 2)
    #cell.set_active(False)
    col.set_resizable(True)
    treev.append_column(col)
    ######
    #cell = gtk.CellRendererText()
    #col = gtk.TreeViewColumn(_('File Name'), cell, text=2)
    #col.set_resizable(True)
    #treev.append_column(col)
    #treev.set_search_column(1)
    ######
    cell = gtk.CellRendererText()
    #cell.set_property('wrap-mode', gtk.WRAP_WORD)
    #cell.set_property('editable', True)
    #cell.set_property('wrap-width', 200)
    col = gtk.TreeViewColumn(_('Description'), cell, text=3)
    #treev.connect('expose-event', self.plugTreevExpose)
    #self.plugDescCell = cell
    #self.plugDescCol = col
    #col.set_resizable(True)## No need!
    treev.append_column(col)
    ######
    #for i in xrange(len(com.plugIndex)):
    #  x = com.plugIndex[i]
    #  trees.append([x[0], x[1], x[2], com.allPlugList[x[0]].desc])
    ######
    self.plugTreeview = treev
    self.plugTreestore = trees
    #######################
    hbox = gtk.HBox()
    vboxPlug = gtk.VBox()
    vboxPlug.pack_start(swin, 1, 1)
    hbox.pack_start(vboxPlug, 1, 1)
    ###
    hboxBut = gtk.HBox()
    ###
    button = gtk.Button(_('_About Plugin'))
    button.set_image(gtk.image_new_from_stock(gtk.STOCK_ABOUT, gtk.ICON_SIZE_BUTTON))
    button.set_sensitive(False)
    button.connect('clicked', self.plugAboutClicked)
    self.plugButtonAbout = button
    hboxBut.pack_start(button, 0, 0)
    hboxBut.pack_start(gtk.Label(''), 1, 1)
    ###
    button = gtk.Button(_('C_onfigure Plugin'))
    button.set_image(gtk.image_new_from_stock(gtk.STOCK_PREFERENCES, gtk.ICON_SIZE_BUTTON))
    button.set_sensitive(False)
    button.connect('clicked', self.plugConfClicked)
    self.plugButtonConf = button
    hboxBut.pack_start(button, 0, 0)
    hboxBut.pack_start(gtk.Label(''), 1, 1)
    ###
    vboxPlug.pack_start(hboxBut, 0, 0)
    ###
    toolbar = gtk.Toolbar()
    toolbar.set_orientation(gtk.ORIENTATION_VERTICAL)
    #try:## DeprecationWarning #?????????????
      #toolbar.set_icon_size(gtk.ICON_SIZE_SMALL_TOOLBAR)
      ### no different (argument to set_icon_size does not affect) ?????????
    #except:
    #  pass
    size = gtk.ICON_SIZE_SMALL_TOOLBAR
    ##no different(argument2 to image_new_from_stock does not affect) ?????????
    self.hboxPlug = hbox
    ######## gtk.ICON_SIZE_SMALL_TOOLBAR or gtk.ICON_SIZE_MENU
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_GOTO_TOP, size))
    set_tooltip(tb, _('Move to top'))
    tb.connect('clicked', self.plugTreeviewTop)
    toolbar.insert(tb, 0)
    ########
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_GO_UP, size))
    set_tooltip(tb, _('Move up'))
    tb.connect('clicked', self.plugTreeviewUp)
    toolbar.insert(tb, 1)
    #########
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_GO_DOWN, size))
    set_tooltip(tb, _('Move down'))
    tb.connect('clicked', self.plugTreeviewDown)
    toolbar.insert(tb, 2)
    ########
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_GOTO_BOTTOM, size))
    set_tooltip(tb, _('Move to bottom'))
    tb.connect('clicked', self.plugTreeviewBottom)
    toolbar.insert(tb, 3)
    ##########
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_ADD, size))
    set_tooltip(tb, _('Add'))
    #tb.connect('clicked', lambda obj: self.plugAddDialog.run())
    tb.connect('clicked', self.plugAddClicked)
    #if len(self.plugAddItems)==0:
    #  tb.set_sensitive(False)
    toolbar.insert(tb, 4)
    self.plugButtonAdd = tb
    ###########
    tb = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_DELETE, size))
    set_tooltip(tb, _('Delete'))
    tb.connect('clicked', self.plugTreeviewDel)
    toolbar.insert(tb, 5)
    ###########
    hbox.pack_start(toolbar, 0, 0)
    #####
    '''
    vpan = gtk.VPaned()
    vpan.add1(hbox)
    vbox2 = gtk.VBox()
    vbox2.pack_start(gtk.Label('Test Label'))
    vpan.add2(vbox2)
    vpan.set_position(100)
    vbox.pack_start(vpan)
    '''
    vbox.pack_start(hbox, 1, 1)
    ##########################
    d = gtk.Dialog()
    d.set_transient_for(self.dialog_pref)
    ## dialog.set_transient_for(parent) makes the window on top of parent and at the center point of parent
    ## but if you call dialog.show() or dialog.present(), the parent is still active(clickabel widgets) before closing child "dialog"
    ## you may call dialog.run() to realy make it transient for parent
    d.set_has_separator(False)
    d.connect('delete-event', self.plugAddDialogClose)
    d.set_title(_('Add Plugin'))
    canB = d.add_button(gtk.STOCK_CANCEL, 1)
    okB = d.add_button(gtk.STOCK_OK, 2)
    canB.connect('clicked', self.plugAddDialogClose)
    okB.connect('clicked', self.plugAddDialogOK)
    if com.autoLocal:
      okB.set_label(_('_OK'))
      okB.set_image(gtk.image_new_from_stock(gtk.STOCK_OK,gtk.ICON_SIZE_BUTTON))
      canB.set_label(_('_Cancel'))
      canB.set_image(gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON))
    treev = gtk.TreeView()
    trees = gtk.ListStore(str)
    treev.set_model(trees)
    #treev.enable_model_drag_source(gdk.BUTTON1_MASK, [('', 0, 0)], gdk.ACTION_MOVE)#?????
    #treev.enable_model_drag_dest([('', 0, 0)], gdk.ACTION_MOVE)#?????
    treev.connect('drag_data_received', self.plugTreevDragReceived)
    treev.connect('row-activated', self.plugAddTreevRActivate)
    ####
    cell = gtk.CellRendererText()
    col = gtk.TreeViewColumn(_('Description'), cell, text=0)
    #col.set_resizable(True)# no need when have only one column!
    treev.append_column(col)
    ####
    swin = gtk.ScrolledWindow()
    swin.add(treev)
    swin.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
    d.vbox.pack_start(swin)
    d.vbox.show_all()
    self.plugAddDialog = d
    self.plugAddTreeview = treev
    self.plugAddTreestore = trees
    #############
    ##treev.set_resize_mode(gtk.RESIZE_IMMEDIATE)
    ##self.plugAddItems = []
    ###################################################################################################
    notebook = gtk.Notebook()
    self.notebook = notebook
    #####################################
    """### to test
    notebook.set_property('homogeneous', True)
    notebook.set_property('show-tabs', True)
    
    notebook.append_page(vbox1)
    notebook.set_tab_label_packing(vbox1, True, True, gtk.PACK_START)
    notebook.set_tab_label(vbox1, gtk.Label('General'))
    notebook.set_tab_reorderable(vbox1, True)
    
    notebook.append_page(vbox2)
    notebook.set_tab_label_packing(vbox2, True, True, gtk.PACK_START)
    notebook.set_tab_label(vbox2, gtk.Label('Appearance'))
    notebook.set_tab_reorderable(vbox2, True)
    """
    ######################
    l = gtk.Label(_('_General'))
    l.set_use_underline(True)
    #eb = gtk.EventBox()
    vb = gtk.VBox()
    vb.pack_start(image_from_file('%s/preferences-other.png'%com.pixDir))
    vb.pack_start(l)
    #eb.add(vb)
    #eb.set_above_child(True)
    #eb.set_visible_window(False)
    #vb.set_extension_events(gtk.gdk.EXTENSION_EVENTS_ALL)
    #vb.set_events(gtk.gdk.ALL_EVENTS_MASK)
    #vb.pack_start(eb, 0, 0)
    #vb.add_events(gtk.gdk.EXPOSURE_MASK | gtk.gdk.BUTTON_PRESS_MASK)
    vb.show_all()
    notebook.append_page(vbox1, vb)
    #notebook.set_tab_label_packing(vbox1, False, False, gtk.PACK_START)
    ###
    #notebook.connect('event', com.show_event)
    #vb.connect('expose-event', com.show_event)
    #vb.connect('expose-event', lambda obj, ev: vb.show_all())
    #vbox1.connect('event', com.show_event)
    ###
    l = gtk.Label(_('A_ppearance'))
    l.set_use_underline(True)
    vb = gtk.VBox()
    vb.pack_start(image_from_file('%s/preferences-desktop-theme.png'%com.pixDir))
    vb.pack_start(l)
    vb.show_all()
    #vb.set_events(gtk.gdk.ALL_EVENTS_MASK)
    #vb.set_extension_events(gtk.gdk.EXTENSION_EVENTS_ALL)
    notebook.append_page(vbox2, vb)
    #notebook.set_tab_label_packing(vbox2, False, False, gtk.PACK_START)
    vb.connect('drag-begin', com.show_event)
    ###
    l = gtk.Label(_('_Manage Plugin'))
    l.set_use_underline(True)
    vb = gtk.VBox()
    vb.pack_start(image_from_file('%s/preferences-plugin.png'%com.pixDir))
    vb.pack_start(l)
    vb.show_all()
    notebook.append_page(vbox3, vb)
    #notebook.set_tab_label_packing(vbox3, False, False, gtk.PACK_START)
    ###
    l = gtk.Label(_('A_dvanced'))
    l.set_use_underline(True)
    vb = gtk.VBox()
    vb.pack_start(image_from_file('%s/applications-system.png'%com.pixDir))
    vb.pack_start(l)
    vb.show_all()
    notebook.append_page(vbox4, vb)
    #notebook.set_tab_label_packing(vbox4, False, False, gtk.PACK_START)
    #"""
    ###
    try:
      notebook.set_tab_reorderable(vbox1, True)
      notebook.set_tab_reorderable(vbox2, True)
      notebook.set_tab_reorderable(vbox3, True)
      notebook.set_tab_reorderable(vbox4, True)
    except AttributeError:
      pass
    notebook.set_property('homogeneous', True)
    self.vbox_pref.pack_start(notebook)
    self.vbox_pref.show_all()
    self.prefPages = (vbox1, vbox2, vbox3, vbox4)
    for i in com.prefPagesOrder:
      j = com.prefPagesOrder[i]
      notebook.reorder_child(self.prefPages[i], j)
    ################################# End of making preferences (prefInit) #######################
    ##############################################################################################
    #self.dialog.connect('window-state-event', self.dialogStateEvent)
    ############### Building About Dialog
    about = gtk.AboutDialog()
    about.set_name('StarCalendar') ## or set_program_name
    about.set_version(VERSION)
    about.set_title(_('About ')+'StarCalendar') ## must call after set_name and set_version !
    about.set_authors([
      _('Saeed Rasooli <saeed.gnu@gmail.com>'),
      _('Mola Pahnadayan <mola.mp@gmail.com>'),
      _('Mehdi Bayazee <bayazee@gmail.com>'),
      'Martin Grimme <martin@pycage.de>',
      'شورای مرکز تقویم مؤسسهٔ ژئوفیزیک دانشگاه تهران و شورای فرهنگ عمومی',
      'رضا مرادی قیاس آبادی (www.ghiasabadi.com)'])
    about.set_comments(_("A Perfect Calendar Program Writen in Python\nCopyleft © 2008-2009 Saeed Rasooli\nStarCalendar is distributed under the GNU General Public License"))
    about.set_license(com.licenseText)
    about.set_wrap_license(True)
    about.connect('delete-event', self.aboutHide)
    about.connect('response', self.aboutHide)
    about.set_website(homePage) ## A palin label (not link)
    about.set_logo(gdk.pixbuf_new_from_file('%s%sstarcal.png'%(com.pixDir,os.sep)))
    #about.set_skip_taskbar_hint(True)
    if com.autoLocal:
      buttonbox = about.vbox.get_children()[1]
      #buttonbox.set_homogeneous(False)
      #buttonbox.set_layout(gtk.BUTTONBOX_SPREAD)
      buttons = buttonbox.get_children()## List of buttons of about dialogs
      buttons[1].set_label(_('C_redits'))
      buttons[2].set_label(_('_Close'))
      buttons[2].set_image(gtk.image_new_from_stock(gtk.STOCK_CLOSE,gtk.ICON_SIZE_BUTTON))
      buttons[0].set_label(_('_License'))
    self.about = about
    ########################## Building menu of right click on the tray icon
    ### When menu will show above the pointer
    menu = gtk.Menu()
    menu.add(self.labelStockMenuItem('Copy _Time',			gtk.STOCK_COPY,			self.copyTime))
    menu.add(self.labelStockMenuItem('Copy _Date',			gtk.STOCK_COPY,			self.copyDateToday))
    menu.add(self.labelStockMenuItem('Ad_just System Time',	gtk.STOCK_PREFERENCES,	self.adjustTime))
    menu.add(self.labelStockMenuItem('_Add Custom Day', 	gtk.STOCK_ADD,			self.showCustomDayTray))
    menu.add(self.labelStockMenuItem('_Export to HTML',		gtk.STOCK_CONVERT,		self.exportClickedTray))
    menu.add(self.labelStockMenuItem('_Preferences',	  	gtk.STOCK_PREFERENCES,	self.prefShow))
    menu.add(self.labelStockMenuItem('_About',				gtk.STOCK_ABOUT,		self.aboutShow))
    menu.add(gtk.SeparatorMenuItem())
    menu.add(self.labelStockMenuItem('_Quit',         		gtk.STOCK_QUIT,			self.quit))
    menu.show_all()
    self.menuTray = self.menuTray1 = menu
    ##########################################################
    ### When menu will show below the pointer
    menu = gtk.Menu()
    menu.add(self.labelStockMenuItem('_Quit',         		gtk.STOCK_QUIT,			self.quit))
    menu.add(gtk.SeparatorMenuItem())
    menu.add(self.labelStockMenuItem('_About',				gtk.STOCK_ABOUT,		self.aboutShow))
    menu.add(self.labelStockMenuItem('_Preferences',	  	gtk.STOCK_PREFERENCES,	self.prefShow))
    menu.add(self.labelStockMenuItem('_Export to HTML',		gtk.STOCK_CONVERT,		self.exportClickedTray))
    menu.add(self.labelStockMenuItem('_Add Custom Day', 	gtk.STOCK_ADD,			self.showCustomDayTray))
    menu.add(self.labelStockMenuItem('Ad_just System Time',	gtk.STOCK_PREFERENCES,	self.adjustTime))
    menu.add(self.labelStockMenuItem('Copy _Date',			gtk.STOCK_COPY,			self.copyDateToday))
    menu.add(self.labelStockMenuItem('Copy _Time',			gtk.STOCK_COPY,			self.copyTime))
    menu.show_all()
    self.menuTray2 = menu
    ########################################### Building main menu
    menu = gtk.Menu()
    ####
    check = gtk.CheckMenuItem(label=_('Show Tool_bar'))
    check.connect('activate', self.dialog.showToolbarActivate)
    self.dialog.checkTb = check
    menu.add(check)
    ####
    item = gtk.ImageMenuItem(_('Resize'))
    item.set_image(image_from_file('%s/resize.png'%com.pixDir))
    item.connect('button-press-event', self.dialog.startResize)
    menu.add(item)
    ####
    check = gtk.CheckMenuItem(label=_('_On Top'))
    check.connect('activate', self.keepAboveClicked)
    menu.add(check)
    self.checkAbove = check
    #self.get_keep_above = check.get_active
    #####
    check = gtk.CheckMenuItem(label=_('_Sticky'))
    check.connect('activate', self.stickyClicked)
    menu.add(check)
    self.checkSticky = check
    #####
    menu.add(self.labelStockMenuItem('Select _Today',		gtk.STOCK_HOME,		self.dialog.goToday))
    menu.add(self.labelStockMenuItem('Select _Date...',		gtk.STOCK_INDEX,	self.selectDate))
    menu.add(self.labelStockMenuItem('_Preferences',    	gtk.STOCK_PREFERENCES,	self.prefShow))
    menu.add(self.labelStockMenuItem('_Add Custom Day', 	gtk.STOCK_ADD,		self.showCustomDay))
    menu.add(self.labelStockMenuItem('_Export to HTML',		gtk.STOCK_CONVERT,	self.exportClicked))
    menu.add(self.labelStockMenuItem('_About',   		gtk.STOCK_ABOUT,	self.aboutShow))
    if self.trayMode!=1:
      menu.add(self.labelStockMenuItem('_Quit',   		gtk.STOCK_QUIT,		self.quit))
    menu.show_all()
    self.dialog.menuMain = menu
    ############################################################
    if not hasattr(self.dialog, 'is_composited'):
      self.dialog.is_composited = lambda: False
    #########
    self.trayInit()
    self.trayUpdate()
    if self.trayMode!=1:
      timeout_add(self.timeout, self.trayUpdate)
    #########
    self.dialog.connect('delete-event', self.dialogClose)
    self.showMain = com.showMain
    ######### Building menu of right click on a day
    menu = gtk.Menu()
    menu.add(self.labelStockMenuItem('_Add Custom Day', 	gtk.STOCK_ADD,		self.showCustomDay))
    menu.add(self.labelStockMenuItem('_Copy Date',		gtk.STOCK_COPY,		self.copyDate))
    menu.add(gtk.SeparatorMenuItem())
    menu.add(self.labelStockMenuItem('Select _Today',		gtk.STOCK_HOME,		self.dialog.goToday))
    menu.add(self.labelStockMenuItem('Select _Date...',		gtk.STOCK_INDEX,	self.selectDate))
    if os.path.isfile('/usr/bin/evolution'):##??????????????????
      menu.add(self.labelImageMenuItem('In E_volution',
        'evolution-18.png', self.dialog.dayOpenEvolution))
    if os.path.isfile('/usr/bin/sunbird'):##??????????????????
      menu.add(self.labelImageMenuItem('In _Sunbird',
        'sunbird-18.png', self.dialog.dayOpenSunbird))
    menu.num = 1
    self.dialog.menuCell1 = menu
    self.dialog.menuCell = menu ## may be changed later frequently, here just initialized
    menu.show_all()
    ########## Building menu of right click on a day (that has CustomDay)
    menu = gtk.Menu()
    menu.add(self.labelStockMenuItem('_Edit Custom Day', 	gtk.STOCK_EDIT,		self.editCustomDay))
    menu.add(self.labelStockMenuItem('_Copy Date',		gtk.STOCK_COPY,		self.copyDate))
    menu.add(gtk.SeparatorMenuItem())
    menu.add(self.labelStockMenuItem('_Remove Custom Day', 	gtk.STOCK_DELETE,	self.removeCustomDay))
    menu.add(gtk.SeparatorMenuItem())
    menu.add(self.labelStockMenuItem('Select _Today',		gtk.STOCK_HOME,		self.dialog.goToday))
    menu.add(self.labelStockMenuItem('Select _Date...',		gtk.STOCK_INDEX,	self.selectDate))
    if os.path.isfile('/usr/bin/evolution'):##??????????????????
      menu.add(self.labelImageMenuItem('In E_volution',
        'evolution-18.png', self.dialog.dayOpenEvolution))
    if os.path.isfile('/usr/bin/sunbird'):##??????????????????
      menu.add(self.labelImageMenuItem('In _Sunbird',
        'sunbird-18.png', self.dialog.dayOpenSunbird))
    menu.show_all()
    menu.num = 2
    self.dialog.menuCell2 = menu
    ######################
    self.prefUpdateGui()
    ######################
    self.clipboard = gtk.clipboard_get(gdk.SELECTION_CLIPBOARD)
    ############ Building selectDateDialog
    d = gtk.Dialog(title=_('Select Date...'))
    d.set_has_separator(False)
    #d.set_skip_taskbar_hint(True)
    d.connect('delete-event', self.selectDateHide)
    ###### Reciving dropped day!
    d.drag_dest_set(gdk.MODIFIER_MASK,\
      (('a', 0, 0),), gdk.ACTION_COPY)
    d.drag_dest_add_text_targets()
    d.connect('drag-data-received', self.selectDateDragRec)
    ######
    hb0 = gtk.HBox(spacing=4)
    hb0.pack_start(gtk.Label(_('Date Mode')), 0, 0)
    combo = gtk.combo_box_new_text()
    for m in cal.modules:
      combo.append_text(_(m.desc))
    #combo.append_text(_('Julian Day'))#??????
    #combo.set_active(com.primaryMode)
    combo.set_active(com.shownDates[0]['mode'])
    combo.connect('changed', self.selectDateComboModeChanged)
    hb0.pack_start(combo, 0, 0)
    d.vbox.pack_start(hb0, 0, 0)
    ########
    hb1 = gtk.HBox(spacing=4)
    hb1.pack_start(gtk.Label(_('Year')), 0, 0)
    spinY = gtk.SpinButton()
    spinY.set_increments(1, 10)
    spinY.set_range(0, 10000)
    spinY.set_width_chars(5)
    spinY.set_direction(gtk.TEXT_DIR_LTR)
    hb1.pack_start(spinY, 0, 0)
    hb1.pack_start(gtk.Label(_('Month')), 0, 0)
    combo2 = gtk.combo_box_new_text()
    module = cal.modules[com.primaryMode]
    for i in xrange(module.getMonthsInYear(None)):## ???????????????????????????????
      combo2.append_text(_(module.getMonthName(i+1, None)))## year=None means all months
    combo2.set_active(0)
    hb1.pack_start(combo2, 0, 0)
    self.selectDateMonCombo = combo2
    #if module.name=='hebrew':
    spinY.connect('changed', self.selectDateYearChanged)
    spinY.connect('activate', self.selectDateYearChanged)
    hb1.pack_start(gtk.Label(_('Day')), 0, 0)
    spinD = gtk.SpinButton()
    spinD.set_increments(1, 5)
    spinD.set_range(1, 31)
    spinD.set_width_chars(3)
    spinD.set_direction(gtk.TEXT_DIR_LTR)
    hb1.pack_start(spinD, 0, 0)
    rb1 = gtk.RadioButton()
    rb1.num = 1
    rb1.connect_after('clicked', self.selectDateRadioChanged)
    hb1i = gtk.HBox(spacing=5)
    hb1i.pack_start(rb1, 0, 0)
    hb1i.pack_start(hb1, 0, 0)
    d.vbox.pack_start(hb1i, 0, 0)
    ########
    hb2 = gtk.HBox(spacing=4)
    hb2.pack_start(gtk.Label('yyyy/mm/dd'), 0, 0)
    #dbox = DateButtonOption(lang=com.langList[com.lang][2], hist_size=16)
    dbox = DateBox(lang=com.langList[com.lang][2], hist_size=16)
    dbox.connect('activate', self.selectDateOK)
    hb2.pack_start(dbox, 0, 0)
    rb2 = gtk.RadioButton()
    rb2.num = 2
    rb2.set_group(rb1)
    rb2.connect_after('clicked', self.selectDateRadioChanged)
    hb2i = gtk.HBox(spacing=5)
    hb2i.pack_start(rb2, 0, 0)
    hb2i.pack_start(hb2, 0, 0)
    d.vbox.pack_start(hb2i, 0, 0)
    #######
    canB = d.add_button(gtk.STOCK_CANCEL, 2)
    okB = d.add_button(gtk.STOCK_OK, 1)
    if com.autoLocal:
      okB.set_label(_('_OK'))
      okB.set_image(gtk.image_new_from_stock(gtk.STOCK_OK,gtk.ICON_SIZE_BUTTON))
      canB.set_label(_('_Cancel'))
      canB.set_image(gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON))
    okB.connect('clicked', self.selectDateOK)
    canB.connect('clicked', self.selectDateHide)
    d.vbox.show_all()
    #######
    
    #######
    self.selectDateCombo = combo
    self.selectDateSpinY = spinY
    self.selectDateCombo2 = combo2
    self.selectDateSpinD = spinD
    self.selectDateDBox = dbox
    self.selectDateDialog = d
    self.selectDateRadio1 = rb1
    self.selectDateRadio2 = rb2
    self.selectDateHB1 = hb1
    self.selectDateHB2 = hb2
    self.selectDateRadioChanged()
    ################################ Building FileChooserDialog ################################
    fcd = gtk.Dialog(title=_('Export to HTML'), parent=None)
    fcd.set_has_separator(False)
    self.fcd = fcd
    ########
    hbox=gtk.HBox(spacing=2)
    hbox.pack_start(gtk.Label(_('Month Range')), 0, 0)
    combo = gtk.combo_box_new_text()
    for t in ('Current Month', 'Whole Current Year', 'Custom'):
      combo.append_text(_(t))
    hbox.pack_start(combo, 0, 0)
    hbox.pack_start(gtk.Label(''), 1, 1)
    fcd.combo = combo
    ###
    hbox2=gtk.HBox(spacing=2)
    hbox2.pack_start(gtk.Label(_('from month')), 0, 0)
    fcd.ymBox0 = YearMonthBox(lang=com.langList[com.lang][2])
    hbox2.pack_start(fcd.ymBox0, 0, 0)
    hbox2.pack_start(gtk.Label(''), 1, 1)
    hbox2.pack_start(gtk.Label(_('to month')), 0, 0)
    fcd.ymBox1 = YearMonthBox(lang=com.langList[com.lang][2])
    hbox2.pack_start(fcd.ymBox1, 0, 0)
    hbox.pack_start(hbox2, 1, 1)
    fcd.hbox2 = hbox2
    combo.set_active(0)
    fcd.vbox.pack_start(hbox, 0, 0)
    ########
    fcd.fcw = gtk.FileChooserWidget(action=gtk.FILE_CHOOSER_ACTION_SAVE)
    fcd.vbox.pack_start(fcd.fcw, 1, 1)
    fcd.vbox.show_all()
    combo.connect('changed', self.fcdComboChanged)
    canB = fcd.add_button(gtk.STOCK_CANCEL, 1)
    saveB = fcd.add_button(gtk.STOCK_SAVE, 2)
    if com.autoLocal:
      canB.set_label(_('_Cancel'))
      canB.set_image(gtk.image_new_from_stock(gtk.STOCK_CANCEL,gtk.ICON_SIZE_BUTTON))
      saveB.set_label(_('_Save'))
      saveB.set_image(gtk.image_new_from_stock(gtk.STOCK_SAVE,gtk.ICON_SIZE_BUTTON))
    fcd.connect('delete-event', self.fcdHide)
    canB.connect('clicked', self.fcdHide)
    saveB.connect('clicked', self.fcdSave)
    try:
      fcd.fcw.set_current_folder('%s/Desktop'%homeDir)
    except:##?????????????????????
      pass
    #########################################
    for plug in com.allPlugList:
      if plug.external and hasattr(plug, 'set_dialog'):
        plug.set_dialog(self.dialog)
    ###########################
    self.checkAbove.set_active(com.winKeepAbove)
    self.dialog.set_keep_above(com.winSticky)
    self.dialog.lowerWin.set_keep_above(com.winSticky) #??????????
    self.checkSticky.set_active(com.winSticky)
    if com.winSticky:
      self.dialog.stick()
    self.dialog.setShowToolbar(com.showToolbar)
    self.dialog.set_title('StarCalendar %s'%VERSION)
    #############################
    #com.rootWindow.set_cursor(gdk.Cursor(gdk.LEFT_PTR))
    #self.prefUpdateGui()
    #fcd.set_skip_taskbar_hint(True)
  #def dialogStateEvent(self, obj, event):
    #print dir(event)
    #print event.new_window_state
    #self.event = event
  #def plugTreevExpose(self, widget, event):
    #self.plugDescCell.set_property('wrap-width', self.plugDescCol.get_width()+2)
  checkYmArrowsClicked = lambda self, check: self.ymArrowHbox.set_sensitive(check.get_active())
  #checkbExtradayEnableClicked = lambda self, check: self.hboxPlug.set_sensitive(check.get_active())
  cursorFixedClicked = lambda self, check: self.cursorFixedHbox.set_sensitive(check.get_active())
  def selectDateYearChanged(self, spin):
    module = cal.modules[self.selectDateMode]
    if module.name!='hebrew':
      return
    y = int(spin.get_value())
    model = self.selectDateMonCombo.get_model()
    n = len(model)
    adar2 = _(module.monthNameLeap[6])
    if module.isLeap(y):
      print '%d in leap.'%y,
      if n==12:
        model.insert(6, (adar2,))
        print 'Adding %s'%adar2
      else:
        print
    else:
      print '%d in not leap.'%y,
      if n==13:
        model.remove(model.get_iter(6))
        print 'Removing %s'%adar2
      else:
        print
  def comboFirstWDChanged(self, combo):
    f = self.comboFirstWD.get_active() ## 0 means Sunday
    if f==7: ## auto
      f = com.getLocaleFirstWeekDay()
    ## com.firstWeekDay will be later = f
    hb = self.holidayHbox
    cbList = self.holidayWeekDaysCb
    for j in range(7):## or range(6)
      hb.reorder_child(cbList[(f+j)%7], j)
  def keepAboveClicked(self, check):
    act = check.get_active()
    self.dialog.set_keep_above(act)
    self.dialog.lowerWin.set_keep_above(act)
    com.winKeepAbove = act
    com.saveLiveConf()
  def stickyClicked(self, check):
    if check.get_active():
      self.dialog.stick()
      self.dialog.lowerWin.stick()
      com.winSticky = True
    else:
      self.dialog.unstick()
      self.dialog.lowerWin.unstick()
      com.winSticky = False
    com.saveLiveConf()
  def updateMenuSize(self):
    ## To calc/update menus size(width is used)
    get_menu_pos = lambda widget: (com.screenW, 0, True)
    self.dialog.menuMain.popup(None, None, get_menu_pos, 3, 0)
    self.dialog.menuMain.hide()
    self.dialog.menuCell1.popup(None, None, get_menu_pos, 3, 0)
    self.dialog.menuCell1.hide()
    self.dialog.menuCell2.popup(None, None, get_menu_pos, 3, 0)
    self.dialog.menuCell2.hide()
    self.menuTray1.popup(None, None, get_menu_pos, 3, 0)
    self.menuTray1.hide()
    self.menuTray2.allocation = self.menuTray1.allocation
  def selectDateDragRec(self, obj, context, x, y, selection, target_id, etime):
    text = selection.get_text()
    if text==None:
      return
    date = com.parseDroppedDate(text)
    if date==None:
      print 'selectDateDialog: dropped text "%s"'%text
      return
    print 'selectDateDialog: dropped date: %d/%d/%d'%date
    mode = self.selectDateCombo.get_active()
    if mode!=com.dragGetMode:
      date=cal.convert(date[0], date[1], date[2], com.dragGetMode, mode)
    (y, m, d) = date
    self.selectDateSpinY.set_value(y)
    self.selectDateCombo2.set_active(m-1)
    self.selectDateSpinD.set_value(d)
    self.selectDateDBox.set_date((y, m, d))
    self.selectDateDBox.add_history()
    return True
  def selectDate(self, *args):
    ## Show a window that ask the date and set on the calendar
    mode = com.shownDates[0]['mode']
    (y, m, d) = self.dialog.cell.dates[mode]
    self.selectDateDates = [None for i in range(cal.modNum)]
    self.selectDateMode = mode
    self.selectDateSet(y, m, d, mode)
    self.selectDateDates[mode] = [y, m, d]
    self.selectDateDialog.present()
  def selectDateHide(self, widget, event=None):
    self.selectDateDialog.hide()
    return True
  def selectDateSet(self, y, m, d, mode=None):
    if mode==None:
      mode=com.primaryMode
    self.selectDateCombo.set_active(mode)
    self.selectDateSpinY.set_value(y)
    self.selectDateCombo2.set_active(m-1)
    self.selectDateSpinD.set_value(d)
    #self.selectDateDBox.child.set_text(dateStr(y, m, d))
    self.selectDateDBox.set_date((y, m, d))
    self.selectDateDBox.add_history()
  def selectDateComboModeChanged(self, widget):
    pMode = self.selectDateMode
    pDate = self.selectDateGet()
    if pDate!=None:
      self.selectDateDates[pMode] = pDate
    mode = self.selectDateCombo.get_active()
    module = cal.modules[mode]
    date = self.selectDateDates[mode]
    if date==None:
      if pDate==None:
        for i in xrange(cal.modNum):
          date = self.selectDateDates[i]
          if date!=None:
            (y0, m0, d0) = date
            (y, m, d) = convert(y0, m0, d0, i, mode)
      else:
        (y0, m0, d0) = pDate
        (y, m, d) = convert(y0, m0, d0, pMode, mode)
    else:
      (y, m, d) = date
    self.selectDateDates[mode] = [y, m, d]
    self.selectDateSpinD.set_range(1, cal.modules[mode].maxMonthLen)
    combo = self.selectDateCombo2
    for i in xrange(len(combo.get_model())):
      combo.remove_text(0)
    for i in xrange(module.getMonthsInYear(y)):
      combo.append_text(_(module.getMonthName(i+1, y)))
    self.selectDateSet(y, m, d, mode)
    self.selectDateMode = mode
  def selectDateGet(self):
    mode = self.selectDateCombo.get_active()
    if self.selectDateRadio1.get_active():
      y0 = int(self.selectDateSpinY.get_value())
      m0 = self.selectDateCombo2.get_active() + 1
      d0 = int(self.selectDateSpinD.get_value())
    elif self.selectDateRadio2.get_active():
      (y0, m0, d0) = self.selectDateDBox.get_date()
    return [y0, m0, d0]
  def selectDateOK(self, widget):
    mode = self.selectDateCombo.get_active()
    if mode==None:
      return
    get = self.selectDateGet()
    if get==None:
      return
    (y0, m0, d0) = get
    if mode==com.primaryMode:
      (y, m, d) = (y0, m0, d0)
    else:
      (y, m, d) = convert(y0, m0, d0, mode, com.primaryMode)
    if not com.validDate(y, m, d):
      print 'bad date: '+dateStr(y, m, d)
      return
    self.dialog.dateChange((y, m, d))
    self.selectDateDialog.hide()
    self.selectDateDBox.add_history((y0, m0, d0))
    #self.selectDateDBox.add_history((y, m, d))
  def selectDateRadioChanged(self, widget=None):
    if self.selectDateRadio1.get_active():
      self.selectDateHB1.set_sensitive(True)
      self.selectDateHB2.set_sensitive(False)
    else:
      self.selectDateHB1.set_sensitive(False)
      self.selectDateHB2.set_sensitive(True)
  def plugTreevCursorChanged(self, treev):
    cur = treev.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    j = self.plugTreestore[i][0]
    plug = com.allPlugList[j]
    self.plugButtonAbout.set_sensitive(plug.about!=None)
    self.plugButtonConf.set_sensitive(plug.has_config)
  def plugAboutClicked(self, button):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    j = self.plugTreestore[i][0]
    plug = com.allPlugList[j]
    if plug.about==None:
      return
    about = gtk.AboutDialog()
    about.set_transient_for(self.dialog_pref)
    about.set_name('')
    #about.set_name(plug.desc) ## or set_program_name
    #about.set_title(_('About ')+plug.desc) ## must call after set_name and set_version !
    about.set_title(_('About Plugin'))
    about.set_authors(plug.authors)
    about.set_comments(plug.about)
    #about.set_license(com.licenseText)
    #about.set_wrap_license(True)
    about.connect('delete-event', lambda w, e: w.destroy())
    about.connect('response', lambda w, e: w.destroy())
    #about.set_resizable(True)
    #about.vbox.show_all()## OR about.vbox.show_all() ; about.run()
    about.present()
  def plugConfClicked(self, button):
    pass
  def plugTreevRActivate(self, treev, path, col):
    if col.get_title()==_('Description'):##??????????
      self.plugAboutClicked(None) #??????
    #print 'row-activate', path
  def plugAddClicked(self, button):
    ## ???????????????????????????
    ## Reize window to show all texts
    #self.plugAddTreeview.columns_autosize()#??????????
    (r, x, y, w, h) = self.plugAddTreeview.get_column(0).cell_get_size()
    #print r[2], r[3], x, y, w, h
    self.plugAddDialog.resize(w+30, 75 + 30*len(self.plugAddTreestore))
    ###############
    self.plugAddDialog.run()
    #self.plugAddDialog.present()
    #self.plugAddDialog.show()
  def plugAddDialogClose(self, obj, event=None):
    self.plugAddDialog.hide()
    return True
  """def plugTreeviewButtonPress(self, treev, event=None):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]"""
  def plugTreeviewCellToggled(self, cell, path):
    i = int(path)
    #cur = self.plugTreeview.get_cursor()[0]
    #if cur==None or i!=cur[0]:#?????????
    #  return
    self.plugTreestore[i][1] = not self.plugTreestore[i][1]
    cell.set_active(not cell.get_active())
  def plugTreeviewCellToggled2(self, cell, path):
    i = int(path)
    #cur = self.plugTreeview.get_cursor()[0]
    #if cur==None or i!=cur[0]:#?????????
    #  return
    self.plugTreestore[i][2] = not self.plugTreestore[i][2]
    cell.set_active(not cell.get_active())
  def plugTreeviewTop(self, but):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    t = self.plugTreestore
    if i<=0 or i>=len(t):
      gdk.beep()
      return
    t.prepend(t[i])
    t.remove(t.get_iter(i+1))
    self.plugTreeview.set_cursor(0)
  def plugTreeviewBottom(self, but):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    t = self.plugTreestore
    if i<0 or i>=len(t)-1:
      gdk.beep()
      return
    t.append(t[i])
    t.remove(t.get_iter(i))
    self.plugTreeview.set_cursor(len(t)-1)
  def plugTreeviewUp(self, but):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    t = self.plugTreestore
    if i<=0 or i>=len(t):
      gdk.beep()
      return
    t.swap(t.get_iter(i-1), t.get_iter(i))
    self.plugTreeview.set_cursor(i-1)
  def plugTreeviewDown(self, but):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    t = self.plugTreestore
    if i<0 or i>=len(t)-1:
      gdk.beep()
      return
    t.swap(t.get_iter(i), t.get_iter(i+1))
    self.plugTreeview.set_cursor(i+1)
  def plugTreevDragReceived(self, treev, context, x, y, selec, info, etime):
    t = treev.get_model() #self.plugAddTreestore
    cur = treev.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    dest = treev.get_dest_row_at_pos(x, y)
    if dest == None:
      t.move_after(t.get_iter(i), t.get_iter(len(t)-1))
    elif dest[1] in (gtk.TREE_VIEW_DROP_BEFORE, gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
      t.move_before(t.get_iter(i), t.get_iter(dest[0][0]))
    else:
      t.move_after(t.get_iter(i), t.get_iter(dest[0][0]))
  def plugTreeviewDel(self, but):
    cur = self.plugTreeview.get_cursor()[0]
    if cur==None:
      return
    i = cur[0]
    t = self.plugTreestore
    n = len(t)
    if i<0 or i>=n:
      gdk.beep()
      return
    j = t[i][0]
    t.remove(t.get_iter(i))
    ### j
    self.plugAddItems.append(j)
    desc = com.allPlugList[j].desc
    self.plugAddTreestore.append([desc])
    print 'deleting', desc
    self.plugButtonAdd.set_sensitive(True)
    if n>1:
      self.plugTreeview.set_cursor(min(n-2, i))
  def plugAddDialogOK(self, obj):
    cur = self.plugAddTreeview.get_cursor()[0]
    if cur==None:
      gdk.beep()
      return
    i = cur[0]
    j = self.plugAddItems[i]
    cur2 = self.plugTreeview.get_cursor()[0]
    if cur2==None:
      pos = len(self.plugTreestore)
    else:
      pos = cur2[0]+1
    self.plugTreestore.insert(pos, [j, True, False, com.allPlugList[j].desc])
    self.plugAddTreestore.remove(self.plugAddTreestore.get_iter(i))
    self.plugAddItems.pop(i)
    self.plugAddDialog.hide()
    self.plugTreeview.set_cursor(pos)### pos==1- #????????
  def plugAddTreevRActivate(self, treev, path, col):
    self.plugAddDialogOK(None)#???????
  def labelStockMenuItem(self, label, stock=None, func=None, *args):
    item = gtk.ImageMenuItem(_(label))
    if stock!=None:
      item.set_image(gtk.image_new_from_stock(stock, gtk.ICON_SIZE_MENU))
    if func!=None:
      item.connect('activate', func, *args)
    return item
  def labelImageMenuItem(self, label, image, func=None, *args):
    item = gtk.ImageMenuItem(_(label))
    item.set_image(image_from_file('%s%s%s'%(com.pixDir, os.sep, image)))
    if func!=None:
      item.connect('activate', func, *args)
    return item
  def stockMenuItem(self, stock, func, *args):
    item = gtk.MenuItem()
    item.add(gtk.image_new_from_stock(stock, gtk.ICON_SIZE_MENU))
    item.connect('activate', func, *args)
    return item
  def newArrowMenuItem(self, arrowType, func=None, *args):
    item = gtk.MenuItem()
    #ev = gtk.EventBox()
    #ev.connect('activate', func, *args)
    item.add(gtk.Arrow(arrowType, gtk.SHADOW_IN))
    if func!=None:
      item.connect('activate', func, *args)
    return item
  def copyDate(self, obj=None, event=None):
    self.clipboard.set_text(com.dateStr(self.dialog.year, self.dialog.month, self.dialog.day))
    #self.clipboard.store() ## ?????? No need!
  def copyDateToday(self, obj=None, event=None):
    self.clipboard.set_text(com.dateStr(*self.todayCell.dates[com.primaryMode]))
    #self.clipboard.store() ## ?????? No need!
  def copyTime(self, obj=None, event=None):
    self.clipboard.set_text(com.strftime(com.clockFormat))
    #self.clipboard.store() ## ?????? No need!
  def imageClicked(self, widget, event, num):
    self.menu_im.popup(None, None, None, event.button, event.time)
    self.im_num = num
  def imageSet(self, widget, stock):
    if type(stock)==str:
      if self.im_num==1:
        self.ev1.remove(self.im1)
        self.im1.destroy()
        self.im1 = gtk.image_new_from_stock(stock, gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.im1.type = stock
        self.ev1.add(self.im1)
        self.im1.show()
      elif self.im_num==2:
        self.ev2.remove(self.im2)
        self.im2.destroy()
        self.im2 = gtk.image_new_from_stock(stock, gtk.ICON_SIZE_SMALL_TOOLBAR)
        self.im2.type = stock
        self.ev2.add(self.im2)
        self.im2.show()
    elif type(stock)==gtk._gtk.ArrowType:
      if self.im_num==1:
        self.ev1.remove(self.im1)
        self.im1.destroy()
        self.im1 = gtk.Arrow(stock, gtk.SHADOW_IN)
        self.im1.type = stock
        self.ev1.add(self.im1)
        self.im1.show()
      elif self.im_num==2:
        self.ev2.remove(self.im2)
        self.im2.destroy()
        self.im2 = gtk.Arrow(stock, gtk.SHADOW_IN)
        self.im2.type = stock
        self.ev2.add(self.im2)
        self.im2.show()
    else:
      raise ValueError('bad stock or arrow type %s'%stock)
  def prefUpdateGui(self):
    self.updateMenuSize()
    self.combo_lang.set_active(com.lang)
    for i in xrange(com.shownDatesNum):
      date = com.shownDates[i]
      self.checkb[i].set_active(date['enable'])
      m = date['mode']
      #if m==com.DATE_JD:
      #  self.combo[i].set_active(3)
      #else:
      self.combo[i].set_active(m)
      self.spinX[i].set_value(date['x'])
      self.spinY[i].set_value(date['y'])
      self.fontb[i].set_font_name(date['font'])
      self.colorb[i].set_color(date['color'])
    self.cbGrid.set_active(com.calGrid)
    self.colorbGrid.set_sensitive(com.calGrid)
    self.checkbFont.set_active(com.fontUseDefault)
    self.fontbApp.set_font_name(com.fontCustom)
    self.colorbGrid.set_color(com.gridColor)
    self.colorbGrid.set_alpha(com.gridAlpha)
    if com.firstWeekDayAuto:
      self.comboFirstWD.set_active(7)
    else:
      self.comboFirstWD.set_active(com.firstWeekDay)
    if com.weekNumberModeAuto:
      self.comboWeekYear.set_active(8)
    else:
      self.comboWeekYear.set_active(com.weekNumberMode)
    for i in range(7):
      self.holidayWeekDaysCb[i].set_active(i in com.holidayWeekDays)
    for opt in self.options:
      opt.update_widget()
    self.checkbExtradayEnable.set_active(com.extradayEnable)
    self.checkbExtradayTray.set_active(com.extradayTray)
    self.cbCustTxt.set_active(com.customdayShowText)
    self.cbCustIcon.set_active(com.customdayShowIcon)
    #self.checkShowToolbar.set_active(com.showToolbar)
    self.checkTaskbar.set_active(com.winTaskbar)
    self.dialog.set_skip_taskbar_hint(not com.winTaskbar)##???????????
    self.checkWinCont.set_active(com.showWinController)
    self.checkClockTb.set_active(com.showDigClockTb)
    self.checkClockTr.set_active(com.showDigClockTr)
    #######
    self.checkYmArrows.set_active(com.showYmArrows)
    self.ymArrowHbox.set_sensitive(com.showYmArrows)
    self.im_num = 1
    self.imageSet(None, com.prevStock)
    self.im_num = 2
    self.imageSet(None, com.nextStock)
    #######
    self.dateFormatEntry.set_text(com.dateFormat)
    self.clockFormatEntry.set_text(com.clockFormat)
    self.cbShowMain.set_active(com.showMain)
    self.cbStartCommon.set_active(os.path.isfile(com.comDesk))
    self.checkDeskBg.set_active(com.bgUseDesk)
    self.colorbBg.set_color(com.bgColor)
    self.colorbBg.set_alpha(com.bgColorAlpha)
    self.colorbBorder.set_color(com.borderColor)
    self.colorbBorder.set_alpha(com.borderColorAlpha)
    self.colorbBorderText.set_color(com.borderTextColor)
    self.colorbHoliday.set_color(com.holidayColor)
    self.colorbInactive.set_color(com.inactiveColor)
    self.colorbInactive.set_alpha(com.inactiveColorAlpha)
    self.colorbCursor.set_color(com.cursorOutColor)
    self.colorbCursorBg.set_color(com.cursorBgColor)
    self.colorbCursorBg.set_alpha(com.cursorBgAlpha)
    self.spinLeftMar.set_value(com.calLeftMargin)
    self.spinTopMar.set_value(com.calTopMargin)
    self.spinCurD.set_value(com.cursorD)
    self.spinCurR.set_value(com.cursorR)
    self.cursorFixedCheck.set_active(com.cursorFixed)
    self.spinCurW.set_value(com.cursorW)
    self.spinCurH.set_value(com.cursorH)
    self.dragRadio1.set_active(com.dragIconCell)
    self.spinCache.set_value(com.maxCache)
    ###### DB Manager (Plugin Manager)
    t = self.plugTreestore
    t.clear()
    for i in com.plugIndex:#????????
      plug = com.allPlugList[i]
      t.append([i, plug.enable, plug.show_date, plug.desc])
    n1 = len(com.plugIndex)
    n2 = len(com.allPlugList)
    #assert n1 <= n2
    if n1>n2:
      com.plugIndex = com.plugIndex[:n2]
    self.plugAddItems = []
    self.plugAddTreestore.clear()
    if n1 < n2:
      for i in xrange(n2):
        """found = False
        for j in com.plugIndex:
          if j==i:
            found = True
            break
        if not found:"""
        try:
          com.plugIndex.index(i)
        except ValueError:
          self.plugAddItems.append(i)
          self.plugAddTreestore.append([com.allPlugList[i].desc])
          self.plugButtonAdd.set_sensitive(True)
    #self.hboxPlug.set_sensitive(com.extradayEnable)#?????
  def prefCancel(self, widget=None):
    self.dialog_pref.hide()
    self.prefUpdateGui()
    return True
  prefShow = lambda self, obj=None, data=None: self.dialog_pref.present()
  def prefHide(self, obj=None, data=None):
    self.dialog_pref.hide()
    return True
  def prefApply(self, widget=None):
    self.updateMenuSize()
    self.prefSave()
    self.dialog.loadExtraDaysDB()#### for memory emhancement
    #self.dialog.updateHeight()
    self.dialog.updateTextWidth()
    #self.dialog.months = {}
    #self.dialog.computeCurrentMonth(True)
    #self.dialog.updateMonth()
    if com.fontUseDefault:
      com.settings.set_property('gtk-font-name', com.fontDefault)
    else:
      com.settings.set_property('gtk-font-name', com.fontCustom)
    self.trayUpdate(check=False)
    #self.dialog.setShowToolbar(com.showToolbar)
    #if self.checkDeskBg.get_active() and self.colorbBg.get_alpha()==65535:
    if com.bgUseDesk and com.bgColorAlpha==65535:
      msg = gtk.MessageDialog(buttons=gtk.BUTTONS_OK_CANCEL, message_format=_(
      'If you want to have a transparent calendar (and see your desktop), change the opacity of calendar background color!'))
      if msg.run()==gtk.RESPONSE_OK:
        self.colorbBg.emit('clicked')
      msg.destroy()
    self.dialog.arrowsUpdate()
    if com.checkNeedRestart():
      #if self.trayMode==1:
      #  pass ##?????????????????????????????????????????????????
      #else:
        d = gtk.Dialog(_('Need Restart StarCalendar'), self.dialog_pref,
          gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT | gtk.DIALOG_NO_SEPARATOR,
          (gtk.STOCK_CANCEL, 0))
        d.set_keep_above(True)
        label = gtk.Label(_('Some preferences need for restart StarCalendar to apply.'))
        label.set_line_wrap(True)
        d.vbox.pack_start(label)
        resBut = d.add_button(_('_Restart'), 1)
        resBut.set_image(gtk.image_new_from_stock(gtk.STOCK_REFRESH,gtk.ICON_SIZE_BUTTON))
        resBut.grab_default()
        d.vbox.show_all()
        if d.run()==1:
          self.restart()
        else:
          d.destroy()
  def restart(self):
    os.popen2('sleep 0.5; export LANG=""; %s'%sys.argv[0]) ## sleep time ????????
    self.quit()
  def prefOk(self, widget):
    self.prefHide()
    self.prefApply()
  def prefSave(self):
    ##################################### Updating pref variables
    com.lang = self.combo_lang.get_active()
    ###### DB Manager (Plugin Manager)
    index = []
    for row in self.plugTreestore:
      index.append(row[0])
      plug = com.allPlugList[row[0]]
      try:
        plug.enable = row[1]
        plug.show_date = row[2]
      except:
        com.myRaise(__file__)
        print i, com.plugIndex
    com.plugIndex = index
    #########################
    for i in xrange(len(com.shownDates)):
        enable = self.checkb[i].get_active()
        mode = self.combo[i].get_active()
        try:
          date=com.shownDates[i]
        except IndexError:
          if enable and mode!=None:
            date={}
            com.shownDates.append(date)
        date['enable']=enable
        #if mode==3:#?????????
        #  mode = com.DATE_JD
        date['mode']=mode
        date['x']=int(self.spinX[i].get_value())
        date['y']=int(self.spinY[i].get_value())
        date['font']=self.fontb[i].get_font_name()
        date['color']=self.colorb[i].get_color()
    if len(com.shownDates)>3:
      com.shownDates = com.shownDates[:3]
    com.calGrid = self.cbGrid.get_active()
    com.fontUseDefault = self.checkbFont.get_active()
    com.fontCustom = self.fontbApp.get_font_name()
    com.gridColor = self.colorbGrid.get_color()
    com.gridAlpha = self.colorbGrid.get_alpha()
    ####
    first = self.comboFirstWD.get_active()
    if first==7:
      com.firstWeekDayAuto = True
      com.firstWeekDay = com.getLocaleFirstWeekDay()
    else:
      com.firstWeekDayAuto = False
      com.firstWeekDay = first
    ###
    mode = self.comboWeekYear.get_active()
    if mode==8:
      com.weekNumberModeAuto = True
      com.weekNumberMode = com.getLocaleweekNumberMode()
    else:
      com.weekNumberModeAuto = False
      com.weekNumberMode = mode
    ###
    com.holidayWeekDays = []
    for i in range(7):
      if self.holidayWeekDaysCb[i].get_active():
        com.holidayWeekDays.append(i)
    for opt in self.options:
      opt.update_var()
    com.extradayEnable = self.checkbExtradayEnable.get_active()
    com.extradayTray = self.checkbExtradayTray.get_active()
    com.customdayShowText = self.cbCustTxt.get_active()
    com.customdayShowIcon = self.cbCustIcon.get_active()
    #com.showToolbar = self.checkShowToolbar.get_active()
    com.winTaskbar = self.checkTaskbar.get_active()
    com.showWinController = self.checkWinCont.get_active()
    if com.showWinController and self.dialog.win_con==None:
      self.dialog.buildWinCont()
    elif not com.showWinController and self.dialog.win_con!=None:
      self.dialog.destroyWinCont()
    com.clockFormat = self.clockFormatEntry.get_text()
    #clockTb0 = com.showDigClockTb
    com.showDigClockTb = self.checkClockTb.get_active()
    if com.showDigClockTb:
      if self.dialog.clock==None:
        self.dialog.clock = com.FClockLabel(com.clockFormat)
        self.dialog.toolbBox.pack_start(self.dialog.clock, 0, 0)
        self.dialog.clock.show()
      else:
        self.dialog.clock.format = com.clockFormat
    else:
      if self.dialog.clock!=None:
        self.dialog.clock.destroy()
        self.dialog.clock = None
    com.showDigClockTr = self.checkClockTr.get_active()
    self.updateTrayClock()
    com.dateFormat = self.dateFormatEntry.get_text() ## or self.dateFormatEntry.get_active_text()
    if self.trayMode!=1:
      com.showMain = self.cbShowMain.get_active()
    com.bgUseDesk = self.checkDeskBg.get_active()
    com.bgColor = self.colorbBg.get_color()
    com.bgColorAlpha = self.colorbBg.get_alpha()
    com.borderColor = self.colorbBorder.get_color()
    com.borderColorAlpha = self.colorbBorder.get_alpha()
    com.borderTextColor = self.colorbBorderText.get_color()
    com.holidayColor = self.colorbHoliday.get_color()
    com.inactiveColor = self.colorbInactive.get_color()
    com.inactiveColorAlpha = self.colorbInactive.get_alpha()
    com.cursorOutColor = self.colorbCursor.get_color()
    com.cursorBgColor = self.colorbCursorBg.get_color()
    com.cursorBgAlpha = self.colorbCursorBg.get_alpha()
    #####
    com.showYmArrows = self.checkYmArrows.get_active()
    com.prevStock = self.im1.type
    com.nextStock = self.im2.type
    #####
    com.calLeftMargin = int(self.spinLeftMar.get_value())
    com.calTopMargin = int(self.spinTopMar.get_value())
    com.cursorD = self.spinCurD.get_value()
    com.cursorR = int(self.spinCurR.get_value())
    com.cursorFixed = self.cursorFixedCheck.get_active()
    com.cursorW = int(self.spinCurW.get_value())
    com.cursorH = int(self.spinCurH.get_value())
    com.dragIconCell = self.dragRadio1.get_active()
    com.maxCache = int(self.spinCache.get_value())
    ##################
    com.primaryMode = com.shownDates[0]['mode']
    self.dialog.months = {}
    self.dialog.monthLabelUpdateMode()
    self.dialog.dateChange(self.dialog.cell.dates[com.primaryMode])
    ################################################################# Saving Pref
    for mod in cal.modules:
      mod.save()
    ############################
    text="#!/usr/bin/python\n## StarCalendar Configuration File\nversion='%s'\nlang=%s\n"%(VERSION,com.lang)
    ###
    text+='firstWeekDayAuto=%s\n'%com.firstWeekDayAuto
    if not com.firstWeekDayAuto:
      text+='firstWeekDay=%s\n'%com.firstWeekDay
    ###
    text+='weekNumberModeAuto=%s\n'%com.weekNumberModeAuto
    if not com.weekNumberModeAuto:
      text+='weekNumberMode=%s\n'%com.weekNumberMode
    ###
    text+='shownDates=%s\n'%com.shownDatesStr()
    for key in ('holidayWeekDays',\
    'extradayEnable','extradayTray','customdayShowText','customdayShowIcon','winHeight',\
    'showToolbar','winTaskbar','showWinController','showDigClockTb','showDigClockTr','maxCache',\
    'fontCustom','fontUseDefault','calGrid','gridAlpha','gridColor','showYmArrows',\
    'prevStock','nextStock','dateFormat','clockFormat','showMain','bgUseDesk','bgColor',\
    'bgColorAlpha','borderColor',\
    'borderColorAlpha','borderTextColor','holidayColor','inactiveColor','inactiveColorAlpha',\
    'cursorOutColor','cursorBgColor','cursorBgAlpha','calLeftMargin','calTopMargin','cursorD',\
    'cursorR','cursorFixed','cursorW','cursorH','dragIconCell','calHeightReq','lowerDocked'):
        value = eval('com.%s'%key)
        t = type(value)
        if t in (bool, int, float, list, tuple, str, unicode):## list, tuple ???????
          text += '%s=%s\n'%(key, repr(value))
        elif t==gdk.Color:
          text += '%s=%s\n'%(key, com.gdkColorToStr(value))
        elif t==gtk._gtk.ArrowType:
          text += '%s=gtk.%s\n'%(key, value.value_name[4:])
        else:
          print 'bad type for saving: %s'%t
    text+='lowerExpanded=%s\n'%self.dialog.lowerExp.get_expanded()
    (winX, winY) = self.dialog.get_position()
    text+='\nwinWidth=%s\nwinX=%s\nwinY=%s\n'%(com.winWidth, winX, winY)
    text+='\nallPlugList=%s\n'%com.getAllPlugListString()
    text+='\nplugIndex=%s\n'%com.plugIndex
    text+='winKeepAbove=%s\n'%self.checkAbove.get_active()
    text+='winSticky=%s\n'%self.checkSticky.get_active()
    text+='prefPagesOrder=%s'%[self.notebook.page_num(page) for page in self.prefPages]
    try:
      fp = file(com.prefPath, 'w')
    except:
      com.myRaise(__file__)
    fp.write(text)
    fp.close()
    if self.trayMode!=1:
      if self.cbStartCommon.get_active():
        if not self.addStartup(com.comDesk):
          self.cbStartCommon.set_active(False)
      else:
        try:
          os.remove(com.comDesk)
        except:
          pass
    print 'Preferences saved'
  def updateTrayClock(self):
    #print 'updateTrayClock, com.showDigClockTr=%s'%com.showDigClockTr
    if self.trayMode!=3:
      return
    if com.showDigClockTr:
      if self.clockTr==None:
        print 'generating tray clock'
        #if self.dialog.is_composited():
        #  self.clockTr = com.FClockImage(com.clockFormat)
        #else:
        self.clockTr = com.FClockLabel(com.clockFormat)
        self.trayHbox.pack_start(self.clockTr, 0, 0)
        self.clockTr.show()
      else:
        self.clockTr.format = com.clockFormat
    else:
      if self.clockTr!=None:
        print 'destroying tray clock'
        self.clockTr.destroy()
        self.clockTr = None
  aboutShow = lambda self, obj=None, data=None: self.about.present()## or run() #?????????
  def aboutHide(self, widget, arg=None):## arg maybe an event, or response id
    self.about.hide()
    return True
  def showCustomDay(self, obj=None, data=None, month=None, day=None):
    if month==None:
      month = self.dialog.month
    if day==None:
      day = self.dialog.day
    self.customDay.set_month_day(month, day)
    self.customDay.entryComment.set_text('')
    self.customDay.entryComment.grab_focus()
    self.customDay.present()
  def showCustomDayTray(self, item, event=None):
    (year, month, day) = getSysDate()
    self.customDay.set_month_day(month, day)
    #self.customDay.entryComment.set_text('')
    #self.customDay.entryComment.grab_focus()
    self.customDay.present()
  def hideCustomDay(self,  *args):
    d = self.dialog
    self.customDay.hide()
    d.loadCustomDB()
    self.dialog.months={}## self.dialog.computeCurrentMonth(True) is not enough
    d.dateChange((d.year, d.month, d.day))
    return True                
  def removeCustomDay(self, widget):
    d = self.dialog
    self.customDay.element_delete_date(d.month, d.day)
    d.loadCustomDB()
    self.dialog.computeCurrentMonth(True)## seem not need to self.dialog.computeCurrentMonth(True)
    d.dateChange((d.year, d.month, d.day))
  def editCustomDay(self, widget):
    self.customDay.element_search_select(self.dialog.month, self.dialog.day)
    self.customDay.entryComment.grab_focus()
    self.customDay.entryComment.select_region(0, 0)
    self.customDay.present()
  def trayInit(self):
    if self.trayMode<2:## ????????????
      return
    elif self.trayMode==2:
      self.sicon = gtk.StatusIcon()
      ##self.sicon.set_blinking(True) ## for Alarms
      self.sicon.set_visible(True)## is needed ????????
      self.sicon.connect('activate', self.trayClicked)
      self.sicon.connect('popup-menu', self.trayPopup)
    elif self.trayMode==3:
      try:
        from egg import trayicon
      except:
        self.sicon = gtk.StatusIcon()
        ##self.sicon.set_blinking(True) ## for Alarms
        self.sicon.set_visible(True)## is needed ????????
        self.sicon.connect('activate', self.trayClicked)
        self.sicon.connect('popup-menu', self.trayPopup)
      else:
        self.sicon = trayicon.TrayIcon('test')
        image = gtk.Image()
        self.sicon.set_from_pixbuf = image.set_from_pixbuf
        try:
          self.sicon.is_embedded = self.sicon.get_embedded
        except AttributeError:#????????????????????????????
          self.sicon.is_embedded = lambda: True
        self.sicon.set_visible = lambda arg: None
        self.sicon.image = image
        ebox = gtk.EventBox()
        #ebox.set_visible_window(False)
        ########????????????????????????????????? iner border of button!
        #ebox = gtk.Button()
        #ebox.set_relief(gtk.RELIEF_NONE)
        #ebox.set_property('can-default', False)
        #style = ebox.get_style()
        #style = ebox.rc_get_style()
        #print dict(style)
        #for x in dir(style):
        #  print type(eval('style.%s'%x)), x
        #for x in style.props:
        #  print x
        #print len(style.props), dir(style.props)
        #print style.get_property('inner-border')
        #style.props.inner_border = 0
        #style.set_property('inner-border', 0)
        #ebox.set_style(style)
        #ebox.style_set_property('inner-border', 0)
        #print 'inner-border', ebox.style_get_property('inner-border')
        ##########
        hbox = gtk.HBox(spacing=2)
        hbox.set_direction(gtk.TEXT_DIR_LTR)
        hbox.pack_start(image, 0, 0)
        self.clockTr = None
        self.trayHbox = hbox
        self.updateTrayClock()
        ebox.add(hbox)
        ###########
        self.sicon.add(ebox)
        ebox.connect('button-press-event', self.trayEggButtonPress)
        self.sicon.show_all()
        ##########
        ## When "killall gnome-panel", the statusIcon destroys!!
        ## Events GDK_UNMAP, GDK_WINDOW_STATE, GDK_DELETE acures
        #self.sicon.connect('event', com.show_event)
        self.sicon.connect('delete-event', self.trayEggDeleted)
        #?????????
        #ebox.connect('expose-event', lambda obj, ev: self.clockTr.show_all())
        #ebox.window.set_composited(False)##??????? Error in Debian Etch
        #### ?????????????????????????????????????????????????????
        ## When desktop is composited, clock label (self.clockTr) will not be shown
    self.trayPix = gdk.Pixbuf(gdk.COLORSPACE_RGB, True, 8, com.traySize, com.traySize)
  def trayEggDeleted(self, wid, event): ##??????????
    self.trayMode = 3
    self.trayInit()
    self.trayUpdate(None, False)
  def trayEggButtonPress(self, widget, event):
    if event.type==gdk._2BUTTON_PRESS or event.type==gdk._3BUTTON_PRESS:
      return True
    #print event.button
    if event.button==1:
      self.trayClicked(widget)
    elif event.button==3:
      self.trayPopupEgg(widget, 3, event.time)
    elif event.button==2:## Middle Button
      self.copyDateToday()
    return True
  def trayPopupEgg(self, sicon, button, etime):#????????????????????? Position of Menu
    #self.menuTray1.popup(None, None, gtk.status_icon_position_menu, button, etime, self.sicon)
    #r = self.sicon.c; print r[0], r[1], r[2], r[3]
    #print self.sicon.window.get_geometry()
    (x0, y0) = self.sicon.window.get_origin()
    if com.trayEggPopupImageOnly:
      obj = self.sicon.image
    else:
      obj = self.sicon
    w = obj.allocation.width
    h = obj.allocation.height
    w2 = self.menuTray1.allocation.width
    h2 = self.menuTray1.allocation.height
    if y0+h+h2<com.screenH:
      menu = self.menuTray1
      y = y0 + h
    else:
      menu = self.menuTray2
      y = y0 - h2
    if com.rtl:
      if x0+w-w2>0:
        x = x0+w-w2
      else:
        x = x0
    else:
      if x0+w2<com.screenW:
        x = x0
      else:
        x = x0+w-w2
    #print (x0,y0), (w,h), (w2,h2), "\n", (x, y), "\n"
    com.focusTime = time.time() ## needed?????
    menu.popup(None, None, lambda widget: (x, y, True), button, etime)
    #menu.popup(None, None, None, button, etime)
  def trayPopup(self, sicon, button, etime):
    geo = self.sicon.get_geometry() ## Returns None on windows
    com.focusTime = time.time()  ## needed?????
    if geo==None:## on windows, why??????? ## taskbar is on buttom(below)
      self.menuTray2.popup(None, None, gtk.status_icon_position_menu, button, etime, self.sicon)
    else:
      y1 = geo[1][1]
      y = gtk.status_icon_position_menu(self.menuTray, self.sicon)[1]
      if y<y1:## taskbar is on buttom(below)
        self.menuTray2.popup(None, None, gtk.status_icon_position_menu, button, etime, self.sicon)
      else:## taskbar is on top
        self.menuTray1.popup(None, None, gtk.status_icon_position_menu, button, etime, self.sicon)
  def trayUpdate(self, gdate=None, check=True):
    if self.trayMode<2:
      return
    #print 'trayUpdate', self.lastGDate, gdate
    if gdate==None:
      gdate = time.localtime()[:3]
    if self.lastGDate!=gdate or not check:
      jd = cal.modules[cal.DATE_GREG].to_jd(*gdate)
      if com.primaryMode==cal.DATE_GREG:
        ddate = gdate
      else:
        ddate = cal.modules[com.primaryMode].jd_to(jd)
      print('Updating tray to date %s'%com.dateStr(*ddate))
      self.lastGDate = gdate
      self.todayCell = self.dialog.getDateCell(*ddate)
      if self.todayCell.holiday:
        pixbuf = gdk.pixbuf_new_from_file(com.trayImageHoli)
      else:
        pixbuf = gdk.pixbuf_new_from_file(com.trayImage)
      ##pixbuf.scale() #????????????
      ###################### PUTTING A TEXT ON A PIXBUF
      pmap = pixbuf.render_pixmap_and_mask(alpha_threshold=127)[0] ## pixmap is also a drawable
      textLay = self.dialog.create_pango_layout(numLocal(ddate[2]))
      if com.trayFont==None:
        if not com.fontUseDefault:
          textLay.set_font_description(pango.FontDescription(com.fontCustom))
      else:
        textLay.set_font_description(pango.FontDescription(com.trayFont))
      (w, h) = textLay.get_pixel_size()
      s = com.traySize
      if com.trayY0 == None:
        y = s/4+int((0.9*s-h)/2)
      else:
        y = com.trayY0
      pmap.draw_layout(pmap.new_gc(), (s-w)/2, y, textLay, com.trayTextColor)## , foreground, background)
      self.trayPix.get_from_drawable(pmap, self.dialog.get_screen().get_system_colormap(), 0, 0, 0, 0, s, s)
      ######################################
      self.sicon.set_from_pixbuf(self.trayPix)
      tt = com.getWeekDayN(cal.getWeekDay(ddate[0], ddate[1], ddate[2], com.primaryMode, com.firstWeekDay))
      #if com.extradayTray:##?????????
      #  sep = _(',')+' '
      #else:
      sep = '\n'
      for item in com.shownDates:
        if item['enable']:
          mode = item['mode']
          module = cal.modules[mode]
          (y, m, d) = self.todayCell.dates[mode]
          tt += '%s%s %s %s'%(sep, numLocal(d), _(module.getMonthName(m, y)), numLocal(y))
      if com.extradayTray:
        self.dialog.loadExtraDaysDB(False)
        text = self.todayCell.extraday
        if text!='':
          tt += '\n\n%s'%text.replace('\t', '\n') #????????????
      set_tooltip(self.sicon, tt)
    '''
    #print 'self.sicon.get_size()', self.sicon.get_size() ## why 200 initialy ??????
    geo = self.sicon.get_geometry() ## Returns None on windows
    if geo==None:## on windows, why???????
      self.menuTray = self.menuTray2 ## taskbar is on buttom(below)
    else:
      y1 = geo[1][1]
      y = gtk.status_icon_position_menu(self.menuTray, self.sicon)[1]
      #h = com.rootWindow.get_geometry()[3]
      #print h, y, y1
      if y<y1:
        self.menuTray = self.menuTray2
      else:
        self.menuTray = self.menuTray1
    '''
    return True
  def trayClicked(self, widget):
    #print 'self.sicon.get_size()', self.sicon.get_size() ## height of panel - 2
    if self.dialog.get_property('visible'):
      (com.winX, com.winY) = self.dialog.get_position()
      self.dialog.hide()
    else:
      self.dialog.move(com.winX, com.winY)
      ## every calling of .hide() and .present(), makes dialog not on top (forgets being on top)
      act = self.checkAbove.get_active()
      self.dialog.set_keep_above(act)
      self.dialog.lowerWin.set_keep_above(act)
      if self.checkSticky.get_active():
        self.dialog.stick()
        self.dialog.lowerWin.stick()
      self.dialog.deiconify()
      self.dialog.present()
  def dialogClose(self, widget=None, event=None):
    (com.winX, com.winY) = self.dialog.get_position()
    if self.trayMode==0:
      self.quit()
    elif self.trayMode>1:
      if self.sicon.is_embedded():
        self.dialog.hide()
      else:
        self.quit()
    return True
  def dialogEsc(self):
    (com.winX, com.winY) = self.dialog.get_position()
    if self.trayMode==0:
      self.quit()
    elif self.trayMode>1:
      if self.sicon.is_embedded():
        self.dialog.hide()
  def addStartup(self, path):
    text='''[Desktop Entry]
Type=Application
Name=StarCalendar
Icon=starcal
Exec="%s" --no-tray-check'''%sys.argv[0]##%COMMAND ## double quotes needed when the path has space
    try:
      os.makedirs(os.path.dirname(path))
    except:
      pass
    try:
      fp = file(path, 'w')
    except:
      com.myRaise(__file__)
      return False
    else:
      fp.write(text)
      return True
  def quit(self, widget=None, event=None):
    #try:#????????????????????????????????
    #  self.prefSave()
    #  print 'Preferences saved'
    #except:
    #  print 'Could not update and save preferences!'
    #  com.myRaise(__file__)
    ################
    if self.trayMode>1:
      self.sicon.set_visible(False) ## needed for windows ## before of after main_quit ?
    print 'Exiting...'
    gtk.main_quit()
  #################### Export to HTML ##################################
  def fcdComboChanged(self, widget=None, ym=None):
    i = self.fcd.combo.get_active()
    if ym==None:
      ym = (self.dialog.year, self.dialog.month)
    if i==0:
      self.fcd.fcw.set_current_name('calendar-%.4d-%.2d.html'%ym)
      self.fcd.hbox2.hide()
    elif i==1:
      self.fcd.fcw.set_current_name('calendar-%.4d.html'%ym[0])
      self.fcd.hbox2.hide()
    else:#elif i==2
      self.fcd.fcw.set_current_name('calendar.html')
      self.fcd.hbox2.show()
    ## select_region(0, -4) #????????????
  def fcdHide(self, widget=None, event=None):## hide(close) File Chooser Dialog
    self.fcd.hide()
    return True
  def fcdSave(self, widget=None):
    self.fcd.window.set_cursor(gdk.Cursor(gdk.WATCH))
    while gtk.events_pending():
      gtk.main_iteration_do(False)
    path = self.fcd.fcw.get_filename()
    if path in (None, ''):
      return
    print 'Exporting to html file "%s"'%path
    i = self.fcd.combo.get_active()
    months = []
    module = cal.modules[com.primaryMode]
    if i==0:
      s = self.dialog.computeCurrentMonth()
      months = [s]
      title = '%s %s'%(_(module.getMonthName(s.month, s.year)), numLocal(s.year))
    elif i==1:
      for i in xrange(1, 13):
        months.append(self.dialog.buildStatus(self.dialog.year, i, False))
      title = '%s %s'%(_('Calendar'), numLocal(self.dialog.year))
    elif i==2:
      (y0, m0) = self.fcd.ymBox0.get_date()
      (y1, m1) = self.fcd.ymBox1.get_date()
      for ym in xrange(y0*12+m0-1, y1*12+m1):
        (y, m) = divmod(ym, 12)
        m += 1
        months.append(self.dialog.buildStatus(y, m, False))
      title = _('Calendar')
    self.exportHtml(path, months, title)
    self.fcd.window.set_cursor(gdk.Cursor(gdk.LEFT_PTR))
    self.fcd.hide()
  def exportClicked(self, widget=None):
    ym = (self.dialog.year, self.dialog.month)
    self.fcdComboChanged(ym=ym)
    self.fcd.ymBox0.set_date(ym)
    self.fcd.ymBox1.set_date(ym)
    self.fcd.resize(1, 1)
    self.fcd.present()
  def exportClickedTray(self, widget=None, event=None):
    ym = getSysDate()[:2]
    self.fcdComboChanged(ym=ym)
    self.fcd.ymBox0.set_date(ym)
    self.fcd.ymBox1.set_date(ym)
    self.fcd.resize(1,1)
    self.fcd.present()
  def exportHtml(self, fpath, monthsStatus, title=''):
    #if monthsStatus==[]:
    #  monthsStatus = [self.dialog.computeCurrentMonth()]
    ##################### Options:
    format = ((2, 'SUB'), (0, None), (1, 'SUB')) ## (dateMode, htmlTag)
    sizeMap = lambda size: size*0.25 - 0.5
    sep = ' '
    extraSep = ' <B>ـ</B> '
    extraPerLine = False
    #####################
    dates = com.shownDates
    #####################
    bc = com.bgColor
    ####
    c = com.inactiveColor
    a = com.inactiveColorAlpha/65535.0
    grayColor = com.rgbToHtml(	a * c.red +  (1-a) * bc.red,
    				a * c.green +(1-a) * bc.green,
    				a * c.blue + (1-a) * bc.blue)
    ####
    c = com.borderColor
    a = com.borderColorAlpha/65535.0
    borderColor= com.rgbToHtml(	a * c.red +  (1-a) * bc.red,
    				a * c.green +(1-a) * bc.green,
    				a * c.blue + (1-a) * bc.blue)
    #del bc, c, a
    #####################
    borderTextColor = gdkColorToHtml(com.borderTextColor)
    holidayColor = gdkColorToHtml(com.holidayColor)
    colors = [gdkColorToHtml(x['color']) for x in dates]
    if com.rtl:
      DIR = 'RTL'
    else:
      DIR = 'LRT'
    if com.lang==2:
      LANG = 'fa-IR'
    elif com.lang==3:
      LANG = 'ar'#??????????? ar-??
    else:
      LANG = 'en-US'
    text = '''<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
  <META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
  <TITLE>%s</TITLE>
</HEAD>
<BODY LANG="%s" DIR="%s" BGCOLOR="%s">\n'''%(title, LANG, DIR, gdkColorToHtml(com.bgColor))
    for status in monthsStatus:
      mDesc = self.dialog.getMonthDesc(status).split('\n')
      text+='<P>'
      for i in xrange(len(dates)):
        if dates[i]['enable']:
          text+='<FONT COLOR="%s">%s</FONT>\n<BR>\n'%(colors[i], mDesc[i])
      text+='</P>\n'
      text+='<TABLE WIDTH=100%% BGCOLOR="%s" BORDER=%s BORDERCOLOR="#000000" CELLPADDING=4 CELLSPACING=0>\n  <TR VALIGN=TOP>\n'\
        %(gdkColorToHtml(com.bgColor),int(com.calGrid))
      text+='    <TD WIDTH=9%% BGCOLOR="%s"><P ALIGN=CENTER></P></TD>\n'## what text????????
      for j in xrange(7):
        text+='    <TD WIDTH=13%% BGCOLOR="%s"><P ALIGN=CENTER><FONT COLOR="%s"><B>%s</B></FONT></P></TD>\n'\
          %(borderColor,borderTextColor,com.getWeekDayN(j))
      text += '    </TD>'
      extra = '\n<P><FONT COLOR="%s">\n'%colors[0]
      for i in xrange(6):
        text += '  <TR VALIGN=TOP>\n  <TD WIDTH=9%% BGCOLOR="%s"><P ALIGN=CENTER><FONT COLOR="%s"><B>%s</B></FONT></P></TD>'\
          %(borderColor, borderTextColor, com.numLocal(status.weekNum[i]))
        for j in xrange(7):
          cell = status[i][j]
          text += '  <TD WIDTH=13%><P DIR="LTR" ALIGN=CENTER>'
          for (ind, tag) in format:
            if not dates[ind]['enable']:
              continue
            mode = dates[ind]['mode']
            day = numLocal(cell.dates[mode][2], mode+1, 2)
            sp = dates[ind]['font'].split(' ')
            face = ' '.join(sp[:-1])
            size = str(sizeMap(int(sp[-1])))
            if cell.gray!=0:
              if ind==0:
                if tag!=None:
                  text += '<%s>'%tag
                text += '<FONT COLOR="%s" FACE="%s" SIZE="%s">%s</FONT>'%(grayColor, face, size, day)
                if tag!=None:
                  text += '</%s>'%tag
                break
              else:
                continue
            if tag!=None:
              text += '<%s>'%tag
            if ind==0 and cell.holiday:
              color = holidayColor
            else:
              color = colors[ind]
            text += '<FONT COLOR="%s" FACE="%s" SIZE="%s">%s</FONT>'%(color, face, size, day)
            if tag!=None:
              text += '</%s>'%tag
            text += sep
          text += '</P></TD>\n'
          if cell.gray==0 and com.extradayEnable:
            if cell.holidayExtra:
              color = holidayColor
            else:
              color = colors[0]
            t = cell.extraday.replace('\n', extraSep)
            if t!='':
              extra+='<B><FONT COLOR="%s">%s</FONT>:</B>  <SMALL>%s</SMALL>'%(color,numLocal(cell.dates[com.primaryMode][2]), t)
              if extraPerLine:
                extra+='<BR>\n'
              else:
                extra+='\t '
        text += '  </TR>\n'
      extra += '</FONT></P>\n'
      text+='</TABLE>\n%s\n<P STYLE="border-bottom: 5pt double %s"></P>\n'%(extra, colors[0])
    text+='''<P><FONT COLOR="%s">
%s <A HREF="%s">StarCalendar</A> %s %s
</FONT></P>
</BODY>
</HTML>'''%(colors[0], _('Generated by'), homePage, _('version'),VERSION)
    file(fpath, 'w').write(text)

  ## ??????????????????????????
  def exportSvg(self, path, monthList):## monthList is a list of tuples (year, month)
    import cairo
    hspace = 20
    (x, y, w, h0) = self.dialog.cal.allocation
    n = len(monthsStatus)
    h = n*h0 + (n-1)*hspace
    fo = file(path+'.svg', 'w')
    surface = cairo.SVGSurface(fo, w, h)
    cr0 = cairo.Context(surface)
    cr = gtk.gdk.CairoContext(cr0)
    year = self.dialog.year
    month = self.dialog.month
    day = self.dialog.day
    self.dialog.show_all()
    for i in range(n):
      surface.set_device_offset(0, i*(h0+hspace))
      self.dialog.dateChange((monthList[i][0], monthList[i][1], 1))
      self.dialog.updateCalAll(cr=cr, cursor=False)
      self.cal.queue_draw()
    self.dialog.dateChange((year, month, day))
    surface.finish()
  def adjustTime(self, widget=None, event=None):
    os.popen2(com.adjustTimeCmd)






#gobject.type_register(StarCal)
#gobject.signal_new('main-show', StarCal, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [])
#gobject.signal_new('main-hide', StarCal, gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [])


if __name__ == '__main__':
    trayMode=2
    if len(sys.argv)>1:
      if sys.argv[1]=='--no-tray': ## to tray icon
        scal = StarCal(trayMode=0)
        show = True
      else:
        scal = StarCal(trayMode=3)
        if sys.argv[1]=='--hide':
          show=False
        elif sys.argv[1]=='--show':
          show=True
        elif sys.argv[1]=='--no-tray-check':
          show = scal.showMain
        #elif sys.argv[1]=='--html':#????????????
        #  scal.exportHtml('calendar.html') ## exportHtml(path, months, title)
        #  sys.exit(0)
        else:
          while gtk.events_pending():## if do not this, scal.sicon.is_embedded returns False
            gtk.main_iteration_do(False)
          show = scal.showMain or not scal.sicon.is_embedded() ##com.showMain
    else:
      scal = StarCal(trayMode=3)
      while gtk.events_pending():## if do not this, scal.sicon.is_embedded returns False
        gtk.main_iteration_do(False)
      show = scal.showMain or not scal.sicon.is_embedded() ##com.showMain
    #print 'show =', show
    if show:
      scal.dialog.present()
    ##com.rootWindow.set_cursor(gdk.Cursor(gdk.LEFT_PTR))#???????????
    """if not com.prefExist or com.prefVersion!=VERSION:
      scal.prefShow()
      n1 = len(com.plugIndex)
      n2 = len(com.plugIndexOrig)
      if n1 < n2:#???????????????
        scal.notebook.set_current_page(2) ## Switch to tab "Manage Plugin"
        scal.plugAddDialog.run()
        #for i in xrange(n1, n2):
        #  com.plugIndex.append(com.plugIndexOrig[i])"""
    #del com.plugIndexOrig
    sys.exit(gtk.main())


